<div align="center"><img src="deps/ijulialogo.png" alt="IJulia logo" width="150"/></div>

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaLang.github.io/IJulia.jl/stable)
[![](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaLang.github.io/IJulia.jl/dev)
[![Run tests](https://github.com/JuliaLang/IJulia.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/JuliaLang/IJulia.jl/actions/workflows/CI.yml)

# IJulia

**IJulia** is a [Julia-language](http://julialang.org/) backend
combined with the [Jupyter](http://jupyter.org/) interactive
environment (also used by [IPython](http://ipython.org/)).  This
combination allows you to interact with the Julia language using
Jupyter/IPython's powerful [graphical
notebook](http://ipython.org/notebook.html), which combines code,
formatted text, math, and multimedia in a single document.
IJulia is a Jupyter language kernel and works with a variety of notebook
user interfaces. In addition to the classic Jupyter Notebook, IJulia
also works with [JupyterLab](https://jupyterlab.readthedocs.io/en/stable/), a Jupyter-based
integrated development environment for notebooks and code.
The [nteract notebook desktop](https://nteract.io/) supports IJulia with
detailed instructions for its [installation with nteract](https://nteract.io/kernels/julia).

(IJulia notebooks can also be re-used in other Julia code via
the [NBInclude](https://github.com/stevengj/NBInclude.jl) package.)

## Quick start

Install IJulia from the Julia REPL by pressing `]` to enter pkg mode and entering:

```
add IJulia
```

If you already have Python/Jupyter installed on your machine, this process will also install a
[kernel specification](https://jupyter-client.readthedocs.io/en/latest/kernels.html#kernelspecs)
that tells Jupyter how to launch Julia. You can then launch the notebook server the usual
way by running `jupyter notebook` in the terminal.

Note that `IJulia` should generally be installed in Julia's global package environment, unless you
install a custom kernel that specifies a particular environment.

Alternatively, you can have IJulia create and manage its own Python/Jupyter installation.
To do this, type the following in Julia, at the `julia>` prompt:

```julia
using IJulia
notebook()
```

to launch the IJulia notebook in your browser.
The first time you run `notebook()`, it will prompt you
for whether it should install Jupyter.  Hit enter to
have it use the [Conda.jl](https://github.com/Luthaf/Conda.jl)
package to install a minimal Python+Jupyter distribution (via
[Miniconda](https://www.anaconda.com/docs/getting-started/miniconda/install#quickstart-install-instructions)) that is
private to Julia (not in your `PATH`).

For more advanced installation options, such as specifying a specific Jupyter
installation to use, see the [documentation](https://JuliaLang.github.io/IJulia.jl/stable).

function hmac(s1, s2, s3, s4, kernel)
    if !isassigned(kernel.sha_ctx)
        return ""
    else
        hmac = SHA.HMAC_CTX(copy(kernel.sha_ctx[]), kernel.hmac_key)
        for s in (s1, s2, s3, s4)
            GC.@preserve s SHA.update!(hmac, unsafe_wrap(Vector{UInt8}, s))
        end

        digest = SHA.digest!(hmac)
        return bytes2hex(digest)
    end
end

# Handlers for execute_request and related messages, which are
# the core of the Jupyter protocol: execution of Julia code and
# returning results.

import Base.Libc: flush_cstdio

import REPL: helpmode


# Pkg is a rather heavy dependency so we go to some effort to load it lazily
const Pkg_pkgid = Base.PkgId(Base.UUID("44cfe95a-1eb2-52ea-b672-e2afdf69b78f"), "Pkg")

function load_Pkg()
    if !haskey(Base.loaded_modules, Pkg_pkgid)
        @eval import Pkg
    end
end

function _do_pkg_cmd(cmd::AbstractString)
    Pkg = Base.loaded_modules[Pkg_pkgid]

    @static if VERSION < v"1.11"
        Pkg.REPLMode.do_cmd(IJulia._default_kernel.minirepl::MiniREPL, cmd; do_rethrow=true)
    else # Pkg.jl#3777
        Pkg.REPLMode.do_cmds(cmd, stdout)
    end
end

function do_pkg_cmd(cmd::AbstractString)
    load_Pkg()
    @invokelatest _do_pkg_cmd(cmd)
end

# Helper function to check if `code` is a valid special mode command. If it is,
# then comment lines will be stripped. If it isn't, then the original `code`
# will be returned.
function special_mode_strip(code::String)
    # Exit early if there are no comment or special mode characters at all
    if !contains(code, r"#|;|\]|\?")
        return code
    end

    # Loop over the string and look for lines that aren't comments and aren't
    # all whitespace.
    uncommented_line = ""
    has_special_mode = false
    for line in eachline(IOBuffer(code))
        if isempty(line) || all(isspace, line)
            continue
        end

        first_char = strip(line)[1]
        if first_char != '#'
            # If we've already found an uncommented line then bail out. We only
            # support special modes with one line of commands.
            if !isempty(uncommented_line)
                return code
            end

            uncommented_line = line
            has_special_mode = first_char ∈ (';', ']', '?')
        end
    end

    if isempty(uncommented_line)
        # If there are no uncommented lines then return the original code
        code
    elseif has_special_mode
        # If there's one and it is a special mode return just that line
        uncommented_line
    else
        # Otherwise return the original code
        code
    end
end

"""
    execute_request(socket, kernel, msg)

Handle a [execute
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#execute).
This will execute Julia code, along with Pkg and shell commands.
"""
function execute_request(socket, kernel, msg)
    code = msg.content["code"]::String
    @vprintln("EXECUTING ", code)
    kernel.execute_msg = msg
    kernel.stdio_bytes = 0
    silent = msg.content["silent"]::Bool
    store_history = get(msg.content, "store_history", !silent)::Bool
    empty!(kernel.execute_payloads)

    if !silent
        kernel.n += 1
        send_ipython(kernel.publish[], kernel,
                     msg_pub(msg, "execute_input",
                             Dict("execution_count" => kernel.n,
                                          "code" => code)))
    end

    silent = silent || REPL.ends_with_semicolon(code)
    if store_history
        kernel.In[kernel.n] = code
    end

    code = special_mode_strip(code)

    # "; ..." cells are interpreted as shell commands for run
    code = replace(code, r"^\s*;.*$" =>
                   m -> string(replace(m, r"^\s*;" => "Base.repl_cmd(`"),
                               "`, stdout)"))


    # "] ..." cells are interpreted as pkg shell commands
    if occursin(r"^\].*$", code)
        code = "IJulia.do_pkg_cmd(\"" * escape_string(strip(code[2:end])) * "\")"
    end

    # a cell beginning with "? ..." is interpreted as a help request
    hcode = replace(code, r"^\s*\?" => "")

    try
        foreach(invokelatest, IJulia._preexecute_hooks)

        kernel.ans = result = if hcode != code # help request
            Core.eval(Main, helpmode(hcode))
        else
            #run the code!
            occursin(magics_regex, code) && match(magics_regex, code).offset == 1 ? magics_help(code) :
                SOFTSCOPE[] ? include_string(REPL.softscope, kernel.current_module, code, "In[$(kernel.n)]") :
                include_string(kernel.current_module, code, "In[$(kernel.n)]")
        end

        if silent
            result = nothing
        elseif (result !== nothing) && (result !== kernel.Out)
            if store_history
                kernel.Out[kernel.n] = result
            end
        end

        maybe_launch_precompile(kernel)

        user_expressions = Dict()
        for (v::String, ex::String) in msg.content["user_expressions"]
            try
                value = include_string(kernel.current_module, ex)
                # Like the IPython reference implementation, we return
                # something that looks like a `display_data` but also has a
                # `status` field:
                # https://github.com/ipython/ipython/blob/master/IPython/core/interactiveshell.py#L2609-L2614
                user_expressions[v] = Dict("status" => "ok",
                                           "data" => display_dict(value),
                                           "metadata" => metadata(value))
            catch e
                # The format of user_expressions[v] is like `error` except that
                # it also has a `status` field:
                # https://jupyter-client.readthedocs.io/en/stable/messaging.html#execution-errors
                user_expressions[v] = Dict("status" => "error",
                                           error_content(e, catch_backtrace())...)
            end
        end

        foreach(invokelatest, IJulia._postexecute_hooks)

        # flush pending stdio
        flush_all()
        yield()
        if haskey(kernel.bufs, "stdout")
            send_stdout(kernel)
        end
        if haskey(kernel.bufs, "stderr")
            send_stderr(kernel)
        end

        undisplay(result, kernel) # dequeue if needed, since we display result in pyout
        @invokelatest flush_kernel_display(kernel) # flush pending display requests

        if result !== nothing
            result_metadata = invokelatest(metadata, result)
            result_data = invokelatest(display_dict, result)
            send_ipython(kernel.publish[], kernel,
                         msg_pub(msg, "execute_result",
                                 Dict("execution_count" => kernel.n,
                                      "metadata" => result_metadata,
                                      "data" => result_data)))

        end
        send_ipython(kernel.requests[], kernel,
                     msg_reply(msg, "execute_reply",
                               Dict("status" => "ok",
                                    "payload" => kernel.execute_payloads,
                                    "execution_count" => kernel.n,
                                    "user_expressions" => user_expressions)))
        empty!(kernel.execute_payloads)
    catch e
        bt = catch_backtrace()

        # Set the `err` variable like the REPL does, so users can call show(err) for full types
        errstack = scrub_backtrace(current_exceptions())
        if !Base.istrivialerror(errstack)
            setglobal!(Base.MainInclude, :err, errstack)
        end

        try
            # flush pending stdio
            flush_all()
            foreach(invokelatest, IJulia._posterror_hooks)
        catch
        end
        empty!(kernel.displayqueue) # discard pending display requests on an error
        content = error_content(e,bt)
        send_ipython(kernel.publish[], kernel, msg_pub(msg, "error", content))
        content["status"] = "error"
        content["execution_count"] = kernel.n
        send_ipython(kernel.requests[], kernel, msg_reply(msg, "execute_reply", content))
    end
end

# This extension implements a Comm and CommManager for the comm package:
# https://github.com/ipython/comm
#
# comm is by ipywidgets and is designed to be extended, so by implementing the
# interfaces it specifies we can get full support for ipywidgets and all other
# libraries that use ipywidgets (like matplotlib/ipympl).

module IJuliaPythonCallExt

import IJulia
using PythonCall
import PrecompileTools: @compile_workload

# `_repr_mimebundle_()` is a standard in the IPython ecosystem for returning all
# the MIME's an object supports at once.
function IJulia.display_dict(x::Py)
    if hasproperty(x, :_repr_mimebundle_) && !pyis(x._repr_mimebundle_, pybuiltins.None)
        recursive_pyconvert(x._repr_mimebundle_())
    else
        IJulia._display_dict(x)
    end
end

# Passing `backtrace=false` when calling showerror() on a PyException will also
# block printing the Python stacktrace, which is confusing. In this situation we
# *only* want the Python stacktrace to be printed so we pass `backtrace=true`
# but give an empty vector as a backtrace so that the Julia backtrace is not
# printed twice.
IJulia.custom_showerror(io, e::PyException, _) = showerror(io, e, []; backtrace=true)

function recursive_pyconvert(x)
    x_type = pyconvert(String, pytype(x).__name__)

    if x_type == "dict"
        x = pyconvert(Dict{String, Any}, x)
        for key in copy(keys(x))
            if x[key] isa Py
                x[key] = recursive_pyconvert(x[key])
            elseif x[key] isa PythonCall.PyDict
                x[key] = recursive_pyconvert(x[key].py)
            end
        end
    elseif x_type == "str"
        x = pyconvert(String, x)
    end

    return x
end

function recursive_pydict(x)
    dict_py = pydict(x)
    for (key, value) in x
        if value isa Dict
            dict_py[key] = recursive_pydict(value)
        end
    end

    dict_py
end

function convert_buffers(buffers)
    if !(buffers isa Py)
        buffers
    elseif pyis(buffers, pybuiltins.None)
        Vector{UInt8}[]
    else
        jl_buffers = Vector{UInt8}[]
        for buf in buffers
            push!(jl_buffers, pyconvert(Vector{UInt8}, buf))
        end

        jl_buffers
    end
end

function arrays_to_pylist!(dict::Dict)
    for (key, value) in dict
        if value isa AbstractArray
            dict[key] = pylist(value)
        elseif value isa Dict
            arrays_to_pylist!(value)
        end
    end
end

function flush_pystdio()
    sys = pyimport("sys")
    sys.stdout.flush()
    sys.stderr.flush()
end

function pycomm_init(self; target_name="comm", data=nothing, metadata=nothing, buffers=nothing,
                     comm_id=IJulia.uuid4(), comm=nothing)
    try
        if target_name isa Py
            target_name = pyconvert(String, target_name)
        end
        if data isa Py
            data = recursive_pyconvert(data)
        end
        if metadata isa Py
            metadata = recursive_pyconvert(metadata)
        end
        if comm_id isa Py
            comm_id = pyconvert(String, comm_id)
        end
        buffers = convert_buffers(buffers)

        if isnothing(comm)
            comm = IJulia.Comm(target_name, comm_id, true; data, metadata, buffers)
        end
        self._comm = comm
        IJuliaPythonCallExt.pycomm_registry[comm_id] = self
    catch e
        @error "pycomm_init() failed" exception=(e, catch_backtrace())
    end

    return nothing
end

function pycomm_on_msg(self, callback)
    self._comm.on_msg = (msg) -> try
        @debug "Received msg $(msg)"

        # We need to convert Julia arrays to Python lists so that some widget
        # values can be set properly. e.g., IntRangeSlider.value is a Tuple
        # trait object (from traitlets) so it expects to be set with a tuple or
        # list, it won't work with a juliacall.ArrayValue.
        arrays_to_pylist!(msg.content)

        msg_dict = Dict("idents" => msg.idents,
                        "header" => msg.header,
                        "content" => msg.content,
                        "parent_header" => msg.parent_header,
                        "metadata" => msg.metadata,
                        "buffers" => msg.buffers
        )
        callback(msg_dict)
    catch e
        @error "pycomm_on_msg() callback failed" exception=(e, catch_backtrace())
    end
end

function pycomm_send(self; data=Dict(), metadata=Dict(), buffers=nothing)
    try
        if data isa Py
            data = recursive_pyconvert(data)
        end
        if metadata isa Py
            metadata = recursive_pyconvert(metadata)
        end
        buffers = convert_buffers(buffers)

        @debug "Sending $(data) with buffers $(length.(buffers))"

        comm = IJulia._default_kernel.comms[pyconvert(String, self.comm_id)]
        IJulia.CommManager.send_comm(comm, data, metadata, buffers)
    catch e
        @error "pycomm_send() failed" exception=(e, catch_backtrace())
    end
end

# This method is needed by ipywidgets. Unlike Julia, Python allows mixing
# keyword and positional arguments so we need to have overloads for all the
# calls with different numbers of positional arguments.
pycomm_send(self, data; buffers=nothing) = pycomm_send(self; data, buffers)

function pycomm_close(self)
    try
        if !isnothing(IJulia._default_kernel)
            comm = IJulia._default_kernel.comms[pyconvert(String, self.comm_id)]
            IJulia.CommManager.close_comm(comm)
            delete!(IJuliaPythonCallExt.pycomm_registry, comm.id)
        end
    catch e
        @error "pycomm_close() failed" exception=(e, catch_backtrace())
    end
end

function py_notimplemented(func_name, args...; kwargs...)
    @error "$(func_name) has not been implemented"
end

pycomm_notimplemented(func_name::String) = pyfunc(Base.Fix1(py_notimplemented, "PyComm.$(func_name)"); name=func_name)
pycommmanager_notimplemented(func_name::String) = pyfunc(Base.Fix1(py_notimplemented, "PyCommManager.$(func_name)"); name=func_name)

PyComm::Union{Py, Nothing} = nothing
PyCommManager::Union{Py, Nothing} = nothing

const pycomm_registry = Dict{String, Py}()

function manager_register_target(self, target_name, callback)
    try
        if callback isa String
            @error "String callbacks are not supported by register_target()"
            return
        end

        target_name = pyconvert(String, target_name)
        comm_sym = Symbol(target_name)
        self.on_open_callbacks[comm_sym] = callback

        if @ccall(jl_generating_output()::Cint) == 0
            # Only create the method if we aren't precompiling
            @eval function IJulia.CommManager.register_comm(comm::IJulia.CommManager.Comm{$(QuoteNode(comm_sym))}, msg::IJulia.Msg)
                msg_dict = Dict("idents" => msg.idents,
                                "header" => msg.header,
                                "content" => msg.content,
                                "parent_header" => msg.parent_header,
                                "metadata" => msg.metadata,
                                "buffers" => msg.buffers)
                # We need to convert the Msg to a Python dict because that's
                # what the callbacks expect, and they may call `.get()` etc on
                # the dict.
                msg_dict_py = recursive_pydict(msg_dict)
                callback = IJuliaPythonCallExt.PyCommManager.on_open_callbacks[$(QuoteNode(comm_sym))]

                # Register a PyComm corresponding to the new `comm`
                if !haskey(IJuliaPythonCallExt.pycomm_registry, comm.id)
                    PyComm(; target_name=$(target_name), comm_id=comm.id, comm)
                end

                try
                    callback(IJuliaPythonCallExt.pycomm_registry[comm.id], msg_dict_py)
                catch ex
                    @error "PyCommManager.register_target() callback failed" exception=(ex, catch_backtrace())
                end
            end
        end
    catch e
        @error "PyCommManager.register_target() failed" exception=(e, catch_backtrace())
    end
end

function IJulia.init_ipython()
    # Some libraries like mpl-interactions call IPython.display() directly, so
    # we override it to call Julia's own display() function.
    ipython_display = pyimport("IPython.display")
    ipython_display.display = display

    nothing
end

function create_pycomm()
    pytype("PyComm", (), [
        "_comm" => nothing,
        "comm_id" => pyproperty(; get=self -> pystr(self._comm.id)),
        pyfunc(pycomm_init; name="__init__"),
        pycomm_notimplemented("publish_msg"),
        pycomm_notimplemented("open"),
        pyfunc(pycomm_close; name="close"),
        pyfunc(pycomm_send; name="send"),
        pycomm_notimplemented("on_close"),
        pyfunc(pycomm_on_msg; name="on_msg"),
        pycomm_notimplemented("handle_close"),
        pycomm_notimplemented("handle_msg")
    ])
end

function create_pycommmanager()
    pytype("PyCommManager", (), [
        "on_open_callbacks" => Dict{Symbol, Py}(),
        pyfunc(manager_register_target; name="register_target"),
        pycommmanager_notimplemented("unregister_target"),
        pycommmanager_notimplemented("register_comm"),
        pycommmanager_notimplemented("unregister_comm"),
        pycommmanager_notimplemented("get_comm"),
        pycommmanager_notimplemented("comm_open"),
        pycommmanager_notimplemented("comm_msg"),
        pycommmanager_notimplemented("comm_close"),
    ])
end

function IJulia.init_ipywidgets()
    global PyComm
    global PyCommManager

    IJulia.init_ipython()

    if isnothing(PyComm)
        PyComm = create_pycomm()
    end
    if isnothing(PyCommManager)
        PyCommManager = create_pycommmanager()
    end

    comm = pyimport("comm")
    ipywidgets = pyimport("ipywidgets")

    comm.get_comm_manager = () -> PyCommManager()
    comm.create_comm = PyComm
    ipywidgets.register_comm_target()

    nothing
end

function IJulia.init_matplotlib(backend::String="module://ipympl.backend_nbagg")
    IJulia.init_ipywidgets()

    # Make sure it's in interactive mode and it's using the backend
    mpl = pyimport("matplotlib")
    if backend == "widget" || backend == "ipympl" || contains(backend, "nbagg")
        mpl.rcParams["interactive"] = true
    end
    mpl.use(backend)

    # Set a hook to automatically display figures that were created without
    # having to return them from the cell.
    nbagg = pyimport("ipympl.backend_nbagg")
    IJulia.push_postexecute_hook(() -> nbagg.flush_figures())
    IJulia.push_posterror_hook(() -> nbagg.flush_figures())

    nothing
end

function __init__()
    push!(IJulia._flush_hooks, flush_pystdio)
end

precompile(manager_register_target, (Py, Py, Py))
precompile(IJulia.display_dict, (Py,))
precompile(convert_buffers, (Py,))
precompile(pycomm_init, (Py, Py, Py, Py, Py, Py))
precompile(pycomm_on_msg, (Py, Py))
precompile(pycomm_send, (Py, Py, Py, Py))
precompile(pycomm_close, (Py,))

@compile_workload begin
    create_pycomm()
    create_pycommmanager()
    flush_pystdio()

    recursive_pydict(Dict{String, Any}("foo" => 2, "bar" => Dict("baz" => "quux")))

    # If ipywidgets is installed in the environment try to precompile its
    # initializer. This is useful because the `ipywigets.register_comm_target()`
    # line is pretty heavy.
    try
        pyimport("ipywidgets")
        IJulia.init_ipywidgets()
    catch ex
        if !(ex isa PyException)
            @error "Ipywidgets precompilation failed" exception=(ex, catch_backtrace())
        end
    finally
        global PyComm = nothing
        global PyCommManager = nothing
        empty!(pycomm_registry)
    end
end

end

module CommManager

using IJulia

import IJulia: Msg, uuid4, send_ipython, msg_pub, Comm

export comm_target, msg_comm, send_comm, close_comm,
       register_comm, comm_msg, comm_open, comm_close, comm_info_request

# Global variable kept around for backwards compatibility
comms::Dict{String, CommManager.Comm} = Dict{String, CommManager.Comm}()

function Comm(target,
              id=uuid4(),
              primary=true,
              on_msg=Returns(nothing),
              on_close=Returns(nothing);
              kernel=IJulia._default_kernel,
              data=Dict(),
              metadata=Dict(),
              buffers=Vector{UInt8}[])
    comm = Comm{Symbol(target)}(id, primary, on_msg, on_close, kernel)
    if primary
        # Request a secondary object be created at the front end
        send_ipython(kernel.publish[], kernel,
                     msg_comm(comm, kernel.execute_msg, "comm_open",
                              data, metadata; target_name=string(target), buffers))
    end
    return comm
end

comm_target(comm :: Comm{target}) where {target} = target::Symbol

function comm_info_request(sock, kernel, msg)
    reply = if haskey(msg.content, "target_name")
        t = Symbol(msg.content["target_name"]::String)
        filter(kv -> comm_target(kv.second) == t, kernel.comms)
    else
        # reply with all comms.
        kernel.comms
    end

    _comms = Dict{String, Dict{Symbol,Symbol}}()
    for (comm_id,comm) in reply
        _comms[comm_id] = Dict(:target_name => comm_target(comm))
    end
    content = Dict(:comms => _comms)

    send_ipython(sock, kernel,
                 msg_reply(msg, "comm_info_reply", content))
end

function msg_comm(comm::Comm, m::IJulia.Msg, msg_type,
                  data=Dict{String,Any}(),
                  metadata=Dict{String, Any}(),
                  buffers=Vector{UInt8}[]; kwargs...)
    content = Dict("comm_id"=>comm.id, "data"=>data)

    for (k, v) in kwargs
        content[string(k)] = v
    end

    return msg_pub(m, msg_type, content, metadata, buffers)
end

function send_comm(comm::Comm, data::Dict,
                   metadata::Dict = Dict(), buffers=Vector{UInt8}[]; kernel=IJulia._default_kernel, kwargs...)
    msg = msg_comm(comm, kernel.execute_msg, "comm_msg", data,
                   metadata, buffers; kwargs...)
    send_ipython(kernel.publish[], kernel, msg)
end

function close_comm(comm::Comm, data::Dict = Dict(),
                    metadata::Dict = Dict(); kernel=IJulia._default_kernel, kwargs...)
    msg = msg_comm(comm, kernel.execute_msg, "comm_close", data,
                   metadata; kwargs...)
    send_ipython(kernel.publish[], kernel, msg)
end

function register_comm(comm::Comm, data)
    # no-op, widgets must override for their targets.
    # Method dispatch on Comm{t} serves
    # the purpose of register_target in IPEP 21.
end

# handlers for incoming comm_* messages

function comm_open(sock, kernel, msg)
    if haskey(msg.content, "comm_id")
        comm_id = msg.content["comm_id"]::String
        if haskey(msg.content, "target_name")
            target = msg.content["target_name"]::String
            if !haskey(msg.content, "data")
                msg.content["data"] = Dict()
            end
            comm = Comm(target, comm_id, false; kernel)
            invokelatest(register_comm, comm, msg)
            kernel.comms[comm_id] = comm
        else
            # Tear down comm to maintain consistency
            # if a target_name is not present
            send_ipython(kernel.publish[], kernel,
                         msg_comm(Comm(:notarget, comm_id, false; kernel),
                                  msg, "comm_close"))
        end
    end

    nothing
end

function comm_msg(sock, kernel, msg)
    if haskey(msg.content, "comm_id")
        comm_id = msg.content["comm_id"]::String
        if haskey(kernel.comms, comm_id)
            comm = kernel.comms[comm_id]
        else
            # We don't have that comm open
            return
        end

        if !haskey(msg.content, "data")
            msg.content["data"] = Dict()
        end
        comm.on_msg(msg)
    end

    nothing
end

function comm_close(sock, kernel, msg)
    if haskey(msg.content, "comm_id")
        comm_id = msg.content["comm_id"]::String
        comm = kernel.comms[comm_id]

        if !haskey(msg.content, "data")
            msg.content["data"] = Dict()
        end
        comm.on_close(msg)

        delete!(kernel.comms, comm.id)
    end

    nothing
end

end # module

using Test
using Base64

import IJulia
import IJulia: JSONX, helpmode, error_content, docdict, get_token

@testset "errors" begin
    content = error_content(UndefVarError(:a), backtrace())
    @test "UndefVarError" == content["ename"]

    # Test that ANSI escape codes appear in the traceback for colored output
    @test occursin("\e[90m", join(content["traceback"], "\n"))
end

@testset "Inspection" begin
    @test get_token(" rand ", 4) == "rand"
    @test get_token("rand", 10) == "rand"

    @test haskey(docdict("import"), "text/plain")
    @test haskey(docdict("sum"), "text/plain")
end

struct FriendlyData
    name::AbstractString
end

@testset "Custom MIME types" begin
    friend = FriendlyData("world")

    FRIENDLY_MIME_TYPE = MIME"application/vnd.ijulia.friendly-text"
    FRIENDLY_MIME = FRIENDLY_MIME_TYPE()
    Base.Multimedia.istextmime(::FRIENDLY_MIME_TYPE) = true
    Base.show(io, ::FRIENDLY_MIME_TYPE, x::FriendlyData) = write(io, "Hello, $(x.name)!")
    IJulia.register_mime(FRIENDLY_MIME)

    BINARY_MIME_TYPE = MIME"application/vnd.ijulia.friendly-binary"
    BINARY_MIME = BINARY_MIME_TYPE()
    Base.Multimedia.istextmime(::BINARY_MIME_TYPE) = false
    Base.show(io, ::BINARY_MIME_TYPE, x::FriendlyData) = write(io, "Hello, $(x.name)!")
    IJulia.register_mime(BINARY_MIME)

    JSON_MIME_TYPE = MIME"application/vnd.ijulia.friendly-json"
    JSON_MIME = JSON_MIME_TYPE()
    Base.Multimedia.istextmime(::JSON_MIME_TYPE) = true
    Base.show(io, ::JSON_MIME_TYPE, x::FriendlyData) = write(io, JSONX.json(Dict("name" => x.name)))
    IJulia.register_jsonmime(JSON_MIME)

    FRIENDLY_MIME_TYPE_1 = MIME"application/vnd.ijulia.friendly-text-1"
    FRIENDLY_MIME_TYPE_2 = MIME"application/vnd.ijulia.friendly-text-2"
    FRIENDLY_MIME_1 = FRIENDLY_MIME_TYPE_1()
    FRIENDLY_MIME_2 = FRIENDLY_MIME_TYPE_2()
    FRIENDLY_MIME_TYPE_UNION = Union{FRIENDLY_MIME_TYPE_1, FRIENDLY_MIME_TYPE_2}
    Base.Multimedia.istextmime(::FRIENDLY_MIME_TYPE_UNION) = true
    Base.show(io, ::FRIENDLY_MIME_TYPE_UNION, x::FriendlyData) = write(io, "Hello, $(x.name)!")
    IJulia.register_mime([FRIENDLY_MIME_1, FRIENDLY_MIME_2])

    # We stringify then re-parse the dict so that JSONText's are parsed as
    # actual JSON objects and we can index into them.
    data = JSONX.parse(JSONX.json(IJulia.display_dict(friend)))
    @test data[string(FRIENDLY_MIME)] == "Hello, world!"
    @test data[string(BINARY_MIME)] == base64encode("Hello, world!")
    @test data[string(JSON_MIME)]["name"] == "world"
    @test data[string(FRIENDLY_MIME_1)] == "Hello, world!"
    @test !haskey(data, string(FRIENDLY_MIME_2))

end

struct AngryData
    thing::AbstractString
end

@testset "Render 1st available MIME in MIME-vector." begin
    ANGRY_MIME_TYPE_1 = MIME"application/vnd.ijulia.angry-1"
    ANGRY_MIME_1 = ANGRY_MIME_TYPE_1()
    ANGRY_MIME_TYPE_2 = MIME"application/vnd.ijulia.angry-2"
    ANGRY_MIME_2 = ANGRY_MIME_TYPE_2()
    ANGRY_MIME_TYPE_3 = MIME"application/vnd.ijulia.angry-3"
    ANGRY_MIME_3 = ANGRY_MIME_TYPE_3()
    ANGRY_MIME_VECTOR = [ANGRY_MIME_1, ANGRY_MIME_2, ANGRY_MIME_3]

    Base.Multimedia.istextmime(::Union{ANGRY_MIME_TYPE_1, ANGRY_MIME_TYPE_2, ANGRY_MIME_TYPE_3}) = true
    Base.show(io, ::Union{ANGRY_MIME_TYPE_2, ANGRY_MIME_TYPE_3}, x::AngryData) = write(io, "I hate $(x.thing)!")
    IJulia.register_mime(ANGRY_MIME_VECTOR)

    broccoli = AngryData("broccoli")
    @test IJulia._showable(ANGRY_MIME_VECTOR, broccoli)
    @test !IJulia._showable(ANGRY_MIME_1, broccoli)

    data = IJulia.display_dict(broccoli)
    @test data[string(ANGRY_MIME_2)] == "I hate broccoli!"
    @test !haskey(data, ANGRY_MIME_1)
    @test !haskey(data, ANGRY_MIME_3)
end

@testset "Special REPL mode detection" begin
    code = "foo"
    @test IJulia.special_mode_strip(code) == code
    code = "foo # bar"
    @test IJulia.special_mode_strip(code) == code
    code = "# foo"
    @test IJulia.special_mode_strip(code) == code
    code = """
    # foo
    bar
    """
    @test IJulia.special_mode_strip(code) == code
    code = """
    foo
    ] st
    """
    @test IJulia.special_mode_strip(code) == code

    code = """
    # foo
    ] st
    """
    @test IJulia.special_mode_strip(code) == "] st"
    code = """
    # foo
    ] st
    ] st
    """
    @test IJulia.special_mode_strip(code) == code
    code = "? foo"
    @test IJulia.special_mode_strip(code) == code
    code = "; foo # bar"
    @test IJulia.special_mode_strip(code) == code
    code = """
     ? foo
    # foo
    """
    @test IJulia.special_mode_strip(code) == " ? foo"
    code = " ] st   "
    @test IJulia.special_mode_strip(code) == code
end

using Test
import IJulia: InlineIOContext

@testset "Custom Jupyter inline display" begin
    @eval struct TestDataType
        payload
    end

    function Base.show(io::IO, m::MIME"text/plain", data::TestDataType)
        print(io, "TestDataType: ")
        if get(io, :jupyter, false)
            print(io, "Jupyter: ")
        end
        Base.show(io, m, data.payload)
    end

    data = TestDataType("foo")
    buf = IOBuffer()

    Base.show(buf, MIME("text/plain"), data)
    @test String(take!(buf)) == "TestDataType: \"foo\""

    Base.show(InlineIOContext(buf), MIME("text/plain"), data)
    @test String(take!(buf)) == "TestDataType: Jupyter: \"foo\""
end

include("jsonx.jl")

function print_json_dict(io::IO, dict::AbstractDict)
    print(io, '{')
    first = true
    for (key, value) in pairs(dict)
        !first && print(io, ',')
        first = false

        println(io)
        print(io, "  ")

        JSONX.write_string(io, string(key))
        print(io, ':')
        JSONX.write_json(io, value)
    end
    println(io)
    print(io, '}')
end

#######################################################################
# Install Jupyter kernel-spec files.

copy_config(src::AbstractString, dest::AbstractString) = cp(src, joinpath(dest, basename(src)), force=true)

# return the user kernelspec directory, according to
#     https://jupyter-client.readthedocs.io/en/latest/kernels.html#kernelspecs
@static if Sys.iswindows()
    function appdata() # return %APPDATA%
        path = zeros(UInt16, 300)
        CSIDL_APPDATA = 0x001a
        result = ccall((:SHGetFolderPathW,:shell32), stdcall, Cint,
                       (Ptr{Cvoid},Cint,Ptr{Cvoid},Cint,Ptr{UInt16}),C_NULL,CSIDL_APPDATA,C_NULL,0,path)
        null_terminator_idx = findfirst(iszero, path)
        if isnothing(null_terminator_idx)
            error("Could not find null terminator from call to SHGetFolderPathW")
        end

        return result == 0 ? transcode(String, resize!(path, null_terminator_idx - 1)) : get(ENV, "APPDATA", "")
    end
    function default_jupyter_data_dir()
        APPDATA = appdata()
        return !isempty(APPDATA) ? joinpath(APPDATA, "jupyter") : joinpath(get(ENV, "JUPYTER_CONFIG_DIR", joinpath(homedir(), ".jupyter")), "data")
    end
    elseif Sys.isapple()
        function default_jupyter_data_dir()
        # Use the same logic as Jupyter's envset() for checking JUPYTER_PLATFORM_DIRS
            val = lowercase(get(ENV, "JUPYTER_PLATFORM_DIRS", "0"))
            if !(val in ("no", "n", "false", "off", "0", "0.0"))
                platformdir = joinpath(homedir(), "Library", "Application Support", "Jupyter")
                return platformdir
            end
        return joinpath(homedir(), "Library", "Jupyter")
    end
else
    function default_jupyter_data_dir()
        xdg_data_home = get(ENV, "XDG_DATA_HOME", "")
        data_home = !isempty(xdg_data_home) ? xdg_data_home : joinpath(homedir(), ".local", "share")
        joinpath(data_home, "jupyter")
    end
end

function jupyter_data_dir()
    env_data_dir = get(ENV, "JUPYTER_DATA_DIR", "")
    !isempty(env_data_dir) ? env_data_dir : default_jupyter_data_dir()
end

kerneldir() = joinpath(jupyter_data_dir(), "kernels")

# Since kernelspecs show up in URLs and other places, a kernelspec is required
# to have a simple name, only containing ASCII letters, ASCII numbers, and the
# simple separators: - hyphen, . period, _ underscore. According to
#       https://jupyter-client.readthedocs.io/en/stable/kernels.html
function kernelspec_name(name::AbstractString)
    debugdesc = ccall(:jl_is_debugbuild,Cint,())==1 ? "-debug" : ""
    name = replace(lowercase(name), " "=>"-")
    name = replace(name, r"[^0-9a-z_\-\.]" => s"_")
    return  name * "-$(VERSION.major).$(VERSION.minor)$debugdesc"
end

if Sys.iswindows()
    exe(s::AbstractString) = endswith(s, ".exe") ? s : "$s.exe"
    exe(s::AbstractString, e::AbstractString) =
        string(endswith(s, ".exe") ? s[1:end-4] : s, e, ".exe")
else
    exe(s::AbstractString) = s
    exe(s::AbstractString, e::AbstractString) = s * e
end

function display_name(name::AbstractString)
    debugdesc = ccall(:jl_is_debugbuild,Cint,())==1 ? "-debug" : ""
    return name * " $(VERSION.major).$(VERSION.minor)" * debugdesc
end

function julia_cmd(bindir=Sys.BINDIR)
    # bindir_components = splitpath(bindir)
    # juliaup_idx = findlast(==("juliaup"), bindir_components)

    # # Attempt to use juliaup if that's being used
    # if !isnothing(juliaup_idx) && get(ENV, "IJULIA_NO_JULIAUP", "0") == "0"
    #     julia_version = "$(VERSION.major).$(VERSION.minor)"
    #     cmd = `julia +$(julia_version)`

    #     # Try running the binary to see if the right channel is installed
    #     if success(`$(cmd) --version`)
    #         return cmd
    #     else
    #         error("""
    #               Juliaup has been detected but the command $(cmd) is not
    #               available. Ensure that the $(julia_version) channel is
    #               installed with `juliaup add 1.12` and try building IJulia
    #               again.

    #               If you want to use an absolute path to the Julia binary in the
    #               kernel defintion instead of using juliaup, set the
    #               `IJULIA_NO_JULIAUP` environment variable with
    #               `ENV["IJULIA_NO_JULIAUP"] = "1"` and try building IJulia
    #               again.
    #               """)
    #     end
    # end

    `$(joinpath(bindir, exe("julia")))`
end

"""
    installkernel(name::AbstractString, options::AbstractString...;
                  julia::Cmd,
                  specname::AbstractString,
                  displayname::AbstractString,
                  env=Dict())

Install a new Julia kernel, where the given `options` are passed to the `julia`
executable, the user-visible kernel name is given by `name` followed by the
Julia version, and the `env` dictionary is added to the environment.

The new kernel name is returned by `installkernel`.  For example:
```julia
kernelpath = installkernel("Julia O3", "-O3", env=Dict("FOO"=>"yes"))
```
creates a new Julia kernel in which `julia` is launched with the `-O3`
optimization flag and `FOO=yes` is included in the environment variables.

The `displayname` argument can be used to customize the name displayed in the
Jupyter kernel list.

The returned `kernelpath` is the path of the installed kernel directory,
something like `/...somepath.../kernels/julia-o3-1.6` (in Julia 1.6).  The
`specname` argument can be passed to alter the name of this directory (which
defaults to `name` with spaces replaced by hyphens, and special characters
other than `-` hyphen, `.` period and `_` underscore replaced by `_` underscores,
and the Julia major and minor version appended).

You can uninstall the kernel by calling `rm(kernelpath, recursive=true)`.

You can specify a custom command to execute Julia via keyword argument
`julia`. For example, you may want specify that the Julia kernel is running
in a Docker container (but Jupyter will run outside of it), by calling
`installkernel` from within such a container instance like this (or similar):

```julia
installkernel(
    "Julia via Docker",
    julia = `docker run --rm --net=host
        --volume=/home/USERNAME/.local/share/jupyter:/home/USERNAME/.local/share/jupyter
        some-container /opt/julia-1.x/bin/julia`
)
```
"""
function installkernel(name::AbstractString, julia_options::AbstractString...;
                       julia::Cmd = julia_cmd(),
                       specname::AbstractString = kernelspec_name(name),
                       displayname::AbstractString = display_name(name),
                       env::Dict{<:AbstractString}=Dict{String,Any}())
    if isnothing(match(r"^[a-zA-Z0-9._-]+$", specname))
        error("Invalid specname=$(repr(specname)): Must contain only ASCII letters, ASCII numbers, and the simple separators: - hyphen, . period, _ underscore")
    end

    # path of the Jupyter kernelspec directory to install
    juliakspec = joinpath(kerneldir(), specname)
    @info("Installing '$displayname' kernelspec in $juliakspec")
    rm(juliakspec, force=true, recursive=true)
    try
        kernelcmd_array = String[julia.exec..., "-i", "--color=yes"]
        append!(kernelcmd_array, julia_options)
        ijulia_dir = get(ENV, "IJULIA_DIR", dirname(@__DIR__)) # support non-Pkg IJulia installs
        append!(kernelcmd_array, ["-e", "import IJulia; IJulia.run_kernel()", "{connection_file}"])

        ks = Dict(
            "argv" => kernelcmd_array,
            "display_name" => displayname,
            "language" => "julia",
            "env" => env,
            # Jupyter's signal interrupt mode is not supported on Windows
            "interrupt_mode" => Sys.iswindows() ? "message" : "signal",
        )

        mkpath(juliakspec)

        open(joinpath(juliakspec, "kernel.json"), "w") do f
            print_json_dict(f, ks)
        end

        copy_config(joinpath(dirname(@__DIR__),"deps","logo-32x32.png"), juliakspec)
        copy_config(joinpath(dirname(@__DIR__),"deps","logo-64x64.png"), juliakspec)
        copy_config(joinpath(dirname(@__DIR__),"deps","logo-svg.svg"), juliakspec)

        return juliakspec
    catch
        rm(juliakspec, force=true, recursive=true)
        rethrow()
    end
end

# IJulia redirects stdout and stderr into "stream" messages sent to the
# Jupyter front-end.

"""
Wrapper type around redirected stdio streams, both for overloading things like
`flush` and so that we can set properties like `color`.
"""
struct IJuliaStdio{IO_t <: IO} <: Base.AbstractPipe
    io::IOContext{IO_t}
end
IJuliaStdio(io::IO, stream::AbstractString="unknown") =
    IJuliaStdio{typeof(io)}(IOContext(io, :color=>Base.have_color,
                            :jupyter_stream=>stream,
                            :displaysize=>displaysize()))
Base.pipe_reader(io::IJuliaStdio) = io.io.io
Base.pipe_writer(io::IJuliaStdio) = io.io.io
Base.lock(io::IJuliaStdio) = lock(io.io.io)
Base.unlock(io::IJuliaStdio) = unlock(io.io.io)
Base.in(key_value::Pair, io::IJuliaStdio) = in(key_value, io.io)
Base.haskey(io::IJuliaStdio, key) = haskey(io.io, key)
Base.getindex(io::IJuliaStdio, key) = getindex(io.io, key)
Base.get(io::IJuliaStdio, key, default) = get(io.io, key, default)
Base.displaysize(io::IJuliaStdio) = displaysize(io.io)
Base.unwrapcontext(io::IJuliaStdio) = Base.unwrapcontext(io.io)
Base.setup_stdio(io::IJuliaStdio, readable::Bool) = Base.setup_stdio(io.io.io, readable)

# logging in verbose mode goes to original stdio streams.  Use macros
# so that we do not even evaluate the arguments in no-verbose modes

using Printf
function get_log_preface()
    t = now()
    taskname = get(task_local_storage(), :IJulia_task, "")
    @sprintf("%02d:%02d:%02d(%s): ", Dates.hour(t),Dates.minute(t),Dates.second(t),taskname)
end

macro vprintln(x...)
    quote
        if _default_kernel.verbose
            println(orig_stdout[], get_log_preface(), $(map(esc, x)...))
        end
    end
end

macro verror_show(e, bt)
    quote
        if _default_kernel.verbose
            showerror(orig_stderr[], $(esc(e)), $(esc(bt)))
        end
    end
end

const stream_interval = 0.1
# maximum number of bytes in libuv/os buffer before emptying
const max_bytes = 10*1024

"""
    watch_stream(rd::IO, name::AbstractString)

Continually read from (size limited) Libuv/OS buffer into an `IObuffer` to avoid
problems when the Libuv/OS buffer gets full
(https://github.com/JuliaLang/julia/issues/8789). Send data immediately when
buffer contains more than `max_bytes` bytes. Otherwise, if data is available it
will be sent every `stream_interval` seconds (see the `flush_loop()`'s set up in
`watch_stdio`). Truncate the output to `max_output_per_request` bytes per
execution request since excessive output can bring browsers to a grinding halt.
"""
function watch_stream(rd::IO, name::AbstractString, kernel)
    task_local_storage(:IJulia_task, "read $name task")
    buf = kernel.bufs[name]
    buf_lock = kernel.bufs_locks[name]

    while isopen(rd)
        try
            while !eof(rd) # blocks until something is available
                nb = bytesavailable(rd)
                if nb > 0
                    kernel.stdio_bytes += nb
                    # if this stream has surpassed the maximum output limit then ignore future bytes
                    if kernel.stdio_bytes >= kernel.max_output_per_request[]
                        read(rd, nb) # read from libuv/os buffer and discard
                        if kernel.stdio_bytes - nb < kernel.max_output_per_request[]
                            send_ipython(kernel.publish[], kernel, msg_pub(kernel.execute_msg, "stream",
                                                                           Dict("name" => "stderr", "text" => "Excessive output truncated after $(kernel.stdio_bytes) bytes.")))
                        end
                    else
                        @lock buf_lock write(buf, read(rd, nb))
                    end
                end
                @lock buf_lock if buf.size > 0
                    if buf.size >= max_bytes
                        #send immediately
                        send_stream(name, kernel)
                    end
                end
            end
        catch e
            # the IPython manager may send us a SIGINT if the user
            # chooses to interrupt the kernel; don't crash on this
            if isa(e, InterruptException)
                @async Base.throwto(kernel.requests_task[], e)
            else
                rethrow()
            end
        end
    end
end

function send_stdio(name, kernel)
    if kernel.verbose && !haskey(task_local_storage(), :IJulia_task)
        task_local_storage(:IJulia_task, "send $name task")
    end
    send_stream(name, kernel)
end

send_stdout(kernel) = send_stdio("stdout", kernel)
send_stderr(kernel) = send_stdio("stderr", kernel)

"""
Jupyter associates cells with message headers. Once a cell's execution state has
been set as to idle, it will silently drop stream messages (i.e. output to
stdout and stderr) - see https://github.com/jupyter/notebook/issues/518.
When using Interact, and a widget's state changes, a new
message header is sent to the IJulia kernel, and while Reactive
is updating Signal graph state, it's execution state is busy, meaning Jupyter
will not drop stream messages if Interact can set the header message under which
the stream messages will be sent. Hence the need for this function.
"""
function set_cur_msg(msg, kernel)
    kernel.execute_msg = msg
end

function send_stream(name::AbstractString, kernel)
    buf = kernel.bufs[name]
    buf_lock = kernel.bufs_locks[name]

    @lock buf_lock if buf.size > 0
        d = take!(buf)
        n = num_utf8_trailing(d)
        dextra = d[end-(n-1):end]
        resize!(d, length(d) - n)
        s = String(copy(d))
        if isvalid(String, s)
            write(buf, dextra) # assume that the rest of the string will be written later
            length(d) == 0 && return
        else
            # fallback: base64-encode non-UTF8 binary data
            sbuf = IOBuffer()
            print(sbuf, "base64 binary data: ")
            b64 = Base64EncodePipe(sbuf)
            write(b64, d)
            write(b64, dextra)
            close(b64)
            print(sbuf, '\n')
            s = String(take!(sbuf))
        end
        send_ipython(kernel.publish[], kernel,
             msg_pub(kernel.execute_msg, "stream",
                     Dict("name" => name, "text" => s)))
    end
end

"""
If `d` ends with an incomplete UTF8-encoded character, return the number of trailing incomplete bytes.
Otherwise, return `0`.
"""
function num_utf8_trailing(d::Vector{UInt8})
    i = length(d)
    # find last non-continuation byte in d:
    while i >= 1 && ((d[i] & 0xc0) == 0x80)
        i -= 1
    end
    i < 1 && return 0
    c = d[i]
    # compute number of expected UTF-8 bytes starting at i:
    n = c <= 0x7f ? 1 : c < 0xe0 ? 2 : c < 0xf0 ? 3 : 4
    nend = length(d) + 1 - i # num bytes from i to end
    return nend == n ? 0 : nend
end

"""
    readprompt(prompt::AbstractString; password::Bool=false)

Display the `prompt` string, request user input,
and return the string entered by the user.  If `password`
is `true`, the user's input is not displayed during typing.
"""
function readprompt(prompt::AbstractString; kernel=_default_kernel, password::Bool=false)
    if !kernel.execute_msg.content["allow_stdin"]
        error("IJulia: this front-end does not implement stdin")
    end
    send_ipython(kernel.raw_input[], kernel,
                 msg_reply(kernel.execute_msg, "input_request",
                           Dict("prompt"=>prompt, "password"=>password)))
    while true
        msg = recv_ipython(kernel.raw_input[], kernel)
        if msg.header["msg_type"] == "input_reply"
            return msg.content["value"]
        else
            error("IJulia error: unknown stdin reply")
        end
    end
end

# override prompts using julia#28038 in 0.7
function check_prompt_streams(input::IJuliaStdio, output::IJuliaStdio)
    if get(input,:jupyter_stream,"unknown") != "stdin" ||
        get(output,:jupyter_stream,"unknown") != "stdout"
        throw(ArgumentError("prompt on IJulia stdio streams only works for stdin/stdout"))
        end
    end
function Base.prompt(input::IJuliaStdio, output::IJuliaStdio, message::AbstractString; default::AbstractString="")
    check_prompt_streams(input, output)
    val = chomp(readprompt(message * ": "))
    return isempty(val) ? default : val
end
function Base.getpass(input::IJuliaStdio, output::IJuliaStdio, message::AbstractString)
    check_prompt_streams(input, output)
    # fixme: should we do more to zero memory associated with the password?
    #        doing this properly might require working with the raw ZMQ message buffer here
    return Base.SecretBuffer!(Vector{UInt8}(codeunits(readprompt(message * ": ", password=true))))
end

# IJulia issue #42: there doesn't seem to be a good way to make a task
# that blocks until there is a read request from STDIN ... this makes
# it very hard to properly redirect all reads from STDIN to pyin messages.
# In the meantime, however, we can just hack it so that readline works:
import Base.readline
function readline(io::IJuliaStdio)
    if get(io,:jupyter_stream,"unknown") == "stdin"
        return readprompt("stdin> ")
    else
        readline(io.io)
    end
end

# This seems like the kind of thing that would be perfect for a Timer, but it's
# quite easy for an interrupt triggered by the user to kill the Timer task. So
# instead we have our own version that's robust against interrupts and correctly
# throws the exceptions to the right task.
function flush_loop(name::String, io::IO, kernel::Kernel, interval::Float64)
    while isopen(io)
        try
            sleep(interval)
            send_stdio(name, kernel)
        catch e
            if isa(e, InterruptException)
                @async Base.throwto(kernel.requests_task[], e)
            else
                @error "Exception in flush_loop()" exception=(e, catch_backtrace())
            end
        end
    end
end

function watch_stdio(kernel)
    task_local_storage(:IJulia_task, "init task")
    if kernel.capture_stdout
        kernel.bufs["stdout"] = IOBuffer()
        kernel.bufs_locks["stdout"] = ReentrantLock()

        kernel.watch_stdout_task[] = @async watch_stream(kernel.read_stdout[], "stdout", kernel)
        errormonitor(kernel.watch_stdout_task[])
        #send stdout stream msgs every stream_interval secs (if there is output to send)
        kernel.flush_stdout_task[] = @async flush_loop("stdout", kernel.read_stdout[], kernel, stream_interval)
    end
    if kernel.capture_stderr
        kernel.bufs["stderr"] = IOBuffer()
        kernel.bufs_locks["stderr"] = ReentrantLock()

        kernel.watch_stderr_task[] = @async watch_stream(kernel.read_stderr[], "stderr", kernel)
        errormonitor(kernel.watch_stderr_task[])
        #send STDERR stream msgs every stream_interval secs (if there is output to send)
        kernel.flush_stderr_task[] = @async flush_loop("stderr", kernel.read_stderr[], kernel, stream_interval)
    end
end

function flush_all()
    flush_cstdio() # flush writes to stdout/stderr by external C code
    flush(stdout)
    flush(stderr)
    for f in _flush_hooks
        @invokelatest f()
    end
end

function oslibuv_flush()
    #refs: https://github.com/JuliaLang/IJulia.jl/issues/347#issuecomment-144505862
    #      https://github.com/JuliaLang/IJulia.jl/issues/347#issuecomment-144605024
    @static if Sys.iswindows()
        ccall(:SwitchToThread, stdcall, Cvoid, ())
    end
    yield()
    yield()
end

function Base.flush(io::IJuliaStdio)
    flush(io.io)
    oslibuv_flush()
    send_stream(get(io,:jupyter_stream,"unknown"), IJulia._default_kernel)
end

# Code to launch and interact with Jupyter, not via messaging protocol
##################################################################

# Conda is a rather heavy dependency so we go to some effort to load it lazily
const Conda_pkgid = Base.PkgId(Base.UUID("8f4d0f93-b110-5947-807f-2305c1781a2d"), "Conda")

function get_Conda(f::Function)
    if !haskey(Base.loaded_modules, Conda_pkgid)
        @eval import Conda
    end

    @invokelatest f(Base.loaded_modules[Conda_pkgid])
end

isyes(s) = isempty(s) || lowercase(strip(s)) in ("y", "yes")

"""
    find_jupyter_subcommand(subcommand::AbstractString, port::Union{Nothing,Int}=nothing)

Return a `Cmd` for the program `subcommand`.
"""
function find_jupyter_subcommand(subcommand::AbstractString, port::Union{Nothing,Int}=nothing)
    jupyter = JUPYTER
    scriptdir = get_Conda() do Conda
        Conda.SCRIPTDIR
    end
    if jupyter == "jupyter" || jupyter == "jupyter.exe" # look in PATH
        jupyter = Sys.which(exe("jupyter"))
        if jupyter === nothing
            jupyter = joinpath(scriptdir, exe("jupyter"))
        end
    end
    isconda = dirname(jupyter) == abspath(scriptdir)
    port_flag = !isnothing(port) ? `--port=$(port)` : ``
    cmd = `$(jupyter) $(subcommand) $(port_flag)`

    # fails in Windows if jupyter directory is not in PATH (jupyter/jupyter_core#62)
    pathsep = Sys.iswindows() ? ';' : ':'
    withenv("PATH" => dirname(jupyter) * pathsep * get(ENV, "PATH", "")) do
        if isconda
            # sets PATH and other environment variables for Julia's Conda environment
            cmd = get_Conda() do Conda
                Conda._set_conda_env(cmd)
            end
        else
            setenv(cmd, ENV)
        end
    end

    return cmd
end

##################################################################

"""
    launch(cmd, dir, detached, verbose)

Run `cmd` in `dir`. If `detached` is `false` it will not wait for the command to
finish. If `verbose` is `true` then the stdout/stderr from the `cmd` process
will be echoed to stdout/stderr.
"""
function launch(cmd, args, dir, detached, verbose)
    cmd = `$cmd $args`
    @info("running $cmd")

    cmd = Cmd(cmd, detach=true, dir=dir)
    if verbose
        cmd = pipeline(cmd; stdout, stderr)
    end
    p = run(cmd; wait=false)

    if !detached
        try
            wait(p)
        catch e
            # SIGTERM will shutdown the server cleanly in a non-interactive
            # session. SIGINT will just raise an internal exception and not do
            # any cleanup if the session isn't interactive (i.e. no stdin or
            # TTY).
            kill(p)

            if isa(e, InterruptException)
                wait(p)
            else
                rethrow()
            end
        end
    end
    return p
end

function run_subcommand(name, package_name, port, args...)
    inited && error("IJulia is already running")
    subcmd = find_jupyter_subcommand(name, port)
    jupyter = first(subcmd)
    scriptdir = get_Conda() do Conda
        Conda.SCRIPTDIR
    end


    if dirname(jupyter) == abspath(scriptdir) && !Sys.isexecutable(exe(jupyter, "-$(name)"))
        if isyes(Base.prompt("install $(package_name) via Conda, y/n? [y]"))
            get_Conda() do Conda
                Conda.add(package_name)
            end
        else
            error("Cannot run $(package_name), it is not installed")
        end
    end
    return launch(subcmd, args...)
end

"""
    notebook(args=``; dir=homedir(), detached=false, port::Union{Nothing,Int}=nothing, verbose=false)

The `notebook()` function launches the Jupyter notebook, and is
equivalent to running `jupyter notebook` at the operating-system
command-line.    The advantage of launching the notebook from Julia
is that, depending on how Jupyter was installed, the user may not
know where to find the `jupyter` executable.

Extra arguments can be passed with the `args` argument,
e.g. ```notebook(`--help`; verbose=true)``` to see the command help. By default,
the notebook server is launched in the user's home directory, but this location
can be changed by passing the desired path in the `dir` keyword argument.
e.g. `notebook(dir=pwd())` to use the current directory.

By default, `notebook()` does not return; you must hit ctrl-c
or quit Julia to interrupt it, which halts Jupyter.  So, you
must leave the Julia terminal open for as long as you want to
run Jupyter.  Alternatively, if you run `notebook(detached=true)`,
the `jupyter notebook` will launch in the background, and will
continue running even after you quit Julia.  (The only way to
stop Jupyter will then be to kill it in your operating system's
process manager.)

When the optional keyword `port` is not `nothing`, open the notebook on the
given port number.

If `verbose=true` then the stdout/stderr from Jupyter will be echoed to the
terminal. Try enabling this if you're having problems connecting to a kernel to
see if there's any useful error messages from Jupyter.

For launching a JupyterLab instance, see [`IJulia.jupyterlab()`](@ref).
"""
function notebook(args=``; dir=homedir(), detached=false, port::Union{Nothing,Int}=nothing, verbose=false)
    run_subcommand("notebook", "jupyter", port, args, dir, detached, verbose)
end

"""
    jupyterlab(args=``; dir=homedir(), detached=false, port::Union{Nothing,Int}=nothing, verbose=false)

Similar to [`IJulia.notebook()`](@ref) but launches JupyterLab instead
of the Jupyter notebook.
"""
function jupyterlab(args=``; dir=homedir(), detached=false, port::Union{Nothing,Int}=nothing, verbose=false)
    run_subcommand("lab", "jupyterlab", port, args, dir, detached, verbose)
end

"""
    nbclassic(args=``; dir=homedir(), detached=false, port::Union{Nothing,Int}=nothing, verbose=false)

Similar to [`IJulia.notebook()`](@ref) but launches the v6
[nbclassic](https://nbclassic.readthedocs.io) notebook instead of the v7
notebook.
"""
function nbclassic(args=``; dir=homedir(), detached=false, port::Union{Nothing,Int}=nothing, verbose=false)
    run_subcommand("nbclassic", "nbclassic", port, args, dir, detached, verbose)
end

"""
    qtconsole()

Launches [qtconsole](https://qtconsole.readthedocs.io) for the current
kernel. IJulia must be initialized already.
"""
function qtconsole(kernel=_default_kernel)
    if isnothing(kernel)
        error("IJulia has not been started, cannot run qtconsole")
    end

    qtconsole = find_jupyter_subcommand("qtconsole")
    if inited
        run(`$qtconsole --existing $(kernel.connection_file)`; wait=false)
    else
        error("IJulia is not running. qtconsole must be called from an IJulia session.")
    end
end

using .CommManager

# Don't send previous lines to the completions function,
# due to issue #380.  Find the start of the first line
# (if any) where the expression is parseable.  Replace
# with find_parsestart(c,p) = start(c) once julia#9467 is merged.
parseok(s) = !Meta.isexpr(Meta.parse(s, raise=false), :error)
function find_parsestart(code, cursorpos)
    s = firstindex(code)
    while s < cursorpos
        parseok(code[s:cursorpos]) && return s
        s = nextind(code, s)
        while s < cursorpos && code[s] ∉ ('\n','\r')
            s = nextind(code, s)
        end
    end
    return firstindex(code) # failed to find parseable lines
end

# As described in jupyter/jupyter_client#259, Jupyter's cursor
# positions are actually measured in UTF-16 code units, not
# Unicode characters.  Hence, these functions are similar to
# Base.chr2ind and Base.ind2chr but count non-BMP characters
# as 2 code units.
function utf16_to_ind(str, ic)
    i = 0
    e = lastindex(str)
    while ic > 0 && i < e
        i = nextind(str, i)
        ic -= UInt32(str[i]) < 0x10000 ? 1 : 2
    end
    return i
end
function ind_to_utf16(str, i)
    ic = 0
    i = min(i, lastindex(str))
    while i > 0
        ic += UInt32(str[i]) < 0x10000 ? 1 : 2
        i = prevind(str, i)
    end
    return ic
end

# protocol change in Jupyter 5.2 (jupyter/jupyter_client#262)
chr2ind(m::Msg, str::String, ic::Integer) = ic == 0 ? 0 :
    VersionNumber(m.header["version"]) ≥ v"5.2" ? nextind(str, 0, ic) : utf16_to_ind(str, ic)
ind2chr(m::Msg, str::String, i::Integer) = i == 0 ? 0 :
    VersionNumber(m.header["version"]) ≥ v"5.2" ? length(str, 1, i) : ind_to_utf16(str, i)
#Compact display of types for Jupyterlab completion

import REPL: REPLCompletions
import REPL.REPLCompletions: sorted_keywords, emoji_symbols, latex_symbols

if isdefined(REPLCompletions, :named_completion)
    # julia#54800 (julia 1.12)
    repl_completion_text(c) = REPLCompletions.named_completion(c).completion::String
else
    # julia#26930
    repl_completion_text(c) = REPLCompletions.completion_text(c)
end

complete_type(::Type{<:Function}) = "function"
complete_type(::Type{<:Type}) = "type"
complete_type(::Type{<:Tuple}) = "tuple"
complete_type(::Any) = ""

function complete_type(T::DataType)
    s = string(T)
    (textwidth(s) ≤ 20 || isempty(T.parameters)) && return s
    buf = IOBuffer()
    print(buf, T.name)
    position(buf) > 19 && return String(take!(buf))
    print(buf, '{')
    comma = false
    for p in T.parameters
        s = string(p)
        if position(buf) + sizeof(s) > 20
            comma || print(buf, '…')
            break
        end
        comma && print(buf, ',')
        comma = true
        print(buf, s)
    end
    print(buf, '}')
    return String(take!(buf))
end

#Get typeMap for Jupyter completions
function complete_types(comps, kernel=_default_kernel)
    typeMap = []
    for c in comps
        ctype = ""
        if !isempty(searchsorted(sorted_keywords, c))
            ctype = "keyword"
        elseif startswith(c, "\\:")
            ctype = get(emoji_symbols, c, "")
            isempty(ctype) || (ctype = "emoji: $ctype")
        elseif startswith(c, "\\")
            ctype = get(latex_symbols, c, "")
        else
            expr = Meta.parse(c, raise=false)
            if typeof(expr) == Symbol
                try
                    ctype = complete_type(Core.eval(kernel.current_module, :(typeof($expr))))
                catch
                end
            elseif !isa(expr, Expr)
                ctype = complete_type(expr)
            elseif expr.head == :macrocall
                ctype = "macro"
            end
        end
        isempty(ctype) || push!(typeMap, Dict("text" => c, "type" => ctype))
    end
    return typeMap
end

"""
    complete_request(socket, kernel, msg)

Handle a [completion
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#completion).
"""
function complete_request(socket, kernel, msg)
    code = msg.content["code"]::String
    cursor_chr = msg.content["cursor_pos"]::Int64
    cursorpos = chr2ind(msg, code, cursor_chr)
    # Ensure that `cursorpos` is within bounds, Jupyter may send a position out
    # of bounds when autocompletion is enabled.
    cursorpos = min(cursorpos, lastindex(code))

    if all(isspace, code[1:cursorpos])
        send_ipython(kernel.requests[], kernel, msg_reply(msg, "complete_reply",
                                 Dict("status" => "ok",
                                              "metadata" => Dict(),
                                              "matches" => String[],
                                              "cursor_start" => cursor_chr,
                                              "cursor_end" => cursor_chr)))
        return
    end

    codestart = find_parsestart(code, cursorpos)
    comps_, positions, should_complete = REPLCompletions.completions(code[codestart:end], cursorpos-codestart+1, kernel.current_module)
    comps = unique!(repl_completion_text.(comps_))
    # positions = positions .+ (codestart - 1) on Julia 0.7
    positions = (first(positions) + codestart - 1):(last(positions) + codestart - 1)
    metadata = Dict()
    if isempty(comps)
        # issue #530: REPLCompletions returns inconsistent results
        # for positions when no completions are found
        cursor_start = cursor_end = cursor_chr
    elseif isempty(positions) # true if comps to be inserted without replacement
        cursor_start = (cursor_end = ind2chr(msg, code, last(positions)))
    else
        cursor_start = ind2chr(msg, code, prevind(code, first(positions)))
        cursor_end = ind2chr(msg, code, last(positions))
        if should_complete
            metadata["_jupyter_types_experimental"] = complete_types(comps, kernel)
        else
            # should_complete is false for cases where we only want to show
            # a list of possible completions but not complete, e.g. foo(\t
            pushfirst!(comps, code[positions])
        end
    end

    maybe_launch_precompile(kernel)

    send_ipython(kernel.requests[], kernel, msg_reply(msg, "complete_reply",
                                     Dict("status" => "ok",
                                                  "matches" => comps,
                                                  "metadata" => metadata,
                                                  "cursor_start" => cursor_start,
                                                  "cursor_end" => cursor_end)))
end

"""
    kernel_info_request(socket, kernel, msg)

Handle a [kernel info
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#kernel-info).
"""
function kernel_info_request(socket, kernel, msg)
    send_ipython(socket, kernel,
                 msg_reply(msg, "kernel_info_reply",
                           Dict("protocol_version" => "5.4",
                                "implementation" => "ijulia",
                                "implementation_version" => string(pkgversion(@__MODULE__)),
                                "language_info" =>
                                    Dict("name" => "julia",
                                         "version" =>
                                             string(VERSION.major, '.',
                                                    VERSION.minor, '.',
                                                    VERSION.patch),
                                         "mimetype" => "application/julia",
                                         "file_extension" => ".jl"),
                                "banner" => "Julia: A fresh approach to technical computing.",
                                "help_links" => [
                                    Dict("text"=>"Julia Home Page",
                                         "url"=>"http://julialang.org/"),
                                    Dict("text"=>"Julia Documentation",
                                         "url"=>"http://docs.julialang.org/"),
                                    Dict("text"=>"Julia Packages",
                                         "url"=>"https://juliahub.com/ui/Packages")
                                ],
                                "status" => "ok")))
end

"""
    connect_request(socket, kernel, msg)

Handle a [connect
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#connect).
"""
function connect_request(socket, kernel, msg)
    send_ipython(kernel.requests[], kernel,
                 msg_reply(msg, "connect_reply",
                           Dict("shell_port" => kernel.profile["shell_port"],
                                "iopub_port" => kernel.profile["iopub_port"],
                                "stdin_port" => kernel.profile["stdin_port"],
                                "hb_port" => kernel.profile["hb_port"])))
end

"""
    shutdown_request(socket, kernel, msg)

Handle a [shutdown
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#kernel-shutdown). After
sending the reply this will exit the process.
"""
function shutdown_request(socket, kernel, msg)
    send_ipython(kernel.control[], kernel,
                 msg_reply(msg, "shutdown_reply", msg.content))
    sleep(0.1) # short delay (like in ipykernel), to hopefully ensure shutdown_reply is sent

    kernel.shutdown(kernel)

    nothing
end

docdict(s::AbstractString) = display_dict(Core.eval(Main, helpmode(devnull, s)))

import Base: is_id_char, is_id_start_char

"""
    get_previous_token(code, pos, crossed_parentheses)

Given a string and a cursor position, find substring corresponding to previous token.
`crossed_parentheses:Int` keeps track of how many parentheses have been crossed.
A pair of parentheses yields 0 crossing; a '(' add 1; a ')' subtracts 1.

Returns `(startpos, endpos, crossed_parentheses, stop)`

- `startpos` is the start position of the closest potential token before `pos`.
- `endpos` is end position if said token is can be valid identifier, or `-1` otherwise
- `crossed_parentheses` is the new count for parentheses.
- `stop` is true if ';' is hit, denoting the beginning of a clause.
"""
function get_previous_token(code, pos, crossed_parentheses)
    startpos = pos
    separator = false
    stop = false
    while startpos > firstindex(code)
        c = code[startpos]
        if c == '('
            crossed_parentheses += 1
            separator = false
        elseif c == ')'
            crossed_parentheses -= 1
            separator = false
        elseif c == ';'
            stop = true
        elseif !is_id_char(c) && !isspace(c) && !separator
            separator = true
            crossed_parentheses = max(0, crossed_parentheses - 1)
        end
        if is_id_char(code[startpos])
            break
        else
            startpos = prevind(code, startpos)
        end
    end
    endpos = startpos
    while startpos >= firstindex(code) && (is_id_char(code[startpos]) || code[startpos] == '.')
        startpos = prevind(code, startpos)
    end
    startpos = startpos < pos ? nextind(code, startpos) : pos
    if !is_id_start_char(code[startpos])
        return startpos, -1, crossed_parentheses, stop
    end
    while endpos < lastindex(code) && is_id_char(code[endpos])
        endpos = nextind(code, endpos)
    end
    if !is_id_char(code[endpos])
        endpos = prevind(code, endpos)
    end
    return startpos, endpos, crossed_parentheses, stop
end

"""
    get_token(code, pos)

Given a string and a cursor position, find substring to request
help on by:

1. Searching backwards for the closest token (may be invalid)
2. Keep searching backwards until we find an token before an unbalanced '('
    a. If (1) is not valid, store the first valid token
    b. We assume a token before an unbalanced '(' is a function
3. If we find a possible function token, return this token.
4. Otherwise, return the last valid token

# Important Note

Tokens are chosen following several empirical observations instead of rigorous rules.
We assume that the first valid token before left-imbalanced (more '(' than ')') parentheses is the function "closest" to cursor.
The following examples use '|' to denote cursor, showing observations on parentheses.

- `f()|` has balanced parentheses with nothing within, thus `f` is the desired token.
- `f(|)` has imbalanced parentheses, thus `f` is the desired token.
- `f(x|, y)` gives tokens `x` and `f`. `x` has balanced parentheses, while `f` is left-imbalanced. `f` is desired.
- `f(x)|` returns `f`
- `f(x, y)|` returns `f`.
- `f((x|))` returns `f`, as expected
- `f(x, (|y))` returns `f`. **This is a hack**, as I deduct `crossed_parentheses` whenever a separator is encountered, clamped to 0!
    Otherwise, `x` would be returned.
- `f(x, (y|))`, `f(x, (y)|)`, and `f(x, (y))|` all behave as above. Arbitrary nesting of tuples should not cause misbehavior.
- `expr1 ; expr2`, cursor in `expr2` never causes search in `expr1`

TODO: detect operators? More robust parsing using the Julia parser instead of string hacks?
"""
function get_token(code, pos)
    # Keep cursor in code range
    pos = max(1, pos)
    pos = min(pos, lastindex(code))

    crossed_parentheses = 0
    prev_startpos, prev_endpos, crossed_parentheses, stop =
        get_previous_token(code, pos, crossed_parentheses)
    startpos = prev_startpos
    endpos = prev_endpos # Does not matter
    last_valid_start = startpos
    last_valid_end = -1
    while !stop && startpos > firstindex(code) && crossed_parentheses <= 0
        pos = prevind(code, startpos)
        startpos, endpos, crossed_parentheses, stop = get_previous_token(code, pos, crossed_parentheses)
        if endpos != -1 && last_valid_end == -1
            last_valid_start = startpos
            last_valid_end = endpos
        end
    end

    token = ""
    if crossed_parentheses > 0 # Potential function token
        if endpos != -1 # Function token valid
            token = code[startpos:endpos]
        elseif prev_endpos != -1 # Closest token valid
            token = code[prev_startpos:prev_endpos]
        elseif last_valid_end != -1 # Another, farther token valid
            token = code[last_valid_start:last_valid_end]
        end
    else # No function token found
        if prev_endpos != -1 # Closest token valid
            token = code[prev_startpos:prev_endpos]
        elseif last_valid_end != -1 # Another, farther token valid
            token = code[last_valid_start:last_valid_end]
        end
    end
    return token
end

"""
    inspect_request(socket, kernel, msg)

Handle a [introspection
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#introspection).
"""
function inspect_request(socket, kernel, msg)
    try
        code = msg.content["code"]::String
        cursor_pos = msg.content["cursor_pos"]::Int64
        s = get_token(code, chr2ind(msg, code, cursor_pos))
        if isempty(s)
            content = Dict("status" => "ok", "found" => false)
        else
            d = docdict(s)
            content = Dict("status" => "ok",
                           "found" => !isempty(d),
                           "data" => d,
                           "metadata" => Dict())
        end
        send_ipython(kernel.requests[], kernel, msg_reply(msg, "inspect_reply", content))
    catch e
        content = error_content(e, backtrace_top=:inspect_request);
        content["status"] = "error"
        send_ipython(kernel.requests[], kernel,
                     msg_reply(msg, "inspect_reply", content))
    end
end

"""
    history_request(socket, kernel, msg)

Handle a [history
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#history). This
is currently only a dummy implementation that doesn't actually do anything.
"""
function history_request(socket, kernel, msg)
    # we will just send back empty history for now, pending clarification
    # as requested in ipython/ipython#3806
    send_ipython(kernel.requests[], kernel,
                 msg_reply(msg, "history_reply",
                           Dict("history" => [])))
end

"""
    is_complete_request(socket, kernel, msg)

Handle a [completeness
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#code-completeness).
"""
function is_complete_request(socket, kernel, msg)
    ex = Meta.parse(msg.content["code"]::String, raise=false)
    status = Meta.isexpr(ex, :incomplete) ? "incomplete" : Meta.isexpr(ex, :error) ? "invalid" : "complete"
    send_ipython(kernel.requests[], kernel,
                 msg_reply(msg, "is_complete_reply",
                           Dict("status"=>status, "indent"=>"")))
end

"""
    interrupt_request(socket, kernel, msg)

Handle a [interrupt
request](https://jupyter-client.readthedocs.io/en/latest/messaging.html#kernel-interrupt). This
will throw an `InterruptException` to the currently executing request handler.
"""
function interrupt_request(socket, kernel, msg)
    @async Base.throwto(kernel.requests_task[], InterruptException())
    send_ipython(socket, kernel, msg_reply(msg, "interrupt_reply", Dict()))
end

function unknown_request(socket, kernel, msg)
    @vprintln("UNKNOWN MESSAGE TYPE $(msg.header["msg_type"])")
end

const handlers = Dict{String,Function}(
    "execute_request" => execute_request,
    "complete_request" => complete_request,
    "kernel_info_request" => kernel_info_request,
    "inspect_request" => inspect_request,
    "connect_request" => connect_request,
    "shutdown_request" => shutdown_request,
    "history_request" => history_request,
    "is_complete_request" => is_complete_request,
    "interrupt_request" => interrupt_request,
    "comm_open" => comm_open,
    "comm_info_request" => comm_info_request,
    "comm_msg" => comm_msg,
    "comm_close" => comm_close
)

# IJulia does not use IPython magic syntax, because there are better
# alternatives in Julia, whereas "magics" are inherently limited to
# running in Jupyter cells only.   The alternatives in Julia, which
# can work in any Julia code regardless of whether it is in a notebook
# cell, are:
#     * To interact with the running kernel, we can use IJulia.foo(...),
#       since the running IJulia kernel is loaded into Main.
#     * For implementing special syntax, Julia has @macros and
#       stringmacros"....".
# However, to ease the transition for users coming from other Jupyter kernels,
# we implement some magics that tell the user how to do the corresponding
# thing in Julia.   These are executed whenever a cell beginning with %
# is encountered.

# regex to find the presence of magics in a code-cell string
const magics_regex = r"^\s*(%%?[A-Za-z_][A-Za-z_0-9]*\b)\s*(.*)\s*$"m

# given the cell contents "code" (which start with %foo) output help
# that indicates the Julia equivalent, if possible.
function magics_help(code::AbstractString)
    for m in eachmatch(magics_regex, code)
        display(get(magic_help, m[1], generic_magic_help)(m[1], m[2]))
    end
end

using Markdown

const magic_help_string = """
    Julia does not use the IPython `%magic` syntax.   To interact
    with the IJulia kernel, use `IJulia.somefunction(...)`, for
    example.  Julia macros, string macros, and functions can be used to
    accomplish most of the other functionalities of IPython magics."""
generic_magic_help(magic::AbstractString, args::AbstractString) =
    Markdown.parse("""
        Unrecognized magic `$magic`.

        $magic_help_string""")

lsmagic_help(magic::AbstractString, args::AbstractString) =
    Markdown.parse("""
    $magic_help_string

    The Julia analogues of many IPython magics are printed if
    you try to input the IPython magic in a code cell.""")

alias_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The equivalent of `%alias` magic in Julia is simply to write
    a function that [runs a command object](http://docs.julialang.org/en/latest/manual/running-external-programs/).

    For example, the equivalent of `%alias bracket echo "Input in brackets: <%l>"`
    in IPython would be the Julia function

        bracket(l) = run(`echo "Input in brackets: <$l>"`)

    which you can then run with e.g. `bracket("hello world")`."""

function cd_magic_help(magic::AbstractString, args::AbstractString)
    if magic == "%cd" && !occursin(r"\s*-", args)
        return md"""The equivalent of `%cd 'dir'` in IPython is `cd("dir")` in Julia."""
    else
        return md"""
    The equivalent of `%cd 'dir'` in IPython is `cd("dir")` in Julia.

    Julia does not keep a history of visited directories, so it
    has no built-in equivalent of IPython's `%cd -`, `%dhist`,
    `%pushd`, and `%popd`.

    However, if you are interested, it would be easy to write a
    Julia function `mycd(x)` that worked like IPython's `%cd`
    (accepting a string, `-`, `-n`, and so on, and keeping a stack
    of directory history).  This might make a nice little Julia package
    if you are sufficiently motivated."""
    end
end

debug_magic_help(magic::AbstractString, args::AbstractString) =
md"""The Julia interactive debugger is provided by the [Gallium](https://github.com/Keno/Gallium.jl) package."""

edit_magic_help(magic::AbstractString, args::AbstractString) = md"""
    An analogue of IPython's `%edit` magic is provided by
    the `edit` function and the `@edit` macro in Julia, as
    described [in the Julia manual](http://docs.julialang.org/en/latest/stdlib/base/#Base.edit).

    For example, instead of `%edit -n line 'filename'` in IPython, you would do
    `edit("filename", line)` followed by `include("filename")` if you
    want to execute the file when you are done editing.  The analogue
    of `%edit` (which creates a temporary file) is `n=tempname(); edit(n)`
    followed by `include(n)`.

    If you have a function `foo()`, then `%edit foo` in IPython opens
    the file where `foo` was defined.  The analogue of this in Julia is
    to do `@edit foo()`   Note that you need to supply sample arguments
    to `foo` (which is not actually called), so that Julia knows *which*
    method of `foo` you want to edit.

    If `s` is a string variable, IPython's `%edit s` loads its contents
    into an editor.  In Julia, you would have to explicitly write
    to a temporary file with `n=tempname(); write(n, s); edit(n)` followed
    by `include(n)` to execute it."""

env_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The equivalent of `%env` in IPython, which lists all environment
    variables, is `ENV` in Julia, and the equivalent of
    `%env var=val` is `ENV["var"]=val`.

    (The `ENV` built-in global variable in Julia provides a dictionary-like
    interface to the system environment variables.)
"""

gui_magic_help(magic::AbstractString, args::AbstractString) = md"""
    There is an analogue of IPython's `%gui` in the
    [PyCall package](https://github.com/stevengj/PyCall.jl)
    for calling Python from Julia.   If you have done `using PyCall`
    to load PyCall, then the analogue of `%gui wx` is `pygui_start(:wx)`,
    and the analogue of `%gui` is `pygui_stop()`.  See the PyCall
    documentation for more information.

    Other Julia packages for GUI toolkits, e.g. the
    [Tk package](https://github.com/JuliaGraphics/Tk.jl) or
    the [Gtk package](https://github.com/JuliaGraphics/Gtk.jl), also
    provide their own event-loop integration."""

history_magic_help(magic::AbstractString, args::AbstractString) = md"""
    An analogue of the `%history` or `%hist` magic of IPython, which provides
    access to the input history, is given by IJulia.history(). It is
    based on the global variable `In` in IJulia. `In` is a dictionary
    mapping cell numbers to the inputs. However, IJulia does not currently
    keep any other history, e.g. it discards input cells that you overwrite.
"""

load_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of `%load filename` in IPython is `IJulia.load("filename")`
    in IJulia (to load code from `filename` into the current frontend)

    The analogue of `%load url` is `IJulia.load(download("url"))`.
"""

paste_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of `%paste` in IPython is `IJulia.load_string(clipboard())`
    in IJulia (to load code from the clipboard into the current frontend).
"""

matplotlib_magic_help(magic::AbstractString, args::AbstractString) =
Markdown.parse("""
    The analogue of IPython's `$magic` in Julia is to use
    the [PyPlot package](https://github.com/stevengj/PyPlot.jl),
    which gives a Julia interface to Matplotlib including inline
    plots in IJulia notebooks.   (The equivalent of `numpy` is already
    loaded by default in Julia.)

    Given PyPlot, the analogue of `$magic inline` is `using PyPlot`,
    since PyPlot defaults to inline plots in IJulia.

    To enable separate GUI windows in PyPlot, analogous to `$magic`,
    do `using PyPlot; pygui(true)`.   To specify a particular gui
    backend, analogous to `$magic gui`, you can either do
    `using PyPlot; pygui(:gui); using PyPlot; pygui(true)` (where
    `gui` is `wx`, `qt`, `tk`, or `gtk`), or you can do
    `ENV["MPLBACKEND"]=backend; using PyPlot; pygui(true)` (where
    `backend` is the name of a Matplotlib backend, like `tkagg`).

    For more options, see the PyPlot documentation.""")

pdef_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%pdef somefunction` in Julia is
    `methods(somefunction)`, which prints out all of the possible
    calling signatures of `somefunction`.  (Note that, unlike Python,
    Julia is based on multiple dispatch, so a given function will
    often be callable with many different argument signatures.)"""

pdoc_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%pdoc object` is `?object` in IJulia."""

pfile_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%pfile somefunction` (also `%psource`) is
    roughly `@less somefunction(somearguments...)` in Julia.   The
    reason that you need to supply sample arguments (the function is
    not actually evaluated) is because Julia functions can
    have multiple definitions for different argument types.
    `@less somefunction(somearguments...)` will print (or run
    through the `less` pager) the `somefunction` definition
    corresponding to the arguments you supply."""

file_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%file somefunction` is
    roughly `methods(somefunction)` in Julia.   This lists
    all the methods of `sumfunction` along with the locations where
    they are defined."""

precision_magic_help(magic::AbstractString, args::AbstractString) = md"""
    There currently is no way to globally set the output precision
    in Julia, analogous to `%precision` in IPython, as discussed
    in [Julia issue #6493](https://github.com/JuliaLang/julia/issues/6493)."""

prun_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%prun statement` in Julia is
    `@profile statement`, which runs the
    [Julia profiler](http://docs.julialang.org/en/latest/manual/profile/).
    The analogue of `%%prun ...code...` is
    ```julia
    @profile begin
        ...code...
    end
    ```
    Note, however, that you should put all performance-critical
    code into a function, avoiding global variables, before
    doing performance measurements in Julia; see the
    [performance tips in the Julia manual](http://docs.julialang.org/en/latest/manual/performance-tips/).

    See also the
    [ProfileView package](https://github.com/timholy/ProfileView.jl) for
    richer graphical display of profiling output."""

psearch_magic_help(magic::AbstractString, args::AbstractString) = md"""
    A rough analogue of IPython's `%psearch PATTERN` in Julia might be
    `filter(s -> occursin(r"PATTERN", string(s)), names(Base))`, which
    searches all the symbols defined in the `Base` module for a given
    regular-expression pattern `PATTERN`."""

pwd_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%pwd` is `pwd()` in Julia."""

qtconsole_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%qtconsole` is `IJulia.qtconsole()` in Julia."""

recall_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%recall n` in IJulia is
    `IJulia.load_string(In[n])`, and the analogue of
    `%recall n-m` is `IJulia.load_string(join([get(In,i,"") for i in n:m],"\n"))`."""

run_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%run file` is `include("file")` in Julia.

    The analogue of `%run -t file`, to print timing information, is
    `@time include("file")` in Julia.  The analogue of `%run -t -N n file`
    is `@time for i in 1:n; include("file"); end` in Julia.

    For running under a debugger, see the
    [Gallium Julia debugger](https://github.com/Keno/Gallium.jl).  To
    run other IJulia notebooks, see the
    [NBInclude package](https://github.com/stevengj/NBInclude.jl)."""

save_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%save filename n1-n2 n3-n4` is
    ```julia
    open("filename","w") do io
        for i in [n1:n2; n3:n4]
            println(get(In,i,""))
        end
    end
    ```
    in IJulia."""

sc_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%sc shell command` is `; shell command` in IJulia, or
        read(`shell command`, String)
    to capture the output as a string in Julia."""

set_env_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%set_env var val` is `ENV["var"]=val` in Julia."""

sx_magic_help(magic::AbstractString, args::AbstractString) =
Markdown.parse("""
    The analogue of IPython's `$magic shell command` is
        split(read(`shell command`, String),'\n')
    in Julia.""")

time_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%time statement` (also `%timeit`) in Julia is
    `@time statement`.  The analogue of `%%time ...code...` is
    ```julia
    @time begin
        ...code...
    end
    ```
    Note, however, that you should put all performance-critical
    code into a function, avoiding global variables, before
    doing performance measurements in Julia; see the
    [performance tips in the Julia manual](http://docs.julialang.org/en/latest/manual/performance-tips/).

    The `@time` macro prints the timing results, and returns the
    value of evaluating the expression.  To instead return the time
    (in seconds), use `@elapsed statement`.

    For more extensive benchmarking tools, including the ability
    to collect statistics from multiple runs, see the
    [BenchmarkTools package](https://github.com/JuliaCI/BenchmarkTools.jl)."""

who_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%who` and `%whos` is `whos()` in Julia.

    You can also use `whos(r"PATTERN")` to find variables matching
    a given regular expression `PATTERN`."""

html_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%%html` is
    ```julia
    HTML(""\"
    ...html text...
    ""\")
    ```
    in Julia."""

javascript_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%%javascript ...code...` in Julia can be
    constructed by first evaluating
    ```julia
    macro javascript_str(s) display("text/javascript", s); end
    ```
    to define the `javascript"...."` [string macro](http://docs.julialang.org/en/latest/manual/strings/#non-standard-string-literals)
    in Julia.  Subsequently, you can simply do:
    ```julia
    javascript""\"
    ...code...
    ""\"
    ```
    to execute the script in an IJulia notebook."""

latex_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%%latex` is
    ```julia
    display("text/latex", ""\"
    ...latex text...
    ""\")
    ```
    in Julia.  Note, however, that `$` and `\` in the LaTeX text
    needs to be escaped as `\$` and `\\` so that they aren't
    interpreted by Julia.  See, however, the
    [LaTeXStrings package](https://github.com/stevengj/LaTeXStrings.jl)
    for easier input of LaTeX text as
    L""\"
    ...latex text...
    ""\"
    without requiring any extra backslashes.
"""

function pipe_magic_help(magic::AbstractString, args::AbstractString)
    cmd = magic[3:end] # magic is "%%cmd"
    if cmd == "script"
        arglist = split(args)
        cmd = isempty(arglist) ? "someprogram" : arglist[end]
        magic = "%%script $cmd"
    end
    Markdown.parse("""
    The analogue of IPython's `$magic ...code...` in Julia can be
    constructed by first evaluating
    ```julia
    macro $(cmd)_str(s) open(`$cmd`,"w",stdout) do io; print(io, s); end; end
    ```
    to define the `$cmd"...."` [string macro](http://docs.julialang.org/en/latest/manual/strings/#non-standard-string-literals)
    in Julia.  Subsequently, you can simply do:
    ```julia
    $cmd""\"
    ...code...
    ""\"
    ```
    to evaluate the code in `$cmd` (outputting to `stdout`).""")
end

svg_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%%svg` is
    ```julia
    display("image/svg+xml", ""\"
    ...svg text...
    ""\")
    ```
    in Julia. To be even nicer, you can define
    ```julia
    macro svg_str(s) display("image/svg+xml", s); end
    ```
    to define the `svg"...."` [string macro](http://docs.julialang.org/en/latest/manual/strings/#non-standard-string-literals)
    in Julia.  Subsequently, you can simply do:
    ```julia
    svg""\"
    ...svg text...
    ""\"
    ```
    to display the SVG image.  Using a custom string macro like this
    has the advantage that you don't need to escape `$` and `\` if they
    appear in the SVG code."""

writefile_magic_help(magic::AbstractString, args::AbstractString) = md"""
    The analogue of IPython's `%%writefile filename` is
    `write("filename", In[IJulia.n])`.

    (`IJulia.n` is the index of the current code cell.  Of
    course, you can also use `In[N]` for some other `N` to output
    the contents of a different input cell.)"""

# map from magic to helpfunction(magic, magicargument)
const magic_help = Dict{String, Function}(
    "%alias" => alias_magic_help,
    "%cd" => cd_magic_help,
    "%dhist" => cd_magic_help,
    "%dirs" => cd_magic_help,
    "%popd" => cd_magic_help,
    "%pushd" => cd_magic_help,
    "%debug" => debug_magic_help,
    "%pdb" => debug_magic_help,
    "%edit" => edit_magic_help,
    "%env" => env_magic_help,
    "%gui" => gui_magic_help,
    "%hist" => history_magic_help,
    "%history" => history_magic_help,
    "%load" => load_magic_help,
    "%loadpy" => load_magic_help,
    "%paste" => paste_magic_help,
    "%lsmagic" => lsmagic_help,
    "%matplotlib" => matplotlib_magic_help,
    "%pylab" => matplotlib_magic_help,
    "%pdef" => pdef_magic_help,
    "%pdoc" => pdoc_magic_help,
    "%pinfo" => pdoc_magic_help,
    "%pinfo2" => pdoc_magic_help,
    "%pfile" => pfile_magic_help,
    "%file" => file_magic_help,
    "%psource" => pfile_magic_help,
    "%precision" => precision_magic_help,
    "%prun" => prun_magic_help,
    "%%prun" => prun_magic_help,
    "%psearch" => psearch_magic_help,
    "%pwd" => pwd_magic_help,
    "%qtconsole" => qtconsole_magic_help,
    "%recall" => recall_magic_help,
    "%run" => run_magic_help,
    "%save" => save_magic_help,
    "%sc" => sc_magic_help,
    "%set_env" => set_env_magic_help,
    "%sx" => sx_magic_help,
    "%system" => sx_magic_help,
    "%time" => time_magic_help,
    "%%time" => time_magic_help,
    "%timeit" => time_magic_help,
    "%%timeit" => time_magic_help,
    "%who" => who_magic_help,
    "%who_ls" => who_magic_help,
    "%whos" => who_magic_help,
    "%%html" => html_magic_help,
    "%%javascript" => javascript_magic_help,
    "%%latex" => latex_magic_help,
    "%%bash" => pipe_magic_help,
    "%%perl" => pipe_magic_help,
    "%%python" => pipe_magic_help,
    "%%python2" => pipe_magic_help,
    "%%python3" => pipe_magic_help,
    "%%ruby" => pipe_magic_help,
    "%%script" => pipe_magic_help,
    "%%sh" => pipe_magic_help,
    "%%svg" => svg_magic_help,
    "%%writefile" => writefile_magic_help,
)

using Test
import IJulia: get_token

@testset "completion tokenizer" begin
    test0_code = "x + y + z"
    test0_expected = "xxxxyyyyz"
    test0_got = map(i -> get_token(test0_code, i), eachindex(test0_code))
    @test split(test0_expected, "") == test0_got

    test1_code      = """println("Hello world")"""
    test1_expected  = "println"
    test1_got = map(i -> get_token(test1_code, i), eachindex(test1_code))
    @test all(test1_expected .== test1_got)

    test2_code      = """println("Hello world", x)"""
    test2_expected  = "println"
    test2_got = map(i -> get_token(test2_code, i), eachindex(test2_code))
    @test all(test2_expected .== test2_got)

    test3_code      = """println("Hello world", x, y)"""
    test3_expected  = "println"
    test3_got = map(i -> get_token(test3_code, i), eachindex(test3_code))
    @test all(test3_expected .== test3_got)

    test4_code      = """println("Hello world", (x, y))"""
    test4_expected  = "println"
    test4_got = map(i -> get_token(test4_code, i), eachindex(test4_code))
    @test all(test4_expected .== test4_got)

    test5_code      = """println("Hello world", (x, y, (2 + 3 - 5)))"""
    test5_expected  = "println"
    test5_got = map(i -> get_token(test5_code, i), eachindex(test5_code))
    @test all(test5_expected .== test5_got)

    # TODO These won't work in current, "hacky" implementation.
    # Current implementation treats each token separate, returning
    # "Vector", "Int", "undef", "n" respectively
    test6_code      = """Vector{Int}(undef, n)"""
    test6_expected  = "Vector"
    test6_got = map(i -> get_token(test6_code, i), eachindex(test6_code))
    @test_broken all(test6_expected .== test6_got)

    # TODO These won't work either, mostly due to the same reason
    test7_code      = """f(g(x))"""
    test7_expected  = """fffggff"""
    test7_got = map(i -> get_token(test7_code, i), eachindex(test7_code))
    @test_broken split(test7_expected, "") == test7_got

    test8_code      = """f(x, g(x))"""
    test8_expected  = """ffffffggff"""
    test8_got = map(i -> get_token(test8_code, i), eachindex(test8_code))
    @test split(test8_expected, "") == test8_got

    # Test tokenizing partial expressions
    test9_code      = """println(x,"""
    test9_expected  = """println"""
    test9_got = map(i -> get_token(test9_code, i), eachindex(test9_code))
    @test all(test9_got .== test9_expected)
end

"""
**IJulia** is a [Julia-language](http://julialang.org/) backend
combined with the [Jupyter](http://jupyter.org/) interactive
environment (also used by [IPython](http://ipython.org/)).  This
combination allows you to interact with the Julia language using
Jupyter/IPython's powerful [graphical
notebook](http://ipython.org/notebook.html), which combines code,
formatted text, math, and multimedia in a single document.

The `IJulia` module is used in three ways

* Typing `using IJulia; notebook()` will launch the Jupyter notebook
  interface in your web browser.  This is an alternative to launching
  `jupyter notebook` directly from your operating-system command line.
* In a running notebook, the `IJulia` module is loaded and `IJulia.somefunctions`
  can be used to interact with the running IJulia kernel:

  - `IJulia.load(filename)` and `IJulia.load_string(s)` load the contents
    of a file or a string, respectively, into a notebook cell.
  - `IJulia.clear_output()` to clear the output from the notebook cell,
    useful for simple animations.
  - `IJulia.clear_history()` to clear the history variables `In` and `Out`.
  - `push_X_hook(f)` and `pop_X_hook(f)`, where `X` is either
    `preexecute`, `postexecute`, or `posterror`.  This allows you to
    insert a "hook" function into a list of functions to execute
    when notebook cells are evaluated.
  - `IJulia.set_verbose()` enables verbose output about what IJulia
    is doing internally; this is mainly used for debugging.

* It is used internally by the IJulia kernel when talking
  to the Jupyter server.
"""
module IJulia
export notebook, jupyterlab, nbclassic, installkernel

import SHA
using ZMQ
import Base: invokelatest, RefValue
import Dates
using Dates: now, format, UTC, ISODateTimeFormat
import Random
import Random: seed!
using Base64: Base64EncodePipe
import REPL
import Logging

# InteractiveUtils is not used inside IJulia, but loaded in src/kernel.jl
# and this import makes it possible to load InteractiveUtils from the IJulia namespace
import InteractiveUtils

const depfile = joinpath(dirname(@__FILE__), "..", "deps", "deps.jl")
isfile(depfile) || error("IJulia not properly installed. Please run Pkg.build(\"IJulia\")")
include(depfile) # generated by Pkg.build("IJulia")

# use our own random seed for msg_id so that we
# don't alter the user-visible random state (issue #336)
const IJulia_RNG = seed!(Random.MersenneTwister(0))
import UUIDs
uuid4() = string(UUIDs.uuid4(IJulia_RNG))

"""
IPython message struct.
"""
mutable struct Msg
    idents::Vector{String}
    header::Dict
    content::Dict
    parent_header::Dict
    metadata::Dict
    buffers::Vector{Vector{UInt8}}

    function Msg(idents, header::Dict, content::Dict,
                 parent_header=Dict{String,Any}(), metadata=Dict{String,Any}(),
                 buffers=Vector{UInt8}[])
        new(idents, header, content, parent_header, metadata, buffers)
    end
end

mutable struct Comm{target}
    id::String
    primary::Bool
    on_msg::Function
    on_close::Function
    function (::Type{Comm{target}})(id, primary, on_msg, on_close, kernel) where {target}
        comm = new{target}(id, primary, on_msg, on_close)
        kernel.comms[id] = comm
        return comm
    end
end

# similar to Pkg.REPLMode.MiniREPL, a minimal REPL-like emulator
# for use with Pkg.do_cmd.  We have to roll our own to
# make sure it uses the redirected stdout, and because
# we don't have terminal support.
struct MiniREPL <: REPL.AbstractREPL
    display::TextDisplay
end
REPL.REPLDisplay(repl::MiniREPL) = repl.display

@kwdef mutable struct Kernel
    verbose::Bool = IJULIA_DEBUG
    inited::Bool = false
    current_module::Module = Main
    shutting_down::Threads.Atomic{Bool} = Threads.Atomic{Bool}(false)

    # These fields are special and are mirrored to their corresponding global
    # variables.
    In::Dict{Int, String} = Dict{Int, String}()
    Out::Dict{Int, Any} = Dict{Int, Any}()
    ans::Any = nothing
    n::Int = 0

    capture_stdout::Bool = true
    capture_stderr::Bool = !IJULIA_DEBUG
    capture_stdin::Bool = true

    minirepl::Union{MiniREPL, Nothing} = nothing

    # This dict holds a map from CommID to Comm so that we can
    # pick out the right Comm object when messages arrive
    # from the front-end.
    comms::Dict{String, Comm} = Dict{String, Comm}()

    shutdown::Function = start_shutdown

    # the following constants need to be initialized in init().
    publish::RefValue{Socket} = Ref{Socket}()
    raw_input::RefValue{Socket} = Ref{Socket}()
    requests::RefValue{Socket} = Ref{Socket}()
    control::RefValue{Socket} = Ref{Socket}()
    heartbeat::RefValue{Socket} = Ref{Socket}()
    zmq_context::RefValue{Context} = Ref{Context}()
    profile::Dict{String, Any} = Dict{String, Any}()
    connection_file::Union{String, Nothing} = nothing
    read_stdout::RefValue{Base.PipeEndpoint} = Ref{Base.PipeEndpoint}()
    read_stderr::RefValue{Base.PipeEndpoint} = Ref{Base.PipeEndpoint}()
    socket_locks::Dict{Socket, ReentrantLock} = Dict{Socket, ReentrantLock}()
    sha_ctx::RefValue{SHA.SHA_CTX} = Ref{SHA.SHA_CTX}()
    hmac_key::Vector{UInt8} = UInt8[]

    stop_event::Base.Event = Base.Event()
    waitloop_task::RefValue{Task} = Ref{Task}()

    # This looks a bit strange, but it's not uncommon for loading packages to
    # invalidate IJulia code. This can contribute significantly to compilation
    # latency so after each execute_request we launch tasks to precompile
    # certain request handlers asynchronously in the hope that it cuts down on
    # perceived latency by the user. We store the tasks here to prevent any
    # lingering tasks upon shutdown that could cause hangs.
    execute_precompile_task::RefValue{Task} = Ref{Task}()
    completion_precompile_task::RefValue{Task} = Ref{Task}()

    requests_task::RefValue{Task} = Ref{Task}()
    watch_stdout_task::RefValue{Task} = Ref{Task}()
    watch_stderr_task::RefValue{Task} = Ref{Task}()
    flush_stdout_task::RefValue{Task} = Ref{Task}()
    flush_stderr_task::RefValue{Task} = Ref{Task}()

    # name=>iobuffer for each stream ("stdout","stderr") so they can be sent in flush
    bufs::Dict{String, IOBuffer} = Dict{String, IOBuffer}()
    bufs_locks::Dict{String, ReentrantLock} = Dict{String, ReentrantLock}()
    # max output per code cell is 512 kb by default
    max_output_per_request::RefValue{Int} = Ref(1 << 19)

    # Variable so that display can be done in the correct Msg context
    execute_msg::Msg = Msg(["julia"], Dict("username"=>"jlkernel", "session"=>uuid4()), Dict())
    # Variable tracking the number of bytes written in the current execution request
    stdio_bytes::Int = 0
    # Use an array to accumulate "payloads" for the execute_reply message
    execute_payloads::Vector{Dict} = Dict[]

    heartbeat_threadid::Vector{Int} = zeros(Int, 128) # sizeof(uv_thread_t) <= 8 on Linux, OSX, Win

    # queue of objects to display at end of cell execution
    displayqueue::Vector{Any} = Any[]
end

function Base.setproperty!(kernel::Kernel, name::Symbol, x)
    # These fields need to be assigned explicitly to their global counterparts
    if name ∈ (:ans, :n, :In, :Out, :inited)
        setproperty!(IJulia, name, x)
    end

    setfield!(kernel, name, x)
end

function Base.wait(kernel::Kernel)
    if isassigned(kernel.waitloop_task)
        wait(kernel.waitloop_task[])
    end
end

function start_shutdown(kernel::Kernel)
    kernel.shutting_down[] = true
    kernel.inited = false

    # First we call zmq_ctx_shutdown() to close the context and stop all sockets
    # from working. We don't call ZMQ.close(::Context) directly because that
    # currently isn't threadsafe:
    # https://github.com/JuliaInterop/ZMQ.jl/issues/256
    ZMQ.lib.zmq_ctx_shutdown(kernel.zmq_context[])

    # Wait for the heartbeat thread to stop
    @ccall uv_thread_join(kernel.heartbeat_threadid::Ptr{Int})::Cint

    # Now all the sockets should have been cancelled and the eventloop tasks
    # should be ready to shutdown.
    notify(kernel.stop_event)
end

function Base.close(kernel::Kernel)
    for task_ref in (kernel.execute_precompile_task, kernel.completion_precompile_task)
        if isassigned(task_ref)
            wait(task_ref[])
        end
    end

    # Reset the IO streams first so that any later errors get printed
    if kernel.capture_stdout
        redirect_stdout(orig_stdout[])
        close(kernel.read_stdout[])
        wait(kernel.flush_stdout_task[])
        wait(kernel.watch_stdout_task[])
    end
    if kernel.capture_stderr
        redirect_stderr(orig_stderr[])
        close(kernel.read_stderr[])
        wait(kernel.flush_stderr_task[])
        wait(kernel.watch_stderr_task[])
    end
    if kernel.capture_stdin
        redirect_stdin(orig_stdin[])
    end

    # Reset the logger so that @log statements work and pop the InlineDisplay
    if isassigned(orig_logger)
        # orig_logger seems to not be set during precompilation
        Logging.global_logger(orig_logger[])
    end
    popdisplay()

    start_shutdown(kernel)
    wait(kernel)

    # Close all sockets
    close(kernel.publish[])
    close(kernel.raw_input[])
    close(kernel.requests[])
    close(kernel.control[])
    close(kernel.heartbeat[])
    close(kernel.zmq_context[])

    # Reset global variables
    IJulia.n = 0
    IJulia.ans = nothing
    IJulia.In = Dict{Int, String}()
    IJulia.Out = Dict{Int, Any}()
    IJulia._default_kernel = nothing
    IJulia.CommManager.comms = Dict{String, CommManager.Comm}()
    IJulia.profile = Dict{String, Any}()
end

function Kernel(f::Function, profile::Union{String, Dict}; kwargs...)
    kernel = Kernel(; kwargs...)
    if profile isa Dict
        init([], kernel, profile)
    else
        init([profile], kernel)
    end

    try
        f(kernel)
    finally
        close(kernel)
    end
end

_default_kernel::Union{Kernel, Nothing} = nothing

function get_kernel_or_error(kernel=_default_kernel)
    if isnothing(kernel)
        error("Kernel has not been initialized.")
    end
    return kernel
end

"""
    set_verbose(v=true)

This function enables (or disables, for `set_verbose(false)`) verbose
output from the IJulia kernel, when called within a running notebook.
This consists of log messages printed to the terminal window where
`jupyter` was launched, displaying information about every message sent
or received by the kernel.   Used for debugging IJulia.
"""
function set_verbose(v::Bool=true, kernel=_default_kernel)
    kernel = get_kernel_or_error(kernel)
    kernel.verbose = v
end

"""
`inited` is a global variable that is set to `true` if the IJulia
kernel is running, i.e. in a running IJulia notebook.  To test
whether you are in an IJulia notebook, therefore, you can check
`isdefined(Main, :IJulia) && IJulia.inited`.
"""
inited::Bool = false

function set_current_module(m::Module; kernel=_default_kernel)
    kernel = get_kernel_or_error(kernel)
    kernel.current_module = m
end

#######################################################################
include(joinpath("..", "deps", "kspec.jl"))
include("jupyter.jl")
#######################################################################

"""
    load_string(s, replace=false)

Load the string `s` into a new input code cell in the running IJulia notebook,
somewhat analogous to the `%load` magics in IPython. If the optional argument
`replace` is `true`, then `s` replaces the *current* cell rather than creating
a new cell.
"""
function load_string(s::AbstractString, replace::Bool=false, kernel=_default_kernel)
    push!(kernel.execute_payloads, Dict(
        "source"=>"set_next_input",
        "text"=>s,
        "replace"=>replace
    ))
    return nothing
end

"""
    load(filename, replace=false)

Load the file given by `filename` into a new input code cell in the running
IJulia notebook, analogous to the `%load` magics in IPython.
If the optional argument `replace` is `true`, then the file contents
replace the *current* cell rather than creating a new cell.
"""
load(filename::AbstractString, replace::Bool=false, kernel=_default_kernel) =
    load_string(read(filename, String), replace, kernel)

#######################################################################
# History: global In/Out and other exported history variables
"""
`In` is a global dictionary of input strings, where `In[n]`
returns the string for input cell `n` of the notebook (as it was
when it was *last evaluated*).
"""
In::Dict{Int, String} = Dict{Int, String}()
"""
`Out` is a global dictionary of output values, where `Out[n]`
returns the output from the last evaluation of cell `n` in the
notebook.
"""
Out::Dict{Int, Any} = Dict{Int, Any}()
"""
`ans` is a global variable giving the value returned by the last
notebook cell evaluated.
"""
ans::Any = nothing

# execution counter
"""
`IJulia.n` is the (integer) index of the last-evaluated notebook cell.
"""
n::Int = 0

#######################################################################
# methods to clear history or any subset thereof

function clear_history(indices; kernel=_default_kernel)
    for n in indices
        delete!(kernel.In, n)
        if haskey(kernel.Out, n)
            delete!(kernel.Out, n)
        end
    end
end

# since a range could be huge, intersect it with 1:n first
clear_history(r::AbstractRange{<:Integer}) =
    invoke(clear_history, Tuple{Any}, intersect(r, 1:n))

function clear_history(; kernel=_default_kernel)
    empty!(kernel.In)
    empty!(kernel.Out)
    kernel.ans = nothing
end

"""
    clear_history([indices])

The `clear_history()` function clears all of the input and output
history stored in the running IJulia notebook.  This is sometimes
useful because all cell outputs are remember in the `Out` global variable,
which prevents them from being freed, so potentially this could
waste a lot of memory in a notebook with many large outputs.

The optional `indices` argument is a collection of indices indicating
a subset of cell inputs/outputs to clear.
"""
clear_history

#######################################################################
# methods to print history or any subset thereof
function history(io::IO, indices::AbstractVector{<:Integer}; kernel=_default_kernel)
    for n in intersect(indices, 1:kernel.n)
      if haskey(kernel.In, n)
        println(io, kernel.In[n])
      end
    end
end

history(io::IO, x::Union{Integer,AbstractVector{<:Integer}}...; kernel=_default_kernel) = history(io, vcat(x...); kernel)
history(x...; kernel=_default_kernel) = history(stdout, x...; kernel)
history(io::IO, x...; kernel=_default_kernel) = throw(MethodError(history, (io, x...,)))
history(; kernel=_default_kernel) = history(1:kernel.n; kernel)
"""
    history([io], [indices...])

The `history()` function prints all of the input history stored in
the running IJulia notebook in a format convenient for copying.

The optional `indices` argument is one or more indices or collections
of indices indicating a subset input cells to print.

The optional `io` argument is for specifying an output stream. The default
is `stdout`.
"""
history

#######################################################################
# Similar to the ipython kernel, we provide a mechanism by
# which modules can register thunk functions to be called after
# executing an input cell, e.g. to "close" the current plot in Pylab.

const _preexecute_hooks = Function[]
const _postexecute_hooks = Function[]
const _posterror_hooks = Function[]
# This is an internal hooks list to be called when stdio is being flushed by
# execute_request(). Used by the PythonCall extension.
const _flush_hooks = Function[]

function _pop_hook!(f, hooks)
    hook_idx = findlast(isequal(f), hooks)
    if isnothing(hook_idx)
        error("Could not find hook: $(f)")
    else
        splice!(hooks, hook_idx)
    end
end

"""
    push_postexecute_hook(f::Function)

Push a function `f()` onto the end of a list of functions to
execute after executing any notebook cell.
"""
push_postexecute_hook(f::Function) = push!(IJulia._postexecute_hooks, f)

"""
    pop_postexecute_hook(f::Function)

Remove a function `f()` from the list of functions to
execute after executing any notebook cell.
"""
pop_postexecute_hook(f::Function) = _pop_hook!(f, IJulia._postexecute_hooks)

"""
    push_preexecute_hook(f::Function)

Push a function `f()` onto the end of a list of functions to
execute before executing any notebook cell.
"""
push_preexecute_hook(f::Function) = push!(IJulia._preexecute_hooks, f)

"""
    pop_preexecute_hook(f::Function)

Remove a function `f()` from the list of functions to
execute before executing any notebook cell.
"""
pop_preexecute_hook(f::Function) = _pop_hook!(f, IJulia._preexecute_hooks)

# similar, but called after an error (e.g. to reset plotting state)
"""
    pop_posterror_hook(f::Function)

Remove a function `f()` from the list of functions to
execute after an error occurs when a notebook cell is evaluated.
"""
push_posterror_hook(f::Function) = push!(IJulia._posterror_hooks, f)

"""
    pop_posterror_hook(f::Function)

Remove a function `f()` from the list of functions to
execute after an error occurs when a notebook cell is evaluated.
"""
pop_posterror_hook(f::Function) = _pop_hook!(f, IJulia._posterror_hooks)

#######################################################################

# The user can call IJulia.clear_output() to clear visible output from the
# front end, useful for simple animations.  Using wait=true clears the
# output only when new output is available, for minimal flickering.
"""
    clear_output(wait=false)

Call `clear_output()` to clear visible output from the current notebook
cell.  Using `wait=true` clears the output only when new output is
available, which reduces flickering and is useful for simple animations.
"""
function clear_output(wait=false, kernel=_default_kernel)
    # flush pending stdio
    flush_all()
    empty!(kernel.displayqueue) # discard pending display requests
    send_ipython(kernel.publish[], kernel, msg_pub(kernel.execute_msg::Msg, "clear_output",
                                           Dict("wait" => wait)))
    kernel.stdio_bytes = 0 # reset output throttling
    return nothing
end


"""
    set_max_stdio(max_output::Integer)

Sets the maximum number of bytes, `max_output`, that can be written to stdout and
stderr before getting truncated. A large value here allows a lot of output to be
displayed in the notebook, potentially bogging down the browser.
"""
function set_max_stdio(max_output::Integer; kernel=_default_kernel)
    kernel.max_output_per_request[] = max_output
end

"""
    reset_stdio_count()

Reset the count of the number of bytes written to stdout/stderr. See
[`set_max_stdio`](@ref) for more details.
"""
function reset_stdio_count(kernel=_default_kernel)
    kernel.stdio_bytes = 0
end

#######################################################################

# These are stubs for the PythonCall extension

"""
    init_ipywidgets()

Initialize the integration with ipywidgets by setting up the right hooks to
allow ipywidgets to use IJulia comms.
"""
function init_ipywidgets end

"""
    init_ipython()

Initialize the integration with IPython by overriding its display system to call
Julia's `display()` instead.
"""
function init_ipython end

"""
    init_matplotlib(backend="module://ipympl.backend_nbagg")

Initialize the integration with matplotlib.
"""
function init_matplotlib end

include("init.jl")
include("hmac.jl")
include("eventloop.jl")
include("stdio.jl")
include("msg.jl")
include("display.jl")
include("magics.jl")
include("comm_manager.jl")
include("execute_request.jl")
include("handlers.jl")
include("heartbeat.jl")
include("inline.jl")
include("kernel.jl")
include("precompile.jl")

end # IJulia

function run_kernel()
    # Load InteractiveUtils from the IJulia namespace since @stdlib might not be in LOAD_PATH
    @eval Main using IJulia.InteractiveUtils

    # the size of truncated output to show should not depend on the terminal
    # where the kernel is launched, since the display is elsewhere
    ENV["LINES"] = get(ENV, "LINES", "30")
    ENV["COLUMNS"] = get(ENV, "COLUMNS", "80")

    println(Core.stdout, "Starting kernel event loops.")
    kernel = Kernel()
    IJulia.init(ARGS, kernel)
    isempty(ARGS) || popfirst!(ARGS) # Jupyter argument should not be visible to user

    let startupfile = !isempty(DEPOT_PATH) ? abspath(DEPOT_PATH[1], "config", "startup_ijulia.jl") : ""
        isfile(startupfile) && Base.JLOptions().startupfile != 2 && Base.include(Main, startupfile)
    end

    # import things that we want visible in IJulia but not in REPL's using IJulia
    @eval Main import IJulia: ans, In, Out, clear_history

    wait(kernel)
    close(kernel)
end

import Random: seed!
import Sockets
import Logging
import Logging: AbstractLogger, ConsoleLogger

const orig_stdin  = Ref{IO}()
const orig_stdout = Ref{IO}()
const orig_stderr = Ref{IO}()
const orig_logger = Ref{AbstractLogger}()
const SOFTSCOPE = Ref{Bool}()

# Global variable kept around for backwards compatibility
profile::Dict{String, Any} = Dict{String, Any}()


function __init__()
    seed!(IJulia_RNG)
    orig_stdin[]  = stdin
    orig_stdout[] = stdout
    orig_stderr[] = stderr
    orig_logger[] = Logging.global_logger()
    SOFTSCOPE[] = lowercase(get(ENV, "IJULIA_SOFTSCOPE", "yes")) in ("yes", "true")

    Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
        if exc.f === IJulia.init_ipywidgets || exc.f === IJulia.init_matplotlib || exc.f === IJulia.init_ipython
            if isempty(methods(exc.f))
                print(io, "\nIJulia.$(nameof(exc.f))() cannot be called yet, you must load PythonCall first for the extension to be loaded.")
            end
        end
    end
end

function getports(port_hint, n)
    ports = Int[]

    for i in 1:n
        port, server = Sockets.listenany(Sockets.localhost, port_hint)
        close(server)
        push!(ports, port)
        port_hint = port + 1
    end

    return ports
end

function create_profile(port_hint=8080; key=uuid4())
    # Disable constprop here because SnoopCompile shows that it significantly
    # reduces inference time. It's fine if inference is bad for this function
    # because in practice it's only used in tests and the precompile workload.
    Base.@constprop :none

    ports = getports(port_hint, 5)

    Dict(
        "transport" => "tcp",
        "ip" => "127.0.0.1",
        "control_port" => ports[1],
        "shell_port" => ports[2],
        "stdin_port" => ports[3],
        "hb_port" => ports[4],
        "iopub_port" => ports[5],
        "signature_scheme" => "hmac-sha256",
        "key" => key
    )
end

function maybe_launch_precompile(kernel::Kernel)
    # Execution and completion are likely the most common requests for the user
    # to observe latency, so only precompile those.
    for (task_ref, handler) in ((kernel.execute_precompile_task, execute_request),
                                (kernel.completion_precompile_task, complete_request))
        if !isassigned(task_ref) || istaskdone(task_ref[])
            task_ref[] = Threads.@spawn @invokelatest precompile(handler, (Socket, Kernel, Msg))
        end
    end
end

"""
    init(args, kernel)

Initialize a kernel. `args` may either be empty or have one element containing
the path to an existing connection file. If `args` is empty a connection file
will be generated.
"""
function init(args, kernel, profile=nothing)
    !isnothing(IJulia._default_kernel) && error("IJulia is already running")
    if length(args) > 0
        merge!(kernel.profile, JSONX.parsefile(args[1])::Dict)
        kernel.verbose && println("PROFILE = $profile")
        kernel.connection_file = args[1]
    elseif !isnothing(profile)
        merge!(kernel.profile, profile)
    else
        # generate profile and save
        let port0 = 5678
            merge!(kernel.profile, create_profile(port0))
            fname = "profile-$(getpid()).json"
            kernel.connection_file = "$(pwd())/$fname"
            println("connect ipython with --existing $(kernel.connection_file)")
            open(fname, "w") do f
                write(f, JSONX.json(kernel.profile))
            end
        end
    end

    profile = kernel.profile

    if !isempty(profile["key"])
        signature_scheme = get(profile, "signature_scheme", "hmac-sha256")::String
        isempty(signature_scheme) && (signature_scheme = "hmac-sha256")
        sigschm = split(signature_scheme, "-")
        if sigschm[1] != "hmac" || length(sigschm) != 2
            error("Unrecognized signature_scheme: $(signature_scheme)")
        elseif !startswith(sigschm[2], "sha")
            error("Signature schemes other than SHA are not supported on IJulia anymore, requested signature_scheme is: $(signature_scheme)")
        end

        kernel.sha_ctx[] = getproperty(SHA, Symbol(uppercase(sigschm[2]), "_CTX"))()
        kernel.hmac_key = collect(UInt8, profile["key"])
    end

    kernel.zmq_context[] = Context()
    kernel.publish[] = Socket(kernel.zmq_context[], PUB)
    kernel.raw_input[] = Socket(kernel.zmq_context[], ROUTER)
    kernel.requests[] = Socket(kernel.zmq_context[], ROUTER)
    kernel.control[] = Socket(kernel.zmq_context[], ROUTER)
    kernel.heartbeat[] = Socket(kernel.zmq_context[], REP)
    sep = profile["transport"]=="ipc" ? "-" : ":"
    bind(kernel.publish[], "$(profile["transport"])://$(profile["ip"])$(sep)$(profile["iopub_port"])")
    bind(kernel.requests[], "$(profile["transport"])://$(profile["ip"])$(sep)$(profile["shell_port"])")
    bind(kernel.control[], "$(profile["transport"])://$(profile["ip"])$(sep)$(profile["control_port"])")
    bind(kernel.raw_input[], "$(profile["transport"])://$(profile["ip"])$(sep)$(profile["stdin_port"])")
    bind(kernel.heartbeat[], "$(profile["transport"])://$(profile["ip"])$(sep)$(profile["hb_port"])")

    # associate a lock with each socket so that multi-part messages
    # on a given socket don't get inter-mingled between tasks.
    for s in (kernel.publish[], kernel.raw_input[], kernel.requests[], kernel.control[])
        kernel.socket_locks[s] = ReentrantLock()
    end

    start_heartbeat(kernel)
    if kernel.capture_stdout
        kernel.read_stdout[], = redirect_stdout()
        redirect_stdout(IJuliaStdio(stdout, "stdout"))
    end
    if kernel.capture_stderr
        kernel.read_stderr[], = redirect_stderr()
        redirect_stderr(IJuliaStdio(stderr, "stderr"))
    end
    if kernel.capture_stdin
        redirect_stdin(IJuliaStdio(stdin, "stdin"))
    end

    @static if VERSION < v"1.11"
        kernel.minirepl = MiniREPL(TextDisplay(stdout))
    end

    watch_stdio(kernel)
    pushdisplay(IJulia.InlineDisplay())

    logger = ConsoleLogger(Base.stderr)
    Base.CoreLogging.global_logger(logger)
    IJulia._default_kernel = kernel
    IJulia.CommManager.comms = kernel.comms
    IJulia.profile = kernel.profile

    send_status("starting", kernel)
    kernel.inited = true

    # Explicitly initialize these fields so that setproperty!(::Kernel) is
    # called and assigns them to their corresponding global variables. This is
    # not done by the @kwdef constructor.
    kernel.In = Dict{Int, String}()
    kernel.Out = Dict{Int, Any}()

    maybe_launch_precompile(kernel)
    kernel.waitloop_task[] = @async waitloop(kernel)
end

"""
    eventloop(socket, kernel)

Generic event loop for one of the [kernel
sockets](https://jupyter-client.readthedocs.io/en/latest/messaging.html#introduction).
"""
function eventloop(socket, kernel)
    task_local_storage(:IJulia_task, "write task")
    while true
        try
            local msg
            try
                msg = recv_ipython(socket, kernel)
            catch e
                if isa(e, EOFError)
                    # The socket was closed
                    return
                else
                    rethrow()
                end
            end

            try
                send_status("busy", kernel, msg)
                msg_type = msg.header["msg_type"]::String
                invokelatest(get(handlers, msg_type, unknown_request), socket, kernel, msg)
            catch e
                if e isa InterruptException && kernel.shutting_down[]
                    # If we're shutting down, just return immediately
                    return
                elseif !isa(e, InterruptException)
                    # Try to keep going if we get an exception, but
                    # send the exception traceback to the front-ends.
                    # (Ignore SIGINT since this may just be a user-requested
                    #  kernel interruption to interrupt long calculations.)
                    content = error_content(e, msg="KERNEL EXCEPTION")
                    map(s -> println(orig_stderr[], s), content["traceback"])
                    send_ipython(kernel.publish[], kernel, msg_pub(kernel.execute_msg, "error", content))
                end
            finally
                flush_all()
                send_status("idle", kernel, msg)
            end
        catch e
            if kernel.shutting_down[]
                return
            end

            # the Jupyter manager may send us a SIGINT if the user
            # chooses to interrupt the kernel; don't crash on this
            if isa(e, InterruptException)
                continue
            elseif isa(e, ZMQ.StateError)
                # This is almost certainly because of a closed socket
                return
            else
                rethrow()
            end
        end
    end
end

"""
    waitloop(kernel)

Main loop of a kernel. Runs the event loops for the control and shell sockets
(note: in IJulia the shell socket is called `requests`).
"""
function waitloop(kernel)
    control_task = @async eventloop(kernel.control[], kernel)
    kernel.requests_task[] = @async eventloop(kernel.requests[], kernel)

    while kernel.inited
        try
            wait(kernel.stop_event)
        catch e
            # send interrupts (user SIGINT) to the code-execution task
            if isa(e, InterruptException)
                @async Base.throwto(kernel.requests_task[], e)
            else
                rethrow()
            end
        finally
            # Only wait for tasks if we're actually exiting the loop
            if !kernel.inited
                wait(control_task)
                wait(kernel.requests_task[])
            end
        end
    end
end

using Test
import IJulia: Msg
using Dates

@testset "msg" begin
    idents = ["idents"]
    header = Dict("msg_id"=>"c673eed8-7c36-47f4-82af-df8ec546a87d",
                "msg_type"=>"comm_msg",
                "username"=>"username",
                "date"=>now(),
                "version"=>"5.0",
                "session"=>"980FF7B5F8A24ECF9876A91F38F4EC09")
    content = Dict("comm_id"=>"d733be5d-fd21-4194-95da-db364346f2c9",
                "data"=>Dict(:value=>Dict("text/plain"=>"10")))
    msg = Msg(idents, header, content)

    @test 1 == length(msg.idents)
    @test "c673eed8-7c36-47f4-82af-df8ec546a87d" == msg.header["msg_id"]
end

import Aqua
# Note that we import Revise before IJulia to prevent Revise adding its own
# preexecute hook, which would mess up the tests.
import Revise
import IJulia

const TEST_FILES = [
    "install.jl", "comm.jl", "msg.jl", "execute_request.jl", "stdio.jl",
    "inline.jl", "completion.jl", "jsonx.jl"
]

for file in TEST_FILES
    println(file)
    include(file)
end

# Python is well-nigh impossible to install on 32bit
if Sys.WORD_SIZE != 32
    include("kernel.jl")
else
    @warn "Skipping the Kernel tests on 32bit"
end

@testset "Aqua.jl" begin
    # Note that Pkg and Conda are loaded lazily
    Aqua.test_all(IJulia; stale_deps=(; ignore=[:Pkg, :Conda]))
end

# JET does not play well on versions prior to 1.12, and we disable it on 32bit
# because it seems to give false positives for the despecialized display methods
# if the kernel tests aren't run.
@static if VERSION >= v"1.12" && Sys.WORD_SIZE == 64
    import JET

    @testset "JET.jl" begin
        JET.test_package(IJulia; target_modules=(IJulia,))
    end
end

using Test
import IJulia: Comm, comm_target

@testset "comm" begin
    kernel = IJulia.Kernel()

    target = :notarget
    comm_id = "6BA197D8A67A455196279A59EB2FE844"
    comm = Comm(target, comm_id, false; kernel)
    @test :notarget == comm_target(comm)
    @test !comm.primary


    # comm_info_request in comm_manager.jl
    comms = Dict{String, Comm}(
        "id" => Comm(Symbol("jupyter.widget"), "id", false; kernel)
    )
    msg_content = Dict("target_name" => "jupyter.widget")
    reply = if haskey(msg_content, "target_name")
        let t, cb
            t = Symbol(msg_content["target_name"])
            cb(k, v) = comm_target(v) == t # For 0.6
            cb(kv) = comm_target(kv[2]) == t # For 0.7
            filter(cb, comms)
        end
    else
        comms
    end
    @test Dict{String,Comm} == typeof(reply)
    _comms = Dict{String,Dict{Symbol,Symbol}}()
    for (comm_id,comm) in reply
        local comm_id, comm
        _comms[comm_id] = Dict(:target_name => comm_target(comm))
    end
    @test Dict("id"=>Dict(:target_name=>Symbol("jupyter.widget"))) == _comms
    content = Dict(:comms => _comms)
    @test Dict(:comms=>Dict("id"=>Dict(:target_name=>Symbol("jupyter.widget")))) == content
end

import Changelog
using Documenter, IJulia

if isdefined(Main, :Revise)
    Revise.revise()
end

# Build the changelog
Changelog.generate(
    Changelog.Documenter(),
    joinpath(@__DIR__, "src/_changelog.md"),
    joinpath(@__DIR__, "src/changelog.md"),
    repo="JuliaLang/IJulia.jl"
)

# Make docs to `docs/build` directory
makedocs(;
    repo=Remotes.GitHub("JuliaLang", "IJulia.jl"),
    modules=[IJulia],
    sitename="IJulia",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        assets = ["assets/favicon.ico", "assets/custom.css"],
    ),
    pages=[
        "Home" => "index.md",
        "Manual" => [
            "manual/installation.md",
            "manual/running.md",
            "manual/usage.md",
            "manual/troubleshooting.md",
        ],
        "Library" => [
            "library/public.md",
            "library/internals.md",
        ],
        "changelog.md"
    ]
)

# Deploy docs
deploydocs(
    repo = "github.com/JuliaLang/IJulia.jl.git",
    push_preview = true,
)

# define our own method to avoid type piracy with Base.showable
_showable(a::AbstractVector{<:MIME}, @nospecialize(x)) = any(m -> showable(m, x), a)
_showable(m, @nospecialize(x)) = showable(m, x)

"""
A vector of MIME types (or vectors of MIME types) that IJulia will try to
render. IJulia will try to render every MIME type specified in the first level
of the vector. If a vector of MIME types is specified, IJulia will include only
the first MIME type that is renderable (this allows for the expression of
priority and exclusion of redundant data).

For example, since "text/plain" is specified as a first-child of the array,
IJulia will always try to include a "text/plain" representation of anything that
is displayed. Since markdown and html are specified within a sub-vector, IJulia
will always try to render "text/markdown", and will only try to render
"text/html" if markdown isn't possible.
"""
const ijulia_mime_types = Vector{Union{MIME, AbstractVector{MIME}}}([
    MIME("text/plain"),
    MIME("image/svg+xml"),
    [MIME("image/png"),MIME("image/jpeg")],
    [
        MIME("text/markdown"),
        MIME("text/html"),
    ],
    MIME("text/latex"),
])

"""
MIME types that when rendered (via stringmime) return JSON data. See
`ijulia_mime_types` for a description of how MIME types are selected.

This is necessary to embed the JSON as is in the displaydata bundle (rather than
as stringify'd JSON).
"""
const ijulia_jsonmime_types = Vector{Union{MIME, Vector{MIME}}}([
    [[MIME("application/vnd.vegalite.v$n+json") for n in 4:-1:2]...,
    [MIME("application/vnd.vega.v$n+json") for n in 5:-1:3]...],
    MIME("application/vnd.dataresource+json"), MIME("application/vnd.plotly.v1+json")
])

"""
    register_mime(x::Union{MIME, Vector{MIME}})
    register_mime(x::AbstractVector{<:MIME})

Register a new MIME type.
"""
register_mime(x::Union{MIME, Vector{MIME}}) = push!(ijulia_mime_types, x)
register_mime(x::AbstractVector{<:MIME}) = push!(ijulia_mime_types, Vector{MIME}(x))

"""
    register_jsonmime(x::Union{MIME, Vector{MIME}})
    register_jsonmime(x::AbstractVector{<:MIME})

Register a new JSON MIME type.
"""
register_jsonmime(x::Union{MIME, Vector{MIME}}) = push!(ijulia_jsonmime_types, x)
register_jsonmime(x::AbstractVector{<:MIME}) = push!(ijulia_jsonmime_types, Vector{MIME}(x))

# return a String=>Any dictionary to attach as metadata
# in Jupyter display_data and pyout messages
metadata(x) = Dict()
transient(x) = Dict()

"""
Generate the preferred MIME representation of x.

Returns a tuple with the selected MIME type and the representation of the data
using that MIME type.
"""
function display_mimestring(mime_array::Vector{MIME}, @nospecialize(x))
    for m in mime_array
        if _showable(m, x)
            return display_mimestring(m, x)
        end
    end
    error("No displayable MIME types in mime array.")
end

display_mimestring(m::MIME, @nospecialize(x)) = (m, limitstringmime(m, x))

# text/plain output must have valid Unicode data to display in Jupyter
function display_mimestring(m::MIME"text/plain", @nospecialize(x))
    s = limitstringmime(m, x)
    return m, (isvalid(s) ? s : "(binary data)")
end

"""
Generate the preferred json-MIME representation of x.

Returns a tuple with the selected MIME type and the representation of the data
using that MIME type (as a `JSONText`).
"""
function display_mimejson(mime_array::Vector{MIME}, x)
    for m in mime_array
        if _showable(m, x)
            return display_mimejson(m, x)
        end
    end
    error("No displayable MIME types in mime array.")
end

display_mimejson(m::MIME, x) = (m, JSONX.JSONText(limitstringmime(m, x, true)))

function _display_dict(@nospecialize(x))
    data = Dict{String, Union{String, JSONX.JSONText}}()
    for m in ijulia_mime_types
        if _showable(m, x)
            mime, mime_repr = display_mimestring(m, x)
            data[string(mime)] = mime_repr
        end
    end

    for m in ijulia_jsonmime_types
        try
            if _showable(m, x)
                mime, mime_repr = display_mimejson(m, x)
                data[string(mime)] = mime_repr
            end
        catch
        end
    end

    return data

end

"""
Generate a dictionary of `mime_type => data` pairs for all registered MIME
types. This is the format that Jupyter expects in `display_data` and
`execute_result` messages.
"""
display_dict(@nospecialize(x)) = _display_dict(x)

# remove x from the display queue
function undisplay(@nospecialize(x), kernel)
    # We do an explicit loop instead of calling findfirst() because findfirst()
    # ends up having a significant compile-time cost for complex types, and by
    # writing a loop we can despecialize the `x` argument. For types like Dict's
    # this removes ~0.5s from the display time.
    for i in eachindex(kernel.displayqueue)
        if isequal(x, kernel.displayqueue[i])
            splice!(kernel.displayqueue, i)
            break
        end
    end

    return x
end

import Base: ip_matches_func

# Scrub IJulia-related frames from backtrace, similar to Base.scrub_repl_backtrace
function scrub_backtrace(bt, top_func::Symbol=:include_string)
    # follow PR #17570 code in removing top_func from backtrace
    eval_ind = findlast(addr->ip_matches_func(addr, top_func), bt)
    !isnothing(eval_ind) ? bt[1:eval_ind-1] : bt
end

function scrub_backtrace(stack::Base.ExceptionStack, top_func::Symbol=:include_string)
    Base.ExceptionStack(Any[(; x.exception, backtrace=scrub_backtrace(x.backtrace, top_func)) for x in stack])
end

function custom_showerror(io, e, bt)
    showerror(io, e, bt; backtrace=false)
end

# return the content of a pyerr message for exception e
function error_content(e, bt=catch_backtrace();
                       backtrace_top::Symbol=:include_string,
                       msg::AbstractString="")
    # Use :stacktrace_types_limited to enable type abbreviation in backtraces (like the REPL does)
    limitflag = Ref(false)
    err_io_context = InlineIOContext(stderr, :stacktrace_types_limited => limitflag)

    tb = map(String, split(sprint(Base.show_backtrace,
                                  scrub_backtrace(bt, backtrace_top); context=err_io_context),
                           "\n", keepempty=true))
    if limitflag[]
        push!(tb, "Some type information was truncated. Use `show(err)` to see complete types.")
    end

    ename = string(typeof(e))
    evalue = try
        # Peel away one LoadError layer that comes from running include_string on the cell
        isa(e, LoadError) && (e = e.error)
        sprint((io, e, bt) -> @invokelatest(custom_showerror(io, e, bt)), e, bt; context=err_io_context)
    catch
        "SYSTEM: show(lasterr) caused an error"
    end
    pushfirst!(tb, evalue) # fperez says this needs to be in traceback too
    if !isempty(msg)
        pushfirst!(tb, msg)
    end

    # Specify the value type as Any because types other than String may be in
    # the returned JSON.
    Dict{String, Any}("ename" => ename, "evalue" => evalue,
                      "traceback" => tb)
end

#######################################################################

# Copy CondaPkg.toml to the test project so that it gets found by CondaPkg
# during the tests. If this was instead in the project directory it would also
# be used by CondaPkg outside of the tests, which we don't want.
cp(joinpath(@__DIR__, "CondaPkg.toml"), joinpath(dirname(Base.active_project()), "CondaPkg.toml"))

ENV["JULIA_CONDAPKG_ENV"] = "@ijulia-tests"
ENV["JULIA_CONDAPKG_VERBOSITY"] = -1

# If you're running the tests locally you could uncomment the two environment
# variables below. This will be a bit faster since it stops CondaPkg from
# re-resolving the environment each time (but you do need to run it at least
# once locally to initialize the `@ijulia-tests` environment).
# ENV["JULIA_PYTHONCALL_EXE"] = joinpath(Base.DEPOT_PATH[1], "conda_environments", "ijulia-tests", "bin", "python")
# ENV["JULIA_CONDAPKG_BACKEND"] = "Null"


using Test
import Sockets
import Sockets: listenany

import ZMQ
import PythonCall
import PythonCall: Py, pyimport, pyconvert, pytype, pystr

# A little bit of hackery to fix the version number sent by the client. See:
# https://github.com/jupyter/jupyter_client/pull/1054
jupyter_client_lib = pyimport("jupyter_client")
jupyter_client_lib.session.protocol_version = "5.4"

const BlockingKernelClient = jupyter_client_lib.BlockingKernelClient

import IJulia: Kernel
# These symbols are imported so that we can test that setproperty!(::Kernel)
# will propagate changes from the corresponding Kernel fields to the
# module-global variables.
import IJulia: ans, In, Out


function test_py_get!(get_func, result)
    try
        result[] = get_func(timeout=0)
        return true
    catch ex
        exception_type = pyconvert(String, ex.t.__name__)
        if exception_type != "Empty"
            rethrow()
        end

        return false
    end
end

function recursive_pyconvert(x)
    x_type = pyconvert(String, pytype(x).__name__)

    if x_type == "dict"
        x = pyconvert(Dict{String, Any}, x)
        for key in copy(keys(x))
            if x[key] isa Py
                x[key] = recursive_pyconvert(x[key])
            elseif x[key] isa PythonCall.PyDict
                x[key] = recursive_pyconvert(x[key].py)
            end
        end
    elseif x_type == "str"
        x = pyconvert(String, x)
    end

    return x
end

# Calling methods directly with `reply=true` on the BlockingKernelClient will
# cause a deadlock because the client will block the whole thread while polling
# the socket, which means that the thread will never enter a GC safepoint so any
# other code that happens to allocate will get blocked. Instead, we send
# requests by themselves and then poll the appropriate socket with `timeout=0`
# so that the Python code will never block and we never get into a deadlock.
function make_request(request_func, get_func, args...; wait=true, kwargs...)
    request_func(args...; kwargs..., reply=false)
    if !wait
        return nothing
    end

    result = Ref{Py}()
    timeout = haskey(ENV, "CI") ? 120 : 20
    if timedwait(() -> test_py_get!(get_func, result), timeout) == :timed_out
        error("Jupyter channel get timed out")
    end

    return recursive_pyconvert(result[])
end

kernel_info(client) = make_request(client.kernel_info, client.get_shell_msg)
comm_info(client) = make_request(client.comm_info, client.get_shell_msg)
history(client) = make_request(client.history, client.get_shell_msg)
shutdown(client; wait=true) = make_request(client.shutdown, client.get_control_msg; wait)
execute(client, code) = make_request(client.execute, client.get_shell_msg; code)
inspect(client, code) = make_request(client.inspect, client.get_shell_msg; code)
complete(client, code) = make_request(client.complete, client.get_shell_msg; code)
get_stdin_msg(client) = make_request(Returns(nothing), client.get_stdin_msg)
get_iopub_msg(client) = make_request(Returns(nothing), client.get_iopub_msg)

function get_iopub_msgtype(client, msg_type)
    while true
        msg = get_iopub_msg(client)
        if msg["header"]["msg_type"] == msg_type
            return msg
        end
    end
end

get_execute_result(client) = get_iopub_msgtype(client, "execute_result")
get_comm_close(client) = get_iopub_msgtype(client, "comm_close")
get_comm_msg(client) = get_iopub_msgtype(client, "comm_msg")

function msg_ok(msg)
    ok = msg["content"]["status"] == "ok"
    if !ok
        @error "Kernel is not ok" msg["content"]
    end

    return ok
end

msg_error(msg) = msg["content"]["status"] == "error"

function jupyter_client(f, profile)
    client = BlockingKernelClient()
    client.load_connection_info(profile)
    client.start_channels()

    try
        f(client)
    finally
        client.stop_channels()
    end
end

function run_precompile()
    profile = IJulia.create_profile(; key=IJulia._TEST_KEY)

    zmq_recv = """

    ZMQ.send_multipart(requests_socket, [only(idents), "<IDS|MSG>", signature, header, parent_header, metadata, content])
    ZMQ.recv_multipart(requests_socket, String)
    """

    Kernel(profile; capture_stdout=false, capture_stderr=false) do kernel
        jupyter_client(profile) do client
            println("# Kernel info")
            kernel_info(client)
            println(zmq_recv)

            println("# Completion request")
            complete(client, "mk")
            println(zmq_recv)

            println("# Execute `42`")
            execute(client, "42")
            println(zmq_recv)

            println("# Execute `?import`")
            execute(client, "?import")
            println(zmq_recv)

            println("""# Execute `error("foo")`""")
            execute(client, """error("foo")""")
            println(zmq_recv)

            println("# Get history")
            history(client)
            println(zmq_recv)

            println("# Get comm info")
            comm_info(client)
            println(zmq_recv)
        end
    end
end

# Uncomment this to run the precompilation workload
# run_precompile()

@testset "Kernel" begin
    profile = IJulia.create_profile(; key=IJulia._TEST_KEY)
    profile_kwargs = Dict([Symbol(key) => value for (key, value) in profile])
    profile_kwargs[:key] = pystr(profile_kwargs[:key]).encode()

    @testset "Pkg integration" begin
        Kernel(profile; capture_stdout=false, capture_stderr=false) do kernel
            stdout_pipe = Pipe()
            redirect_stdout(stdout_pipe) do
                IJulia.do_pkg_cmd("st")
            end
            close(stdout_pipe.in)
            stdout_str = read(stdout_pipe, String)
            @test contains(stdout_str, r"Status `.+Project.toml`")
        end
    end

    @testset "getproperty()/setproperty!()" begin
        # Test setting special fields that should be mirrored to global variables
        Kernel(profile; capture_stdout=false, capture_stderr=false) do kernel
            # Check that init() set Out/In appropriately
            @test In === kernel.In
            @test Out === kernel.Out

            for field in (:ans, :n, :In, :Out, :inited,)
                test_value = if field === :inited
                    true
                elseif field === :In
                    Dict{Int, String}()
                elseif field === :Out
                    Dict{Int, Any}()
                else
                    10
                end

                setproperty!(kernel, field, test_value)
                @test getproperty(IJulia, field) === test_value
                @test getproperty(kernel, field) === test_value

                # Sanity check that these fields are mirrored to Main correctly
                if field ∈ (:ans, :In, :Out)
                    @test getproperty(kernel.current_module, field) === test_value
                end
            end
        end
    end

    @testset "Explicit tests with jupyter_client" begin
        # Some of these tests have their own kernel instance to avoid
        # interfering with the state of other tests.

        # Test clear_history() and In/Out
        Kernel(profile; capture_stdout=false, capture_stderr=false) do kernel
            jupyter_client(profile) do client
                for i in 1:10
                    @test msg_ok(execute(client, "$(i)"))
                end
                @test length(In) == 10
                @test length(Out) == 10
                @test msg_ok(execute(client, "IJulia.clear_history(-1:5)"))
                @test Set(keys(kernel.In)) == Set(6:11) # The 11th entry is the call to clear_history()
                @test msg_ok(execute(client, "IJulia.clear_history()"))
                @test isempty(kernel.In)
                @test isempty(kernel.Out)
            end
        end

        # Test input
        Kernel(profile; capture_stdout=false, capture_stderr=false) do kernel
            jupyter_client(profile) do client
                # The input system in Jupyter is a bit convoluted. First we
                # make a request to the kernel:
                client.execute("readline()")
                # Then wait for readline(::IJuliaStdio) to send its own
                # `input_request` message on the stdin socket.
                @test msg_ok(get_stdin_msg(client))
                # Send an `input_reply` back
                client.input("foo")

                # Wait for the original `execute_request` to complete and
                # send an `execute_result` message with the 'input'.
                msg = get_execute_result(client)
                @test msg["content"]["data"]["text/plain"] == "\"foo\""
            end
        end


        # Revise integration
        Kernel(profile; capture_stdout=false, capture_stderr=false) do _
            jupyter_client(profile) do client
                @test length(IJulia._preexecute_hooks) == 1
                @test nameof(IJulia._preexecute_hooks[1]) == :revise_hook

                mktemp() do path, _
                    write(path, "foo() = 1")
                    code = """
                           using Revise
                           includet($(repr(path)))
                           """
                    @test msg_ok(execute(client, code))

                    # Test running the initial version of the code
                    client.execute("foo()")
                    msg = get_execute_result(client)
                    @test msg["content"]["data"]["text/plain"] == "1"

                    # Change the file and try again. Note that we allow multiple
                    # attempts because file events on Mac OS have a bit of
                    # latency so it might take some time for Revise to notice
                    # the update.
                    write(path, "foo() = 2")
                    ret = timedwait(10; pollint=0.5) do
                        client.execute("foo()")
                        msg = get_execute_result(client)
                        msg["content"]["data"]["text/plain"] == "2"
                    end
                    @test ret == :ok
                end
            end
        end

        shutdown_called = false
        Kernel(profile; capture_stdout=false, capture_stderr=false, shutdown=(_) -> shutdown_called = true) do kernel
            jupyter_client(profile) do client
                @testset "Comms" begin
                    # Try opening a Comm without a target_name, which should
                    # only trigger a comm_close message.
                    open_msg = IJulia.Msg(["foo"],
                                          Dict("username" => "user",
                                               "session" => "session1"),
                                          Dict("comm_id" => "foo",
                                               "data" => Dict()))
                    IJulia.comm_open(kernel.requests[], kernel, open_msg)
                    @test get_comm_close(client)["content"]["comm_id"] == "foo"

                    # Setting the target_name should cause the Comm to be created
                    open_msg.content["target_name"] = "foo"
                    IJulia.comm_open(kernel.requests[], kernel, open_msg)
                    @test kernel.comms["foo"] isa IJulia.Comm{:foo}

                    @test haskey(comm_info(client)["content"]["comms"], "foo")

                    # Smoke test for comm_msg (incoming to the kernel)
                    msg_msg = IJulia.Msg(["foo"],
                                         Dict("username" => "user",
                                              "session" => "session1"),
                                         Dict("comm_id" => "foo",
                                              "data" => Dict()))
                    IJulia.comm_msg(kernel.requests[], kernel, msg_msg)

                    # Test comm_msg (outgoing from the kernel)
                    IJulia.send_comm(kernel.comms["foo"], Dict(1 => 2))
                    @test get_comm_msg(client)["content"]["data"]["1"] == 2

                    # Test comm_close (outgoing from the kernel)
                    IJulia.close_comm(kernel.comms["foo"])
                    # Should this also delete the Comm from kernel.comms?
                    @test get_comm_close(client)["content"]["comm_id"] == "foo"

                    # Test comm_close (incoming to the kernel)
                    close_msg = IJulia.Msg(["foo"],
                                           Dict("username" => "user",
                                                "session" => "session1"),
                                           Dict("comm_id" => "foo",
                                                "data" => Dict()))
                    IJulia.comm_close(kernel.requests[], kernel, close_msg)
                    @test !haskey(kernel.comms, "foo")
                end

                # Test load()/load_string()
                mktemp() do path, _
                    write(path, "42")

                    msg = execute(client, "IJulia.load($(repr(path)))")
                    @test msg_ok(msg)
                    @test length(msg["content"]["payload"]) == 1
                end

                # Test hooks
                @testset "Hooks" begin
                    preexecute = false
                    postexecute = false
                    posterror = false
                    preexecute_hook = () -> preexecute = !preexecute
                    postexecute_hook = () -> postexecute = !postexecute
                    posterror_hook = () -> posterror = !posterror
                    IJulia.push_preexecute_hook(preexecute_hook)
                    IJulia.push_postexecute_hook(postexecute_hook)
                    IJulia.push_posterror_hook(posterror_hook)
                    @test msg_ok(execute(client, "42"))

                    # The pre/post hooks should've been called but not the posterror hook
                    @test preexecute
                    @test postexecute
                    @test !posterror

                    # With a throwing cell the posterror hook should be called
                    @test msg_error(execute(client, "error(42)"))
                    @test posterror

                    # After popping the hooks they should no longer be executed
                    preexecute = false
                    postexecute = false
                    posterror = false
                    IJulia.pop_preexecute_hook(preexecute_hook)
                    IJulia.pop_postexecute_hook(postexecute_hook)
                    IJulia.pop_posterror_hook(posterror_hook)
                    @test msg_ok(execute(client, "42"))
                    @test msg_error(execute(client, "error(42)"))
                    @test !preexecute
                    @test !postexecute
                    @test !posterror
                end

                # Smoke tests
                @test msg_ok(kernel_info(client))
                @test msg_ok(comm_info(client))
                @test msg_ok(history(client))
                @test msg_ok(execute(client, "IJulia.set_verbose(false)"))
                @test msg_ok(execute(client, "flush(stdout)"))

                # Test history(). This test requires `capture_stdout=false`.
                IJulia.clear_history()
                @test msg_ok(execute(client, "1"))
                @test msg_ok(execute(client, "42"))
                stdout_pipe = Pipe()
                redirect_stdout(stdout_pipe) do
                    IJulia.history()
                end
                close(stdout_pipe.in)
                @test collect(eachline(stdout_pipe)) == ["1", "42"]

                # Test that certain global variables are updated in kernel.current_module
                @test msg_ok(execute(client, "42"))
                @test msg_ok(execute(client, "ans == 42"))
                @test kernel.ans

                # Test an edge-case with displaying Type's:
                # https://github.com/JuliaLang/IJulia.jl/issues/1098
                @test msg_ok(execute(client, "Pair.body"))

                # Test shutdown_request
                @test msg_ok(shutdown(client))
                @test timedwait(() -> shutdown_called, 10) == :ok
            end
        end
    end

    @testset "jupyter_kernel_test" begin
        stdout_pipe = Pipe()
        stderr_pipe = Pipe()
        Base.link_pipe!(stdout_pipe)
        Base.link_pipe!(stderr_pipe)
        stdout_str = ""
        stderr_str = ""
        test_proc = nothing

        Kernel(profile; shutdown=Returns(nothing)) do kernel
            test_file = joinpath(@__DIR__, "kernel_test.py")

            mktemp() do connection_file, io
                # Write the connection file
                jupyter_client_lib.connect.write_connection_file(; fname=connection_file, profile_kwargs...)

                try
                    # Run jupyter_kernel_test
                    cmd = ignorestatus(`$(PythonCall.C.python_executable_path()) $(test_file)`)
                    cmd = addenv(cmd, "IJULIA_TESTS_CONNECTION_FILE" => connection_file)
                    cmd = pipeline(cmd; stdout=stdout_pipe, stderr=stderr_pipe)
                    test_proc = run(cmd)
                finally
                    close(stdout_pipe.in)
                    close(stderr_pipe.in)
                    stdout_str = read(stdout_pipe, String)
                    stderr_str = read(stderr_pipe, String)
                    close(stdout_pipe)
                    close(stderr_pipe)
                end
            end
        end

        if !isempty(stdout_str)
            @info "jupyter_kernel_test stdout:"
            println(stdout_str)
        end
        if !isempty(stderr_str)
            @info "jupyter_kernel_test stderr:"
            println(stderr_str)
        end
        if !success(test_proc)
            error("jupyter_kernel_test failed")
        end
    end

    # run_kernel() is the function that's actually run by Jupyter
    @testset "run_kernel()" begin
        julia = joinpath(Sys.BINDIR, "julia")

        mktemp() do connection_file, io
            # Write the connection file
            jupyter_client_lib.connect.write_connection_file(; fname=connection_file, profile_kwargs...)
            cmd = `$(Base.julia_cmd()) --project=$(Base.active_project()) -e 'import IJulia; IJulia.run_kernel()' $(connection_file)`
            kernel_proc = run(pipeline(cmd; stdout, stderr); wait=false)
            try
                jupyter_client(profile) do client
                    @test msg_ok(kernel_info(client))
                    @test msg_ok(execute(client, "42"))

                    # Note that we don't wait for a reply because the kernel
                    # will shut down almost immediately and it's not guaranteed
                    # we'll receive the reply. We also sleep for a bit to try to
                    # ensure that the shutdown message is sent.
                    shutdown(client; wait=false)
                    sleep(0.1)
                end

                @test timedwait(() -> process_exited(kernel_proc), 60) == :ok
            finally
                kill(kernel_proc)
            end
        end
    end
end

@testset "Python integration" begin
    profile = IJulia.create_profile(; key=IJulia._TEST_KEY)

    # These are mostly just smoke tests
    Kernel(profile; capture_stdout=false, capture_stderr=false) do kernel
        jupyter_client(profile) do client
            # Test ipywidgets
            @test msg_ok(execute(client, """
                    using PythonCall
                    IJulia.init_matplotlib()

                    ipywidgets = pyimport("ipywidgets")
                    slider = ipywidgets.IntSlider(value=5)
            """))

            # Check that we've registered some comms
            @test length(methods(IJulia.CommManager.register_comm)) == 3

            # Test matplotlib
            @test msg_ok(execute(client, """
                    plt = pyimport("matplotlib.pyplot")
                    plt.figure()
                    plt.plot([1, 2, 3], [1, 4, 2])
            """))
        end
    end

    @testset "Utilities" begin
        ext = Base.get_extension(IJulia, :IJuliaPythonCallExt)

        x = Dict(1 => Dict{Int, Any}(2 => [1, 2]), "foo" => "bar")
        ext.arrays_to_pylist!(x)
        @test x[1][2] isa Py
        @test x["foo"] == "bar"

        @test_logs (:error, r"has not been implemented") ext.PyComm.open(1)
        @test_logs (:error, r"has not been implemented") ext.PyCommManager.unregister_target(1)
    end
end

using Test
import IJulia
import IJulia: JSONX

@testset "installkernel" begin
    let kspec = IJulia.installkernel("ijuliatest", "-O3", "-p2",
                                     env=Dict("FOO"=>"yes"), specname="Yef1rLr4kXKxq9rbEh3m")
        try
            @test basename(kspec) == "Yef1rLr4kXKxq9rbEh3m"  # should not contain Julia version suffix
            @test dirname(kspec) == IJulia.kerneldir()
            @test isfile(joinpath(kspec, "kernel.json"))
            @test isfile(joinpath(kspec, "logo-32x32.png"))
            @test isfile(joinpath(kspec, "logo-64x64.png"))
            let k = JSONX.parsefile(joinpath(kspec, "kernel.json"))
                debugdesc = ccall(:jl_is_debugbuild,Cint,())==1 ? "-debug" : ""
                @test k["display_name"] == "ijuliatest $(VERSION.major).$(VERSION.minor)$(debugdesc)"
                @test k["argv"][end] == "{connection_file}"
                @test k["argv"][end-4:end-3] == ["-O3", "-p2"]
                @test k["language"] == "julia"
                @test k["env"]["FOO"] == "yes"
            end
        finally
            rm(kspec, force=true, recursive=true)
        end
    end

    let kspec = IJulia.installkernel("ahzAHZ019.-_ ~!@#%^&*()"; displayname="foo")
        try
            @test occursin("ahzahz019.-_-__________", basename(kspec))

            let k = JSONX.parsefile(joinpath(kspec, "kernel.json"))
                @test k["display_name"] == "foo"
            end
        finally
            rm(kspec, force=true, recursive=true)
        end
    end

    # Smoke test the default Julia binary path
    julia_exe = IJulia.exe("julia")
    @test IJulia.julia_cmd("bin") == `$(joinpath("bin", julia_exe))`
end

# Copied from:
# https://github.com/JuliaIO/JSON.jl/tree/b2787c38d18aa5a6828eefabc8d4f4726e1c09e7/vendor


module JSONX

"""
    JSONX.parse(json_str::String)
    JSONX.parse(bytes::AbstractVector{UInt8})

Parse a JSON string or byte array and return a Julia value.
Returns one of: Dict{String, Any}, Vector{Any}, String, Int64, Float64, Bool, or Nothing.
Numbers without decimal points or exponents are parsed as Int64, falling back to Float64 on overflow.
"""
function parse(json_str::String)
    pos = 1
    len = ncodeunits(json_str)
    pos = skip_whitespace(json_str, pos, len)
    pos > len && throw(ArgumentError("Empty or whitespace-only JSON"))
    result, new_pos = parse_value(json_str, pos, len)
    new_pos = skip_whitespace(json_str, new_pos, len)
    new_pos <= len && throw(ArgumentError("Trailing content after JSON"))
    return result
end

parse(bytes::AbstractVector{UInt8}) = parse(String(bytes))

"""
    JSONX.parsefile(filename::String)

Parse a JSON file and return a Julia value.
"""
parsefile(filename::String) = parse(read(filename, String))

"""
    JSONX.json(value)

Convert a Julia value to a JSON string.
Supports: AbstractDict, NamedTuple, AbstractVector, AbstractSet, Tuple, AbstractString, Number, Bool, Nothing, Missing.
"""
function json(value)
    io = IOBuffer()
    write_json(io, value)
    return String(take!(io))
end

# Helper function to skip whitespace
function skip_whitespace(str::String, pos::Int, len::Int)
    while pos <= len && isspace(Char(codeunit(str, pos)))
        pos += 1
    end
    return pos
end

# Unicode handling functions (adapted from JSON.jl)
utf16_is_surrogate(c::UInt16) = (c & 0xf800) == 0xd800
utf16_get_supplementary(lead::UInt16, trail::UInt16) = Char(UInt32(lead-0xd7f7)<<10 + trail)

function reverseescapechar(b)
    b == UInt8('"')  && return UInt8('"')
    b == UInt8('\\') && return UInt8('\\')
    b == UInt8('/')  && return UInt8('/')
    b == UInt8('b')  && return UInt8('\b')
    b == UInt8('f')  && return UInt8('\f')
    b == UInt8('n')  && return UInt8('\n')
    b == UInt8('r')  && return UInt8('\r')
    b == UInt8('t')  && return UInt8('\t')
    return 0x00
end

function unescape_string(str::String, start_pos::Int, end_pos::Int)
    # Unescape the string (we know it needs unescaping when this is called)
    io = IOBuffer()
    pos = start_pos
    while pos < end_pos
        c = codeunit(str, pos)
        if c == UInt8('\\')
            pos += 1
            pos >= end_pos && throw(ArgumentError("Unexpected end of input in string"))
            esc_c = codeunit(str, pos)
            if esc_c == UInt8('u')
                # Unicode escape sequence
                pos + 4 >= end_pos && throw(ArgumentError("Incomplete Unicode escape"))
                # Parse 4 hex digits
                c = UInt16(0)
                for offset in 1:4
                    bb = codeunit(str, pos + offset)
                    nv = if UInt8('0') <= bb <= UInt8('9')
                             bb - UInt8('0')
                         elseif UInt8('A') <= bb <= UInt8('F')
                             bb - (UInt8('A') - 10)
                         elseif UInt8('a') <= bb <= UInt8('f')
                             bb - (UInt8('a') - 10)
                         else
                             throw(ArgumentError("Invalid Unicode escape"))
                         end
                    c = (c << 4) + UInt16(nv)
                end
                pos += 4
                
                if utf16_is_surrogate(c)
                    # Check for surrogate pair
                    if pos + 6 < end_pos && codeunit(str, pos + 1) == UInt8('\\') && codeunit(str, pos + 2) == UInt8('u')
                        # Parse next 4 hex digits
                        c2 = UInt16(0)
                        for offset in 3:6
                            bb = codeunit(str, pos + offset)
                            nv = if UInt8('0') <= bb <= UInt8('9')
                                     bb - UInt8('0')
                                 elseif UInt8('A') <= bb <= UInt8('F')
                                     bb - (UInt8('A') - 10)
                                 elseif UInt8('a') <= bb <= UInt8('f')
                                     bb - (UInt8('a') - 10)
                                 else
                                     throw(ArgumentError("Invalid Unicode escape"))
                                 end
                            c2 = (c2 << 4) + UInt16(nv)
                        end
                        if utf16_is_surrogate(c2)
                            # Valid surrogate pair
                            ch = utf16_get_supplementary(c, c2)
                            print(io, ch)
                            pos += 6
                        else
                            # Invalid trailing surrogate, treat lead as lone
                            ch = Char(c)
                            print(io, ch)
                        end
                    else
                        # Lone surrogate - this is valid, just emit the character
                        ch = Char(c)
                        print(io, ch)
                    end
                else
                    # Non-surrogate Unicode
                    ch = Char(c)
                    print(io, ch)
                end
            else
                # Simple escape sequence
                b = reverseescapechar(esc_c)
                b == 0x00 && throw(ArgumentError("Invalid escape sequence \\$(Char(esc_c))"))
                print(io, Char(b))
            end

            pos += 1
        else
            # Regular character
            print(io, str[pos])
            pos = nextind(str, pos)
        end

    end
    return String(take!(io))
end

# Parse-related functionality
function parse_value(str::String, pos::Int, len::Int)
    pos > len && throw(ArgumentError("Unexpected end of input"))
    c = codeunit(str, pos)
    if c == UInt8('{')
        return parse_object(str, pos, len)
    elseif c == UInt8('[')
        return parse_array(str, pos, len)
    elseif c == UInt8('"')
        return parse_string(str, pos, len)
    elseif c == UInt8('n') && pos + 3 <= len && codeunit(str, pos + 1) == UInt8('u') && codeunit(str, pos + 2) == UInt8('l') && codeunit(str, pos + 3) == UInt8('l')
        return nothing, pos + 4
    elseif c == UInt8('t') && pos + 3 <= len && codeunit(str, pos + 1) == UInt8('r') && codeunit(str, pos + 2) == UInt8('u') && codeunit(str, pos + 3) == UInt8('e')
        return true, pos + 4
    elseif c == UInt8('f') && pos + 4 <= len && codeunit(str, pos + 1) == UInt8('a') && codeunit(str, pos + 2) == UInt8('l') && codeunit(str, pos + 3) == UInt8('s') && codeunit(str, pos + 4) == UInt8('e')
        return false, pos + 5
    elseif c == UInt8('-') || (UInt8('0') <= c <= UInt8('9'))
        return parse_number(str, pos, len)
    else
        throw(ArgumentError("Invalid JSON value starting at position $pos"))
    end
end

function parse_object(str::String, pos::Int, len::Int)
    codeunit(str, pos) != UInt8('{') && throw(ArgumentError("Expected '{' at position $pos"))
    pos += 1
    result = Dict{String, Any}()
    pos = skip_whitespace(str, pos, len)
    pos > len && throw(ArgumentError("Unexpected end of input in object"))
    codeunit(str, pos) == UInt8('}') && return result, pos + 1
    while true
        codeunit(str, pos) != UInt8('"') && throw(ArgumentError("Expected '\"' at position $pos"))
        key, pos = parse_string(str, pos, len)
        pos = skip_whitespace(str, pos, len)
        (pos > len || codeunit(str, pos) != UInt8(':')) && throw(ArgumentError("Expected ':' at position $pos"))
        pos += 1
        pos = skip_whitespace(str, pos, len)
        pos > len && throw(ArgumentError("Unexpected end of input in object"))
        value, pos = parse_value(str, pos, len)
        result[key] = value
        pos = skip_whitespace(str, pos, len)
        pos > len && throw(ArgumentError("Unexpected end of input in object"))
        if codeunit(str, pos) == UInt8('}')
            return result, pos + 1
        elseif codeunit(str, pos) == UInt8(',')
            pos += 1
            pos = skip_whitespace(str, pos, len)
        else
            throw(ArgumentError("Expected ',' or '}' at position $pos"))
        end
    end
end

function parse_array(str::String, pos::Int, len::Int)
    codeunit(str, pos) != UInt8('[') && throw(ArgumentError("Expected '[' at position $pos"))
    pos += 1
    result = []
    pos = skip_whitespace(str, pos, len)
    pos > len && throw(ArgumentError("Unexpected end of input in array"))
    codeunit(str, pos) == UInt8(']') && return result, pos + 1
    while true
        value, pos = parse_value(str, pos, len)
        push!(result, value)
        pos = skip_whitespace(str, pos, len)
        pos > len && throw(ArgumentError("Unexpected end of input in array"))
        if codeunit(str, pos) == UInt8(']')
            return result, pos + 1
        elseif codeunit(str, pos) == UInt8(',')
            pos += 1
            pos = skip_whitespace(str, pos, len)
            pos <= len && codeunit(str, pos) == UInt8(']') && throw(ArgumentError("Trailing comma not allowed in JSON"))
        else
            throw(ArgumentError("Expected ',' or ']' at position $pos"))
        end
    end
end

function parse_string(str::String, pos::Int, len::Int)
    codeunit(str, pos) != UInt8('"') && throw(ArgumentError("Expected '\"' at position $pos"))
    pos += 1
    start_pos = pos
    needs_unescape = false
    while pos <= len
        c = codeunit(str, pos)
        if c == UInt8('"')
            return needs_unescape ? unescape_string(str, start_pos, pos) : GC.@preserve(str, unsafe_string(pointer(str, start_pos), pos - start_pos)), pos + 1
        elseif c == UInt8('\\')
            needs_unescape = true
            pos += 1
            pos > len && throw(ArgumentError("Unexpected end of input in string"))
            esc_c = codeunit(str, pos)
            if esc_c == UInt8('"') || esc_c == UInt8('\\') || esc_c == UInt8('/') || esc_c == UInt8('b') || esc_c == UInt8('f') || esc_c == UInt8('n') || esc_c == UInt8('r') || esc_c == UInt8('t') || esc_c == UInt8('u')
                # Valid escape sequence, continue
            else
                throw(ArgumentError("Invalid escape sequence \\$(Char(esc_c))"))
            end
        elseif Int(c) < 0x20
            throw(ArgumentError("Control character in string"))
        end
        pos += 1
    end
    throw(ArgumentError("Unterminated string"))
end

function parse_number(str::String, pos::Int, len::Int)
    start_pos = pos
    has_decimal_or_exp = false
    while pos <= len
        c = codeunit(str, pos)
        if c == UInt8('-') || (UInt8('0') <= c <= UInt8('9')) || c == UInt8('+')
            pos += 1
        elseif c == UInt8('.') || c == UInt8('e') || c == UInt8('E')
            has_decimal_or_exp = true
            pos += 1
        else
            break
        end
    end
    num_str = @view str[start_pos:pos-1]

    # Try parsing as Int64 if no decimal point or exponent
    if !has_decimal_or_exp
        try
            return Base.parse(Int64, num_str), pos
        catch
            # Fall back to Float64 if Int64 parsing fails (e.g., overflow)
        end
    end

    # Parse as Float64
    try
        return Base.parse(Float64, num_str), pos
    catch
        throw(ArgumentError("Invalid number format"))
    end
end

# JSON writing functionality

struct JSONText
    text::String
end

function write_json(io::IO, value)
    if value === nothing || value === missing
        print(io, "null")
    elseif value isa Bool
        print(io, value ? "true" : "false")
    elseif value isa Number
        value isa Complex && throw(ArgumentError("Cannot serialize Complex numbers to JSON"))
        print(io, value)
    elseif value isa JSONText
        print(io, value.text)
    elseif value isa AbstractString
        write_string(io, value)
    elseif value isa AbstractVector || value isa AbstractSet || value isa Tuple
        write_array(io, value)
    elseif value isa AbstractDict || value isa NamedTuple
        write_object(io, value)
    elseif value isa Symbol || value isa Enum
        write_string(io, string(value))
    else
        throw(ArgumentError("Cannot serialize $(typeof(value)) to JSON"))
    end
end

function write_string(io::IO, str::AbstractString)
    print(io, '"')
    for c in str
        if c == '"'
            print(io, "\\\"")
        elseif c == '\\'
            print(io, "\\\\")
        elseif c == '\b'
            print(io, "\\b")
        elseif c == '\f'
            print(io, "\\f")
        elseif c == '\n'
            print(io, "\\n")
        elseif c == '\r'
            print(io, "\\r")
        elseif c == '\t'
            print(io, "\\t")
        elseif Int(c) < 0x20
            print(io, "\\u", string(Int(c), base=16, pad=4))
        else
            print(io, c)
        end
    end
    print(io, '"')
end

function write_array(io::IO, arr::Union{AbstractVector, AbstractSet, Tuple})
    print(io, '[')
    for (i, item) in enumerate(arr)
        i > 1 && print(io, ',')
        write_json(io, item)
    end
    print(io, ']')
end

function write_object(io::IO, dict::Union{AbstractDict, NamedTuple})
    print(io, '{')
    first = true
    for (key, value) in pairs(dict)
        !first && print(io, ',')
        first = false
        write_string(io, string(key))
        print(io, ':')
        write_json(io, value)
    end
    print(io, '}')
end

end # module

"""
Struct to dispatch on for inline display.
"""
struct InlineDisplay <: AbstractDisplay end

"""
Supported MIME types for inline display in IPython, in descending order
of preference (descending "richness").
"""
const ipy_mime = [
    "application/vnd.dataresource+json",
    ["application/vnd.vegalite.v$n+json" for n in 4:-1:2]...,
    ["application/vnd.vega.v$n+json" for n in 5:-1:3]...,
    "application/vnd.plotly.v1+json",
    "text/html",
    "text/latex",
    "image/svg+xml",
    "image/png",
    "image/jpeg",
    "text/plain",
    "text/markdown",
    "application/javascript"
]

"""
Need special handling for showing a string as a textmime type, since in that
case the string is assumed to be raw data unless it is text/plain.
"""
israwtext(m::MIME, x::AbstractString) = !showable(m, x)
israwtext(::MIME"text/plain", x::AbstractString) = false
israwtext(::MIME, x) = false

"""
    InlineIOContext(io, KVs::Pair...)

Create an `IOContext` for inline display.
"""
InlineIOContext(io, KVs::Pair...) = IOContext(
    io,
    :limit=>true, :color=>true, :jupyter=>true,
    KVs...
)

"""
    limitstringmime(mime::MIME, x, forcetext=false)

Convert x to a string of type mime, making sure to use an IOContext that tells
the underlying show function to limit output.
"""
function limitstringmime(mime::MIME, @nospecialize(x), forcetext=false)
    buf = IOBuffer()
    if forcetext || istextmime(mime)
        if israwtext(mime, x)
            return String(x)
        else
            show(InlineIOContext(buf), mime, x)
        end
    else
        b64 = Base64EncodePipe(buf)
        if isa(x, Vector{UInt8})
            write(b64, x) # x assumed to be raw binary data
        else
            show(InlineIOContext(b64), mime, x)
        end
        close(b64)
    end
    return String(take!(buf))
end

for mime in ipy_mime
    @eval begin
        function Base.display(d::InlineDisplay, ::MIME{Symbol($mime)}, @nospecialize(x))
            kernel = get_kernel_or_error()

            flush_all() # so that previous stream output appears in order
            send_ipython(kernel.publish[], kernel,
                         msg_pub(kernel.execute_msg, "display_data",
                                 Dict(
                                  "metadata" => metadata(x), # optional
                                  "transient" => transient(x), # optional
                                  "data" => Dict($mime => limitstringmime(MIME($mime), x)))))
        end
        Base.displayable(d::InlineDisplay, ::MIME{Symbol($mime)}) = true
    end
end

# deal with annoying application/x-latex == text/latex synonyms
Base.display(d::InlineDisplay, m::MIME"application/x-latex", @nospecialize(x)) = display(d, MIME("text/latex"), limitstringmime(m, x))

# deal with annoying text/javascript == application/javascript synonyms
Base.display(d::InlineDisplay, m::MIME"text/javascript", @nospecialize(x)) = display(d, MIME("application/javascript"), limitstringmime(m, x))

# If the user explicitly calls display("foo/bar", x), we send
# the display message, also sending text/plain for text data.
Base.displayable(d::InlineDisplay, M::MIME) = istextmime(M)
function Base.display(d::InlineDisplay, M::MIME, @nospecialize(x))
    kernel = get_kernel_or_error()

    sx = limitstringmime(M, x)
    d = Dict(string(M) => sx)
    if istextmime(M)
        d["text/plain"] = sx # directly show text data, e.g. text/csv
    end
    flush_all() # so that previous stream output appears in order
    send_ipython(kernel.publish[], kernel,
                 msg_pub(kernel.execute_msg, "display_data",
                         Dict("metadata" => metadata(x), # optional
                              "transient" => transient(x), # optional
                              "data" => d)))
end

# override display to send IPython a dictionary of all supported
# output types, so that IPython can choose what to display.
function Base.display(d::InlineDisplay, @nospecialize(x))
    kernel = get_kernel_or_error()

    undisplay(x, kernel) # dequeue previous redisplay(x)
    flush_all() # so that previous stream output appears in order
    send_ipython(kernel.publish[], kernel,
                 msg_pub(kernel.execute_msg, "display_data",
                         Dict("metadata" => metadata(x), # optional
                              "transient" => transient(x), # optional
                              "data" => display_dict(x))))
end

# we overload redisplay(d, x) to add x to a queue of objects to display,
# with the actual display occurring when display() is called or when
# an input cell has finished executing.
function Base.redisplay(d::InlineDisplay, x)
    kernel = get_kernel_or_error()
    if !in(x, kernel.displayqueue)
        push!(kernel.displayqueue, x)
    end
end

function flush_kernel_display(kernel::Kernel)
    q = copy(kernel.displayqueue)
    empty!(kernel.displayqueue) # so that undisplay in display(x) is no-op
    for x in q
        display(x, kernel)
    end
end

using Test
using IJulia

@testset "stdio" begin
    kernel = IJulia.Kernel()
    # Set _default_kernel so that flush(::IJuliaStdio) works
    IJulia._default_kernel = kernel

    mktemp() do path, io
        redirect_stdout(IJulia.IJuliaStdio(io, "stdout")) do
            println(Base.stdout, "stdout")
            println("print")
        end
        flush(io)
        seek(io, 0)
        @test read(io, String) == "stdout\nprint\n"
    end

    mktemp() do path, io
        redirect_stderr(IJulia.IJuliaStdio(io, "stderr")) do
            println(Base.stderr, "stderr")
        end
        flush(io)
        seek(io, 0)
        @test read(io, String) == "stderr\n"
    end

    mktemp() do path, io
        redirect_stdin(IJulia.IJuliaStdio(io, "stdin")) do
            # We can't actually do anything here because `IJuliaexecute_msg` has not
            # yet been initialized, so we just make sure that redirect_stdin does
            # not error.
        end
    end

    kernel.stdio_bytes = 42
    IJulia.reset_stdio_count(kernel)
    @test kernel.stdio_bytes == 0

    # Test that the IJuliaStdio object is deepcopy-able. See:
    # https://github.com/JuliaLang/IJulia.jl/issues/1179
    mktemp() do path, io
        deepcopy(IJulia.IJuliaStdio(io, "stdout"))
    end

    IJulia._default_kernel = nothing
end

import PrecompileTools: @compile_workload

# This key is used by the tests and precompilation workload to keep some
# consistency in the message signatures.
const _TEST_KEY = "a0436f6c-1916-498b-8eb9-e81ab9368e84"

# How to update the precompilation workload:
# 1. Uncomment the `@show` expressions in `recv_ipython()` in msg.jl.
# 2. Uncomment the call to `run_precompile()` in tests/kernel.jl (and comment
#    out the rest of the tests if you like).
# 3. When the `run_precompile()` runs it will print out the contents of the
#    received messages as strings. You can copy these verbatim into the
#    precompilation workload below. Note that if you modify any step of the
#    workload you will need to update *all* the messages to ensure they have the
#    right parent headers/signatures.
@compile_workload begin
    local profile = create_profile(45_000; key=_TEST_KEY)

    __init__()

    mktemp() do path, io
        write(io, JSONX.json(profile))
        flush(io)

        Kernel(path; capture_stdout=true, capture_stderr=false, capture_stdin=false) do kernel
            # Connect as a client to the kernel
            requests_socket = ZMQ.Socket(ZMQ.DEALER)
            ip = profile["ip"]
            port = profile["shell_port"]
            ZMQ.connect(requests_socket, "tcp://$(ip):$(port)")

            # Kernel info
            idents = ["626c4427-479d61edd6b98ccca470f2d6"]
            signature = "306b616a72292e9a736fe42b3c7d6fd51e10653ea2c5bc8f33810a06d33df8b5"
            header = "{\"msg_id\": \"626c4427-479d61edd6b98ccca470f2d6_3346283_0\", \"msg_type\": \"kernel_info_request\", \"username\": \"james\", \"session\": \"626c4427-479d61edd6b98ccca470f2d6\", \"date\": \"2025-11-02T18:59:07.097698Z\", \"version\": \"5.4\"}"
            parent_header = "{}"
            metadata = "{}"
            content = "{}"

            ZMQ.send_multipart(requests_socket, [only(idents), "<IDS|MSG>", signature, header, parent_header, metadata, content])
            ZMQ.recv_multipart(requests_socket, String)

            # Completion request
            idents = ["626c4427-479d61edd6b98ccca470f2d6"]
            signature = "721d3988d167417f9f0f03a823d3870470a5d924184a9a07dff422d8993eefa8"
            header = "{\"msg_id\": \"626c4427-479d61edd6b98ccca470f2d6_3346283_1\", \"msg_type\": \"complete_request\", \"username\": \"james\", \"session\": \"626c4427-479d61edd6b98ccca470f2d6\", \"date\": \"2025-11-02T18:59:07.587641Z\", \"version\": \"5.4\"}"
            parent_header = "{}"
            metadata = "{}"
            content = "{\"code\": \"mk\", \"cursor_pos\": 2}"

            ZMQ.send_multipart(requests_socket, [only(idents), "<IDS|MSG>", signature, header, parent_header, metadata, content])
            ZMQ.recv_multipart(requests_socket, String)

            # Execute `42`
            idents = ["626c4427-479d61edd6b98ccca470f2d6"]
            signature = "01e135a939f00a11708ca906c6a16ce1226ad07669b7dad49c12c4b792ef6242"
            header = "{\"msg_id\": \"626c4427-479d61edd6b98ccca470f2d6_3346283_2\", \"msg_type\": \"execute_request\", \"username\": \"james\", \"session\": \"626c4427-479d61edd6b98ccca470f2d6\", \"date\": \"2025-11-02T18:59:14.947227Z\", \"version\": \"5.4\"}"
            parent_header = "{}"
            metadata = "{}"
            content = "{\"code\": \"42\", \"silent\": false, \"store_history\": true, \"user_expressions\": {}, \"allow_stdin\": true, \"stop_on_error\": true}"

            ZMQ.send_multipart(requests_socket, [only(idents), "<IDS|MSG>", signature, header, parent_header, metadata, content])
            ZMQ.recv_multipart(requests_socket, String)

            # Execute `?import`
            idents = ["626c4427-479d61edd6b98ccca470f2d6"]
            signature = "a0fc54c9ed7250e8a151a766c7293843a1b8f91b1d766579a4761c18f34862df"
            header = "{\"msg_id\": \"626c4427-479d61edd6b98ccca470f2d6_3346283_3\", \"msg_type\": \"execute_request\", \"username\": \"james\", \"session\": \"626c4427-479d61edd6b98ccca470f2d6\", \"date\": \"2025-11-02T18:59:15.621963Z\", \"version\": \"5.4\"}"
            parent_header = "{}"
            metadata = "{}"
            content = "{\"code\": \"?import\", \"silent\": false, \"store_history\": true, \"user_expressions\": {}, \"allow_stdin\": true, \"stop_on_error\": true}"

            ZMQ.send_multipart(requests_socket, [only(idents), "<IDS|MSG>", signature, header, parent_header, metadata, content])
            ZMQ.recv_multipart(requests_socket, String)

            # Execute `error("foo")`
            idents = ["626c4427-479d61edd6b98ccca470f2d6"]
            signature = "7c7810bce6ff448c3ad8b0c928822d03ad8baf838e417ea5c29ec620a2cc36a7"
            header = "{\"msg_id\": \"626c4427-479d61edd6b98ccca470f2d6_3346283_4\", \"msg_type\": \"execute_request\", \"username\": \"james\", \"session\": \"626c4427-479d61edd6b98ccca470f2d6\", \"date\": \"2025-11-02T18:59:18.648766Z\", \"version\": \"5.4\"}"
            parent_header = "{}"
            metadata = "{}"
            content = "{\"code\": \"error(\\\"foo\\\")\", \"silent\": false, \"store_history\": true, \"user_expressions\": {}, \"allow_stdin\": true, \"stop_on_error\": true}"

            ZMQ.send_multipart(requests_socket, [only(idents), "<IDS|MSG>", signature, header, parent_header, metadata, content])
            ZMQ.recv_multipart(requests_socket, String)

            # Get history
            idents = ["626c4427-479d61edd6b98ccca470f2d6"]
            signature = "1d4bc84a2efb28efa0e8efe8eba32bc6b84decfd55d95e765b062a1adae2ae62"
            header = "{\"msg_id\": \"626c4427-479d61edd6b98ccca470f2d6_3346283_5\", \"msg_type\": \"history_request\", \"username\": \"james\", \"session\": \"626c4427-479d61edd6b98ccca470f2d6\", \"date\": \"2025-11-02T18:59:18.813677Z\", \"version\": \"5.4\"}"
            parent_header = "{}"
            metadata = "{}"
            content = "{\"raw\": true, \"output\": false, \"hist_access_type\": \"range\", \"session\": 0, \"start\": 0}"

            ZMQ.send_multipart(requests_socket, [only(idents), "<IDS|MSG>", signature, header, parent_header, metadata, content])
            ZMQ.recv_multipart(requests_socket, String)

            # Get comm info
            idents = ["626c4427-479d61edd6b98ccca470f2d6"]
            signature = "ff8e9a57a81f5cbdebd12a34a09aad953d63e24e0c866fc3af936a4ef764a181"
            header = "{\"msg_id\": \"626c4427-479d61edd6b98ccca470f2d6_3346283_6\", \"msg_type\": \"comm_info_request\", \"username\": \"james\", \"session\": \"626c4427-479d61edd6b98ccca470f2d6\", \"date\": \"2025-11-02T18:59:18.953835Z\", \"version\": \"5.4\"}"
            parent_header = "{}"
            metadata = "{}"
            content = "{}"

            ZMQ.send_multipart(requests_socket, [only(idents), "<IDS|MSG>", signature, header, parent_header, metadata, content])
            ZMQ.recv_multipart(requests_socket, String)

            close(requests_socket)
        end
    end

    # Clear global variables
    empty!(_preexecute_hooks)
    empty!(_postexecute_hooks)
    empty!(_posterror_hooks)
end

# This function is executed by Jupyter so make sure that it's precompiled
precompile(run_kernel, ())

# Precompile all the handlers
for f in values(handlers)
    precompile(f, (ZMQ.Socket, Kernel, Msg))
end

# Spawn a thread (using pthreads on Unix/OSX and Windows threads on Windows)
# to implement the "heartbeat" message channel, which is just a ZMQ
# socket that echoes all messages.  This is implemented with the zmq_proxy
# call in libzmq, which simply blocks forever, so the usual lack of
# thread safety in Julia should not be an issue here.

# entry point for new thread
function heartbeat_thread(heartbeat::Ptr{Cvoid})
    # Julia automatically "adopts" this thread because
    # we entered a Julia cfunction.  We then have to enable
    # a GC "safe" region to prevent us from grabbing the
    # GC lock with the call to zmq_proxy, which never returns.
    # (see julia#47196, julia#46609)
    ccall(:jl_gc_safe_enter, Int8, ())
    ret = ZMQ.lib.zmq_proxy(heartbeat, heartbeat, C_NULL)
    # leave safe region if zmq_proxy returns (when context is closed)
    ccall(:jl_gc_safe_leave, Int8, ())
    return ret
end

function start_heartbeat(kernel)
    heartbeat = kernel.heartbeat[]
    heartbeat.linger = 0
    heartbeat_c = @cfunction(heartbeat_thread, Cint, (Ptr{Cvoid},))
    ccall(:uv_thread_create, Cint, (Ptr{Int}, Ptr{Cvoid}, Ptr{Cvoid}),
          kernel.heartbeat_threadid, heartbeat_c, heartbeat)
end

module IJuliaReviseExt

import IJulia
import Revise
import PrecompileTools: @compile_workload

function revise_hook()
    kernel = IJulia._default_kernel
    if isnothing(kernel)
        return
    end

    # This first time this function is called will be during execution of the
    # first cell, when it's impossible that any other packages have been loaded
    # except for IJulia and those in the startup files. Thus, it's very unlikely
    # that we actually need to call Revise.revise() and so we skip it if
    # possible to avoid compilation latency.
    if !isempty(Revise.revision_queue)
        # Inference barrier to prevent invalidations
        @invokelatest Revise.revise()
    end
end

function __init__()
    if @ccall(jl_generating_output()::Cint) == 0 && get(ENV, "JULIA_REVISE", "auto") == "auto"
        IJulia.push_preexecute_hook(revise_hook)
    end
end

@compile_workload begin
    revise_hook()
    Revise.revise()
end

end

import Base.show

export Msg, msg_pub, msg_reply, send_status, send_ipython

"""
    msg_header(m::Msg, msg_type::String)

Create a header for a [`Msg`](@ref).
"""
msg_header(m::Msg, msg_type::String) = Dict("msg_id" => uuid4(),
                                            "username" => m.header["username"],
                                            "session" => m.header["session"],
                                            "date" => format(now(UTC), ISODateTimeFormat)*"Z",
                                            "msg_type" => msg_type,
                                            "version" => "5.4")

Base.VersionNumber(m::Msg) = VersionNumber(m.header["version"])::VersionNumber

# PUB/broadcast messages use the msg_type as the ident, except for
# stream messages which use the stream name (e.g. "stdout").
# [According to minrk, "this isn't well defined, or even really part
# of the spec yet" and is in practice currently ignored since "all
# subscribers currently subscribe to all topics".]
msg_pub(m::Msg, msg_type, content, metadata=Dict{String,Any}(), buffers=Vector{UInt8}[]) =
  Msg([ msg_type == "stream" ? content["name"] : msg_type ],
      msg_header(m, msg_type), content, m.header, metadata, buffers)

msg_reply(m::Msg, msg_type, content, metadata=Dict{String,Any}()) =
  Msg(m.idents, msg_header(m, msg_type), merge(Dict("status" => "ok"), content), m.header, metadata)

function show(io::IO, msg::Msg)
    print(io, "IPython Msg [ idents ")
    print(io, join(msg.idents, ", "))
    print(io, " ] {\n  parent_header = $(msg.parent_header),\n  header = $(msg.header),\n  metadata = $(msg.metadata),\n  content = $(msg.content)\n}")
end

"""
    send_ipython(socket, kernel, m::Msg)

Send a message `m`. This will lock `socket`.
"""
function send_ipython(socket::ZMQ.Socket, kernel::Kernel, m::Msg)
    lock(kernel.socket_locks[socket])
    try
        @vprintln("SENDING ", m)
        for i in m.idents
            send(socket, i, more=true)
        end
        send(socket, "<IDS|MSG>", more=true)
        header = JSONX.json(m.header)
        parent_header = JSONX.json(m.parent_header)
        metadata = JSONX.json(m.metadata)
        content = JSONX.json(m.content)
        send(socket, hmac(header, parent_header, metadata, content, kernel), more=true)
        send(socket, header, more=true)
        send(socket, parent_header, more=true)
        send(socket, metadata, more=true)
        send(socket, content, more=!isempty(m.buffers))
        ZMQ.send_multipart(socket, m.buffers)
    finally
        unlock(kernel.socket_locks[socket])
    end
end

"""
    recv_ipython(socket, kernel)

Wait for and get a message. This will lock `socket`.
"""
function recv_ipython(socket::ZMQ.Socket, kernel::Kernel)
    lock(kernel.socket_locks[socket])
    try
        idents = String[]
        s = recv(socket, String)
        @vprintln("got msg part $s")
        while s != "<IDS|MSG>"
            push!(idents, s)
            s = recv(socket, String)
            @vprintln("got msg part $s")
        end
        signature = recv(socket, String)
        header = recv(socket, String)
        parent_header = recv(socket, String)
        metadata = recv(socket, String)
        content = recv(socket, String)

        buffers = Vector{UInt8}[]
        while socket.rcvmore
            push!(buffers, recv(socket, Vector{UInt8}))
        end

        if signature != hmac(header, parent_header, metadata, content, kernel)
            error("Invalid HMAC signature") # What should we do here?
        end

        # Note: don't remove these lines, they're useful for creating a
        # precompilation workload.
        # @show idents
        # @show signature
        # @show header
        # @show parent_header
        # @show metadata
        # @show content

        m = Msg(idents, JSONX.parse(header), JSONX.parse(content), JSONX.parse(parent_header), JSONX.parse(metadata), buffers)
        @vprintln("RECEIVED $m")
        return m
    finally
        unlock(kernel.socket_locks[socket])
    end
end

"""
    send_status(state::AbstractString, kernel, parent_msg::Msg=execute_msg)

Publish a status message.
"""
function send_status(state::AbstractString, kernel::Kernel, parent_msg::Msg=kernel.execute_msg)
    send_ipython(kernel.publish[], kernel,
                 Msg([ "status" ], msg_header(parent_msg, "status"),
                     Dict("execution_state" => state), parent_msg.header))
end

# Using IJulia

There are various features of IJulia that allow you to interact with a
running IJulia kernel.


## General


### Detecting that code is running under IJulia

If your code needs to detect whether it is running in an IJulia notebook
(or other Jupyter client), it can check `isdefined(Main, :IJulia) && Main.IJulia.inited`.


### Julia projects

The default Jupyter kernel that is installed by IJulia starts with the
Julia command line flag `--project=@.`. A  `Project.toml` (or `JuliaProject.toml`)
in the folder of a notebook (or in a parent folder of this notebook) will
therefore automatically become the active project for that notebook.
Users that don't want this behavior should install an additional IJulia
kernel without that command line flag (see section
[Installing and customizing kernels](@ref)).

If an existing `Project.toml` file is not found then, by default, an IJulia notebook will try to run a Julia kernel
with its active project set from the global or default environment (usually of the form `~/.julia/environments/v1.x`).
If the IJulia package is not installed in that environment, then the Julia kernel selected by default will not be able to
connect, and a **Connection failed** error will be displayed. In this case, users should install a additional
Julia kernel that uses their chosen Julia environment.
For example, if the desired environment is currently activated in the REPL then one possibility is to execute
```julia
IJulia.installkernel("Julia MyProjectEnv", "--project=$(Base.active_project())")
```
and subsequently select the kernel starting with `Julia MyProjectEnv` from _Kernel > Change Kernel_ in the menu of the Jupyter notebook.

### Customizing your IJulia environment

If you want to run code every time you start IJulia---but only when in IJulia---add a `startup_ijulia.jl` file to your Julia `config` directory, e.g., `~/.julia/config/startup_ijulia.jl`.


### Julia and IPython Magics

One difference from IPython is that the IJulia kernel does
not use "magics", which are special commands prefixed with `%` or
`%%` to execute code in a different language.   Instead, other
syntaxes to accomplish the same goals are more natural in Julia,
work in environments outside of IJulia code cells, and are often
more powerful.

However, if you enter an IPython magic command
in an IJulia code cell, it will print help explaining how to
achieve a similar effect in Julia if possible.
For example, the analogue of IPython's `%load filename` in IJulia
is `IJulia.load("filename")`.


## Input and output

### Prompting for user input

When you are running in a notebook, ordinary I/O functions on `stdin` do
not function.   However, you can prompt for the user to enter a string
in one of two ways:

* `readline()` and `readline(stdin)` both open a `stdin>` prompt widget where the user can enter a string, which is returned by `readline`.

* `IJulia.readprompt(prompt)` displays the prompt string `prompt` and
  returns a string entered by the user.  `IJulia.readprompt(prompt, password=true)` does the same thing but hides the text the user types.


### Clearing output

Analogous to the [IPython.display.clear_output()](http://ipython.org/ipython-doc/dev/api/generated/IPython.display.html#IPython.display.clear_output) function in IPython, IJulia provides a function:

```julia
IJulia.clear_output(wait=false)
```

to clear the output from the current input cell.  If the optional
`wait` argument is `true`, then the front-end waits to clear the
output until a new output is available to replace it (to minimize
flickering).  This is useful to make simple animations, via repeated
calls to `IJulia.clear_output(true)` followed by calls to
`display(...)` to display a new animation frame.


### Input and output history

IJulia will store dictionaries of the user's input and output history
for each session in exported variables called `In` and `Out`. To recall
old inputs and outputs, simply index into them, e.g. `In[1]` or `Out[5]`. Sometimes, a user
may find themselves outputting large matrices or other datastructures which
will be stored in `Out` and hence not garbage collected, possibly hogging memory.
If you find that IJulia is using too much memory after generating large outputs, empty this output dictionary:
```julia
empty!(Out)
```


### Default display size

When Julia displays a large data structure such as a matrix, by default
it truncates the display to a given number of lines and columns.  In IJulia,
this truncation is to 30 lines and 80 columns by default.   You can change
this default by the `LINES` and `COLUMNS` environment variables, respectively,
which can also be changed within IJulia via `ENV` (e.g. `ENV["LINES"] = 60`).
(Like in the REPL, you can also display non-truncated data structures via `print(x)`.)


### Preventing truncation of output

The new default behavior of IJulia is to truncate stdout (via `show` or `println`)
after 512kb. This to prevent browsers from getting bogged down when displaying the
results. This limit can be increased to a custom value, like 1MB, as follows

```julia
IJulia.set_max_stdio(1 << 20)
```


## Execution


### Setting the current module

The module that code in an input cell is evaluated in can be set using `Main.IJulia.set_current_module(::Module)`.
It defaults to `Main`.


### Opting out of soft scope

By default, IJulia evaluates user code using "soft" global scope, via the [SoftGlobalScope.jl package](https://github.com/stevengj/SoftGlobalScope.jl): this means that you don't need explicit `global` declarations to modify global variables in `for` loops and similar, which is convenient for interactive use.

To opt out of this behavior, making notebooks behave similarly to global code in Julia `.jl` files,
you can set `IJulia.SOFTSCOPE[] = false` at runtime, or include the environment variable `IJULIA_SOFTSCOPE=no`
environment of the IJulia kernel when it is launched.

## Python integration

IJulia has an extension for PythonCall.jl that can integrate with ipywidgets and
matplotlib to allow using their interactive widgets. Usage in Julia should be
almost exactly the same as in Python, with the caveat that some libraries may
expect `numpy.ndarray` arguments and not know what to do with
`juliacall.ArrayValue` arguments (see the `mpl-interactions` example). In this
case you should convert the array to an `ndarray` by calling `Py(x).to_numpy()`.

To enable the integrations you should call one of the [Python initializer
functions](../library/public.md#Python-initializers) *after* loading PythonCall
and *before* importing any other Python libraries. Otherwise some hooks may be
set up too late.

### Examples

Ipywidgets:
```julia
using PythonCall
IJulia.init_ipywidgets()
const ipywidgets = pyimport("ipywidgets")

widget = ipywidgets.IntSlider(5)

widget.value
```
![](../assets/ipywidgets.gif)

Matplotlib:
```julia
using PythonCall
IJulia.init_matplotlib()
const plt = pyimport("matplotlib.pyplot")

plt.figure()
plt.imshow(rand(100, 100))
plt.tight_layout()
```
![](../assets/matplotlib.gif)

And a more complex example with
[mpl-interactions](https://mpl-interactions.readthedocs.io/en/stable/):
```julia
using PythonCall
IJulia.init_matplotlib()

const plt = pyimport("matplotlib.pyplot")
const iplt = pyimport("mpl_interactions.ipyplot")

x = collect(range(0, pi, 100))
tau = collect(range(0.5, 10, 100))

f1(x; tau, beta) = @. sin(x * tau) * x * beta
f2(x; tau, beta) = @. sin(x * beta) * x * tau

fig, ax = plt.subplots(figsize=(7, 3.5))
# Note the calls to Py(x).to_numpy() to convert `x` to an ndarray
controls = iplt.plot(Py(x).to_numpy(), f1, tau=tau, beta=(1, 10, 100), label="f1")
iplt.plot(Py(x).to_numpy(), f2, controls=controls, label="f2")
plt.legend()
plt.grid()
plt.tight_layout()
```
![](../assets/mpl-interactions.gif)

# Public API


## General

```@docs
IJulia.IJulia
IJulia.inited
IJulia.installkernel
```


## Launching the server

```@docs
IJulia.jupyterlab
IJulia.notebook
IJulia.nbclassic
IJulia.qtconsole
```


## History

```@docs
IJulia.In
IJulia.Out
IJulia.ans
IJulia.n
IJulia.clear_history
IJulia.history
```


## Cells

```@docs
IJulia.clear_output
IJulia.load
IJulia.load_string
```


## I/O

```@docs
IJulia.readprompt
IJulia.set_max_stdio
IJulia.reset_stdio_count
```

## Cell execution hooks

```@docs
IJulia.push_preexecute_hook
IJulia.pop_preexecute_hook
IJulia.push_postexecute_hook
IJulia.pop_postexecute_hook
IJulia.push_posterror_hook
IJulia.pop_posterror_hook
```

## Python initializers

See the [Python integration](../manual/usage.md#Python-integration) docs for
more details.

```@docs
IJulia.init_matplotlib
IJulia.init_ipywidgets
IJulia.init_ipython
```

# IJulia

**IJulia** is a [Julia-language](http://julialang.org/) backend
combined with the [Jupyter](http://jupyter.org/) interactive
environment (also used by [IPython](http://ipython.org/)).  This
combination allows you to interact with the Julia language using
Jupyter/IPython's powerful [graphical
notebook](http://ipython.org/notebook.html), which combines code,
formatted text, math, and multimedia in a single document.  It
also works with [JupyterLab](https://jupyterlab.readthedocs.io/en/stable/), a Jupyter-based
integrated development environment for notebooks and code.
The [nteract notebook desktop](https://nteract.io/) supports IJulia with
detailed instructions for its [installation with nteract](https://nteract.io/kernels/julia).

(IJulia notebooks can also be re-used in other Julia code via
the [NBInclude](https://github.com/stevengj/NBInclude.jl) package.)

# Running IJulia


## Running the IJulia Notebook

If you are comfortable managing your own Python/Jupyter installation, you can just run `jupyter notebook` yourself in a terminal.   To simplify installation, however, you can alternatively type the following in Julia, at the `julia>` prompt:
```julia
using IJulia
notebook()
```
to launch the IJulia notebook in your browser.

The first time you run `notebook()`, it will prompt you for whether it should
install Jupyter.  Hit enter to have it use the
[Conda.jl](https://github.com/Luthaf/Conda.jl) package to install a minimal
Python+Jupyter distribution (via
[Miniconda](https://www.anaconda.com/docs/getting-started/miniconda/install#quickstart-install-instructions))
that is private to Julia (not in your `PATH`).  On Linux, it defaults to looking
for `jupyter` in your `PATH` first, and only asks to installs the Conda Jupyter
if that fails; you can force `notebook()` to use an existing environment on
Linux by setting `ENV["JUPYTER"] = "/path/to/jupyter"` during the installation of
IJulia (see above).  (In a Debian or Ubuntu GNU/Linux system, install the
package `jupyter-client` to install the system `jupyter`.)

You can
use `notebook(detached=true)` to launch a notebook server
in the background that will persist even when you quit Julia.
This is also useful if you want to keep using the current Julia
session instead of opening a new one.

```julia
using IJulia; notebook(detached=true)
```

By default, the notebook "dashboard" opens in your
home directory (`homedir()`), but you can open the dashboard
in a different directory with `notebook(dir="/some/path")`.

Alternatively, you can run
```
jupyter notebook
```
from the command line (the
[Terminal](https://en.wikipedia.org/wiki/Terminal_%28OS_X%29) program
in MacOS or the [Command
Prompt](https://en.wikipedia.org/wiki/Command_Prompt) in Windows).
Note that if you installed `jupyter` via automated Miniconda installer
in `Pkg.add`, above, then `jupyter` may not be in your `PATH`; type
`import Conda; Conda.SCRIPTDIR` in Julia to find out where Conda
installed `jupyter`.

A "dashboard" window like this should open in your web browser.  Click
on the *New* button and choose the *Julia* option to start a new
"notebook".  A notebook will combine code, computed results, formatted
text, and images, just as in IPython.  You can enter multiline input
cells and execute them with *shift-ENTER*, and the menu items are
mostly self-explanatory.  Refer to [the Jupyter notebook
documentation](https://jupyter-notebook.readthedocs.io/en/stable/) for more
information, and see also the "Help" menu in the notebook itself.

Given an IJulia notebook file, you can execute its code within any
other Julia file (including another notebook) via the [NBInclude](https://github.com/stevengj/NBInclude.jl) package.


## Running the JupyterLab

Instead of running the classic notebook interface, you can use the IDE-like JupyterLab. If you are comfortable managing your own JupyterLab installation, you can just run `jupyter lab` yourself in a terminal.   To simplify installation, however, you can alternatively type the following in Julia, at the `julia>` prompt:

```julia
using IJulia
jupyterlab()
```

Like [`notebook()`](@ref), above, this will install JupyterLab via Conda if it is
not installed already. [`jupyterlab()`](@ref) also supports `detached` and `dir`
keyword options similar to [`notebook()`](@ref).

## Running nbclassic

The notebook interface was significantly overhauled in v7, but the old v6
interface is still available through
[nbclassic](https://nbclassic.readthedocs.io). To start `nbclassic` you can run:

```julia
using IJulia
nbclassic()
```

The behaviour of [`nbclassic()`](@ref) is exactly the same as
[`notebook()`](@ref) and [`jupyterlab()`](@ref).

## Running nteract

The [nteract Desktop](https://nteract.io/) is an application that lets you work with notebooks without a Python installation. First, install IJulia (but do not run `notebook()` unless you want a Python installation) and then nteract.


## Other IPython interfaces

Most people will use the notebook (browser-based) interface, but you
can also use the IPython
[qtconsole](http://ipython.org/ipython-doc/dev/interactive/qtconsole.html)
or IPython terminal interfaces by running `ipython qtconsole --kernel
julia-0.7` or `ipython console --kernel julia-0.7`, respectively.
(Replace `0.7` with whatever major Julia version you are using.)

# Internals


## Initialization

```@docs
IJulia.init
```

## Messaging

```@docs
IJulia.Msg
IJulia.msg_header
IJulia.send_ipython
IJulia.recv_ipython
IJulia.set_cur_msg
IJulia.send_status
```


## Request handlers

```@docs
IJulia.connect_request
IJulia.execute_request
IJulia.shutdown_request
IJulia.interrupt_request
IJulia.inspect_request
IJulia.history_request
IJulia.complete_request
IJulia.kernel_info_request
IJulia.is_complete_request
```


## Event loop

```@docs
IJulia.eventloop
IJulia.waitloop
```


## IO

```@docs
IJulia.IJuliaStdio
IJulia.watch_stream
```


## Multimedia display

```@docs
IJulia.InlineDisplay
IJulia.InlineIOContext
IJulia.ipy_mime
IJulia.ijulia_mime_types
IJulia.ijulia_jsonmime_types
IJulia.limitstringmime
IJulia.israwtext
IJulia.display_dict
IJulia.display_mimejson
IJulia.display_mimestring
IJulia.register_mime
IJulia.register_jsonmime
```


## Jupyter

```@docs
IJulia.find_jupyter_subcommand
IJulia.launch
```


## Debugging

```@docs
IJulia.set_verbose
```


## Utility

```@docs
IJulia.num_utf8_trailing
IJulia.get_token
IJulia.get_previous_token
```

## JSONX

```@docs
IJulia.JSONX.json
IJulia.JSONX.parse
IJulia.JSONX.parsefile
```

# Installation

## Installing IJulia

1. [Go to the Julia Install page.](https://julialang.org/install/)
2. Follow the instructions recommended to install Julia and the `juliaup` tool.
3. Run the Julia application by double-clicking on the icon or running
   `julia` in a terminal. This will open the Julia REPL and a window with
   a `julia>` prompt will appear.
4. At the `julia>` prompt, install IJulia by typing:

   ```julia
   using Pkg
   Pkg.add("IJulia")
   ```

!!! info
    This process installs a
    [kernel specification](https://jupyter-client.readthedocs.io/en/latest/kernels.html#kernelspecs)
    for IJulia. The IJulia kernelspec, shorthand for kernel specification,
    contains the instructions for launching a Julia kernel that a notebook
    frontend (Jupyter, JupyterLab, nteract) can use. The kernelspec does not
    install the notebook frontend.

    IJulia respects the standard
    [`JUPYTER_DATA_DIR`](https://docs.jupyter.org/en/stable/use/jupyter-directories.html#data-files)
    environment variable, so you can set that before installation if you want
    the kernel to be installed in a specific location.

!!! warning
    The command, `Pkg.add("IJulia")`, does not install Jupyter
    Notebook itself.

    You can install Jupyter Notebook by following the Notebook's
    installation instructions if you want. Conveniently, Jupyter
    Notebook can also be installed automatically when you run
    `IJulia.notebook()`. 
    See [Running the Julia notebook](running.md#Running-the-IJulia-Notebook).
    
    You can direct `IJulia.notebook()` to use a specific Jupyter
    installation by setting `ENV["JUPYTER"]` to the path of the
    `jupyter` program executable. This environment variable should
    be set before `Pkg.add` or before running `Pkg.build("IJulia")`,
    and it will remember your preference for subsequent updates.

## Updating Julia and IJulia

Julia is improving rapidly, so it won't be long before you want to
update your packages or Julia to a more recent version.  

### Update packages

To update the packages only and keep the same Julia version, run
at the Julia prompt (or in IJulia):

```julia
Pkg.update()
```

### Update Julia and packages

If you download and install a new version of Julia from the Julia web
site, you will also probably want to update the packages with
`Pkg.update()` (in case newer versions of the packages are required
for the most recent Julia). If you're using juliaup to manage Julia, then for
every Julia *minor release* (1.11, 1.12, etc) you will need to explicitly update
the IJulia installation to tell Jupyter where to find the new Julia version:
```julia
Pkg.build("IJulia")
```

This is because IJulia creates default kernels for every minor version if it
detects that juliaup is used.

If you are not using juliaup to manage Julia, then you *must* update the IJulia
installation every time you install a new Julia binary (or do anything that
*changes the location of Julia* on your computer).


!!! important
    `Pkg.build("IJulia")` **must** be run at the Julia command line.
    It will error and fail if run within IJulia.

## Installing and customizing kernels

You may find it helpful to run multiple Julia kernels to support different Julia
executable versions and/or environment settings.

You can install one or more custom Julia kernels by using the
[`IJulia.installkernel`](@ref) function. For example, if you want to run Julia
with all deprecation warnings disabled, you can create a custom IJulia kernel:

```julia
using IJulia
installkernel("Julia nodeps", "--depwarn=no")
```
and a kernel called `Julia nodeps 0.7` (if you are using Julia 0.7)
will be installed (will show up in your main Jupyter kernel menu) that
lets you open notebooks with this flag. Note that the default kernel
that IJulia installs passes the `--project=@.` option to Julia, if you
want to preserve this behaviour for custom kernels make sure to pass it
explicitly to `IJulia.installkernel`:
```julia
installkernel("Julia nodeps", "--depwarn=no", "--project=@.")
```

You can also install kernels to run Julia with different environment
variables, for example to set
[`JULIA_NUM_THREADS`](https://docs.julialang.org/en/v1/manual/environment-variables/index.html#JULIA_NUM_THREADS-1)
for use with Julia
[multithreading](https://docs.julialang.org/en/v1/manual/parallel-computing/#Multi-Threading-(Experimental)-1):
```julia
using IJulia
installkernel("Julia (4 threads)", env=Dict("JULIA_NUM_THREADS"=>"4"))
```

The `env` keyword should be a `Dict` which maps environment variables to values.

To *prevent* IJulia from installing a default kernel when the package is built,
define the `IJULIA_NODEFAULTKERNEL` environment variable before adding or
building IJulia.

## Low-level IPython Installations

We recommend using IPython 7.15 or later as well as Python 3.

### Using legacy IPython 2.x version

We recognize that some users may need to use legacy IPython 2.x.  You
can do this by checkout out the `ipython2` branch of the IJulia package:

```julia
Pkg.checkout("IJulia", "ipython2")
Pkg.build("IJulia")
```

### Manual installation of IPython

First, you will need to install a few prerequisites:

* You need **version 3.0** or later of IPython, or version 4 or later
  of Jupyter.  Note that IPython 3.0 was released in February 2015, so
  if you have an older operating system you may have to
  [install IPython manually](http://ipython.org/ipython-doc/stable/install/install.html).
  On Mac and Windows systems, it is currently easiest to use the
  [Anaconda Python](http://continuum.io/downloads) installer.

* To use the [IPython notebook](http://ipython.org/notebook.html) interface, which runs in your web
  browser and provides a rich multimedia environment, you will need
  to install the [jsonschema](https://pypi.python.org/pypi/jsonschema), [Jinja2](http://jinja.pocoo.org/docs/), [Tornado](http://www.tornadoweb.org/en/stable/),
  and [pyzmq](https://github.com/zeromq/pyzmq) (requires `apt-get install libzmq-dev` and possibly `pip install --upgrade --force-reinstall pyzmq` on Ubuntu if you are using `pip`) Python packages.
  (Given the [pip](http://www.pip-installer.org/en/latest/) installer, `pip install jsonschema jinja2 tornado pyzmq`
  should normally be sufficient.)  These should have been automatically installed if you installed IPython itself
  [via `easy_install` or `pip`](http://ipython.org/ipython-doc/stable/install/install.html#quickstart).

* To use the [IPython qtconsole](http://ipython.org/ipython-doc/dev/interactive/qtconsole.html) interface,
  you will need to install [PyQt4](http://www.riverbankcomputing.com/software/pyqt/download) or
  [PySide](http://qt-project.org/wiki/Category:LanguageBindings::PySide).

* You need Julia version 0.7 or later.

Once IPython 3.0+ and Julia 0.7+ are installed, you can install IJulia from a Julia console by typing:

```julia
Pkg.add("IJulia")
```

This will download IJulia and a few other prerequisites, and will set up a
Julia kernel for IPython.

If the command above returns an error, you may need to run `Pkg.update()`, then
retry it, or possibly run `Pkg.build("IJulia")` to force a rebuild.

# Troubleshooting

Jupyter notebooks run code by connecting to a
[kernel](https://docs.jupyter.org/en/stable/projects/kernels.html). That's
exactly what the `IJulia` package provides. Jupyter knows about available
kernels through [kernel
specs](https://jupyter-client.readthedocs.io/en/stable/kernels.html#kernel-specs),
which are `kernel.json` files inside [Jupyter's data
paths](https://docs.jupyter.org/en/stable/use/jupyter-directories.html#data-files). You
can list the available kernel specs on the command line with:
```sh
jupyter kernelspec list
```

Or, explore the data directory relevant to your system, e.g.,
`~/.local/share/jupyter/kernels`.

Make sure that you can find a Julia kernel. If you can't, run
[`IJulia.installkernel`](@ref), e.g., as `import IJulia;
IJulia.installkernel("Julia", "--project=@.")` in the Julia REPL.

The `kernel.json` file for the `IJulia` kernel should look something like this:
```json
{
  "display_name": "Julia 1.11.5",
  "argv": [
    "/home/user/.julia/juliaup/julia-1.11.5+0.x64.linux.gnu/bin/julia",
    "-i",
    "--color=yes",
    "--project=@.",
    "-e",
    "import IJulia; IJulia.run_kernel()",
    "{connection_file}"
  ],
  "language": "julia",
  "env": {},
  "interrupt_mode": "signal"
}
```

Note the reference to the `julia` executable in line 4, and the call to
`IJulia.run_kernel()` in line 9. There isn't much magical about kernels. All
that happens when Jupyter starts the kernel based on a specific kernel spec is
that it runs the process given by `argv`. That is, it runs `julia` with the
given command line arguments. It then expects that it can talk to the resulting
process with a specific [messaging
protocol](https://jupyter-client.readthedocs.io/en/latest/messaging.html#messaging). Here,
the code in `run_kernel()` exposes the implementation of that protocol.


## Kernel connection failure tips

Fundamentally, if the `IJulia` kernel fails to connect, it is most likely due to
one of the following two issues:

* The `julia` executable no longer exists (maybe you updated your installed
  Julia versions?).
* The environment that the `julia` executable runs in does not have the `IJulia`
  package installed. This is a common error. In general, the `IJulia` package
  should be installed in the base environment of your Julia installation (what
  you get when you type `] activate` into the REPL without any further options,
  or when you simply start the Julia REPL without any options). Note that the
  `--project=@.` option in the above `kernel.json` looks for a `Project.toml` in
  the current and parent directories before falling back to the base
  environment, so it should generally be safe. If you like to use [shared
  environments](https://pkgdocs.julialang.org/v1/environments/#Shared-environments),
  you may want to have a `--project` flag that references that shared
  environment, and make sure that `IJulia` is installed in that
  environment. Also make sure that the environment is instantiated.

You can edit the `kernel.json` file to fix any issues. Or, delete the entire
folder containing the `kernel.json` file to start from scratch. This is entirely
safe to do, or you could also use `jupyter kernelspec uninstall <name>` from the
command line, see `jupyter kernelspec --help`. After deleting an old kernel,
simply create a new one, using [`IJulia.installkernel`](@ref) from the Julia
REPL.

For further insight into kernel connection issues, look at the error messages
emitted by Jupyter. If you started `jupyter lab` / `jupyter notebook` in the
terminal, messages will be printed there, not in the web interface that you
access via the browser. For more details, you can pass the `--debug` command
line flag to `jupyter`. If you started Jupyter via `IJulia.jupyterlab()` /
`IJulia.notebook()`, you must also pass `verbose=true` to see any of the output
emitted by `jupyter`, including error messages about connection failures;
cf. [Debugging IJulia problems](@ref), below.

## General troubleshooting tips

* If you ran into a problem with the above steps, after fixing the
  problem you can type `Pkg.build()` to try to rerun the install scripts.
* If you tried it a while ago, try running `Pkg.update()` and try again:
  this will fetch the latest versions of the Julia packages in case
  the problem you saw was fixed.  Run `Pkg.build("IJulia")` if your Julia
  version may have changed.  If this doesn't work, you could try just deleting
  the whole `.julia/conda` directory in your home directory (on Windows, it is
  called `Users\USERNAME\.julia\conda` in your home directory) via
  `rm(abspath(first(DEPOT_PATH), "conda"),recursive=true)` in Julia and
  re-adding the packages.
* On MacOS, you currently need MacOS 10.7 or later; [MacOS 10.6 doesn't
  work](https://github.com/JuliaLang/julia/issues/4215) (unless you compile
  Julia yourself, from source code).
* Internet Explorer 8 (the default in Windows 7) or 9 don't work with the
  notebook; use Firefox (6 or later) or Chrome (13 or later).  Internet Explorer
  10 in Windows 8 works (albeit with a few rendering glitches), but Chrome or
  Firefox is better.
* If the notebook opens up, but doesn't respond (the input label is `In[*]`
  indefinitely), try creating a new Python notebook (not Julia) from the `New`
  button in the Jupyter dashboard, to see if `1+1` works in Python.  If it is
  the same problem, then probably you have a [firewall
  running](https://github.com/ipython/ipython/issues/2499) on your machine (this
  is common on Windows) and you need to disable the firewall or at least to
  allow the IP address 127.0.0.1.  (For the
  [Sophos](https://en.wikipedia.org/wiki/Sophos) endpoint security software, go
  to "Configure Anti-Virus and HIPS", select "Authorization" and then
  "Websites", and add 127.0.0.1 to "Authorized websites"; finally, restart your
  computer.) If the Python test works, then IJulia may not be installed in the
  global or default environment and you may need to install a custom Julia
  kernel that uses your required `Project.toml` (see [Julia projects](@ref)).
* Try running `jupyter --version` and make sure that it prints `3.0.0` or
  larger; earlier versions of IPython are no longer supported by IJulia.
* You can try setting `ENV["JUPYTER"]=""; Pkg.build("IJulia")` to force IJulia
  to go back to its own Conda-based Jupyter version (if you previously tried a
  different `jupyter`).


## Debugging IJulia problems

If IJulia is crashing (e.g. it gives you a "kernel appears to have
died" message), you can modify it to print more descriptive error
messages to the terminal by doing:

```julia
ENV["IJULIA_DEBUG"]=true
Pkg.build("IJulia")
```

Restart the notebook and look for the error message when IJulia dies.
(This changes IJulia to default to `verbose = true` mode, and sets
`capture_stderr = false`, hopefully sending a bunch of debugging to
the terminal where you launched `jupyter`).

When you are done, set `ENV["IJULIA_DEBUG"]=false` and re-run
`Pkg.build("IJulia")` to turn off the debugging output.

```@meta
CurrentModule = IJulia
```

# Changelog

This documents notable changes in IJulia.jl. The format is based on [Keep a
Changelog](https://keepachangelog.com).

## [v1.34.3] - 2026-02-13

### Changed
-  Prioritize `~/Library/Application Support/Jupyter` on macOS when the `JUPYTER_PLATFORM_DIRS` environment variable is positively set ([#1242]).


## [v1.34.2] - 2026-02-08

### Changed
- The change to the default Jupyter directory in v1.34.1 was reverted since the
  new directory turned out to not be used by default ([#1240]).

## [v1.34.1] - 2026-01-26

### Changed
- Prioritize `~/Library/Application Support/Jupyter` on macOS for modern Jupyter compatibility ([#1238]).

## [v1.34.0] - 2026-01-18

### Changed
- IJulia now handles exceptions like the REPL: types will be limited by default
  and the `err` variable will be set appropriately for those who want to display
  the full error ([#1237]).

## [v1.33.0] - 2025-11-22

### Added
- Added support for flushing the Python stdio streams in the [PythonCall
  extension](manual/usage.md#Python-integration), now the output from
  `pyprint()` etc will show up immediately in the cell output just like with
  Julia ([#1223]). Note that Julia's stdio is flushed first, so if you have
  interleaved print statements in both Julia and Python then the output may not
  appear in order of execution.
- Added [`nbclassic()`](@ref) to run the classic notebook ([#1228]).

### Fixed
- Previously the Python stacktraces from `PyException`'s were not displayed, now
  they are displayed along with the corresponding Julia stacktrace ([#1224]).
- Significantly improved the reliability of interrupt handling ([#1227]).

### Changed
- Added speculative precompilation of common Jupyter request handlers to improve
  TTFX ([#1220]).
- Moved Revise.jl support into a package extension to improve TTFX and
  implemented a special hook to lazily call `Revise.revise()` ([#1220]). This
  helps improve TTFX from invalidations after loading packages in the common
  case where no files need to be revised.
- Some display methods have been selectively despecialized to improve TTFX, for
  complex types like highly dimensional arrays this is often a ~2x speedup
  ([#1220]).
- IJulia will now remove the Jupyter-specific arguments from `ARGS` ([#1226]).

## [v1.32.1] - 2025-11-05

### Fixed
- Disabled the juliaup binary detection, sadly it was too buggy ([#1214]).

## [v1.32.0] - 2025-11-04

### Added
- *Note: this turned out to be buggy and was disabled in v1.32.1.*

  The most important change in this release is that support for juliaup was
  added. IJulia now checks if juliaup is used during the build step when
  installing the default kernel, and if it is used then it will set the kernel
  command to the equivalent of `julia +major.minor` ([#1201]). This has the
  advantage of not needing to rebuild IJulia to update the kernel after every
  patch release of Julia, but it does mean that IJulia will only create kernels
  for each Julia minor release instead of each patch release.

### Fixed
- Fixed the display of `UnionAll` types such as `Pair.body` ([#1203]).
- Fixed a bug in the [PythonCall extension](manual/usage.md#Python-integration)
  that would break opening comms from the frontend side ([#1206]).
- The [PythonCall extension](manual/usage.md#Python-integration) accidentally
  forced some Python test dependencies to be installed outside of the tests, now
  they have been fully moved into the test suite ([#1209]).
- A long-standing issue with `show()` exceptions being silently discarded was
  fixed ([#1202]).

### Changed
- Replaced JSON.jl with a vendored copy of
  [JSONX](https://github.com/JuliaIO/JSON.jl/tree/master/vendor) ([#1200]). This
  lets us remove one more dependency and remove all of the invalidations caused
  by JSON.jl. Load time is also slightly improved, from ~0.08s to ~0.05s on
  Julia 1.12.
- Switched the default matplotlib backend for [`IJulia.init_matplotlib()`](@ref)
  to the ipympl default, which should be more backwards compatible ([#1206]).
- Extended the precompilation workload to cover more calls, and added a
  workaround to minimize TTFX when Revise is used ([#1210]).
- Previously, running special mode commands like `] st` would not work if the
  cell contained comment lines:
  ```julia
  # Check environment
  ] st
  ```

  Now the comment lines are stripped from special mode commands so the above
  will work ([#1207]). Note that this only applies to *whole comment lines*, the
  inline comments in code like `] st # check environment` will still not be
  stripped.

## [v1.31.1] - 2025-10-20

### Added
- Added support for JSON v1 ([#1197]).

### Fixed
- Fixed support for 32bit systems ([#1196]).

### Changed
- Improved precompilation for the [PythonCall.jl
  extension](manual/usage.md#Python-integration), if `ipywidgets` is installed
  in the Python environment then it will be used to execute a simple workload
  ([#1199]).

## [v1.31.0] - 2025-10-13

### Added
- Implemented a [PythonCall.jl extension](manual/usage.md#Python-integration) to
  support interactive ipywidgets and matplotlib widgets in Julia ([#1190]).
- Added support for buffers in the Jupyter messaging protocol ([#1190]).

## [v1.30.6] - 2025-10-06

### Fixed
- It's now possible to register hooks at any time, even if an IJulia kernel is
  not running ([#1188]). This was accidentally broken in v1.30.

### Changed
- Implemented lazy loading for Conda.jl ([#1187]), which shaves off about 60% of
  the load time (~0.21s to ~0.08s on Julia 1.12).

## [v1.30.5] - 2025-10-03

### Fixed
- Fixed a major performance regression in message hashing from the switch to
  SHA.jl in v1.29.1, which particularly affected things like plot/dataframe
  outputs ([#1185]).

## [v1.30.4] - 2025-09-08

### Fixed
- Fixed usage of [`In`](@ref) and [`Out`](@ref) so that they actually contain
  the cell history instead of just being empty ([#1182]). This was accidentally
  broken in v1.30.0.

## [v1.30.3] - 2025-09-02

### Fixed
- Modified the internal `IJuliaStdio` struct to be deepcopy-able, which was
  inadvertently broken in v1.30.0 ([#1180]).

## [v1.30.2] - 2025-08-29

### Changed
- Implemented lazy loading for Pkg.jl ([#1177]), which significantly cuts down
  the load time (~0.75s to ~0.25s on Julia 1.11). Also made various other
  improvements to precompilation and inference to improve TTFX.

## [v1.30.1] - 2025-08-27

### Fixed
- Added the default value `kernel=_default_kernel` to the function
  [`set_max_stdio`](@ref), which fixes a breaking change introduced in v1.30.0
  ([#1178]).

## [v1.30.0] - 2025-08-24

### Added
- Implemented [`reset_stdio_count()`](@ref) to provide a public API for
  resetting the stdio count ([#1145]).
- A precompilation workload was added to improve TTFX ([#1145], [#1174]).

### Changed
- IJulia was completely refactored to minimize global state ([#1145]). This
  allows for better testing (for the first time we can test kernel execution)
  and for executing precompilation workloads. We've tried to avoid any breaking
  changes but it's possible that some packages may be relying on internals that
  have changed. If you have any problems with this release please [open an issue
  on Github](https://github.com/JuliaLang/IJulia.jl/issues/new) so we can help.
- [`history()`](@ref) now prints each entry on a new line ([#1145]).

## [v1.29.2] - 2025-07-29

### Fixed
- Fixed a typo in the tooltip lookup code ([#1171]).

## [v1.29.1] - 2025-07-26

### Changed
- Improved the token-finding functionality to return more accurate tooltips when
  Shift + Tab is pressed ([#847]).
- IJulia switched from using MbedTLS.jl to the SHA.jl stdlib. This should not
  change anything for users except that now only SHA message digests are
  supported instead of e.g. MD5, and Jupyter uses SHA256 by default ([#1170]).

## [v1.29.0] - 2025-06-13

### Added
- Added an `args` argument to [`notebook()`](@ref) and [`jupyterlab()`](@ref) to
  allow passing custom arguments to the underlying commands ([#1164]).

### Fixed
- Fixed handling of the Jupyter process in [`notebook()`](@ref) and
  [`jupyterlab()`](@ref) when Ctrl + C'ing to shutdown the server, now any
  running kernels will be cleanly shutdown as well ([#1165]).

## [v1.28.1] - 2025-06-02

### Fixed

- Fixed a deadlock in the `shutdown_request` handler that would cause the kernel
  to hang when exiting ([#1163]).

## [v1.28.0] - 2025-06-01

### Added
- [`notebook()`](@ref) and [`jupyterlab()`](@ref) now support a `verbose`
  keyword argument to echo output from Jupyter to the terminal, which can be
  useful when debugging kernels ([#1157]).

### Changed
- IJulia no longer uses a standalone `kernel.jl` file to launch the kernel, it
  instead calls a function inside the IJulia module. This means that kernel
  specs don't use absolute paths anymore and it's not necessary to rebuild
  IJulia after updating the package ([#1158]).
- Colors in stacktraces are now displayed properly in Jupyter ([#1161]).

### Fixed

- The Julia major and minor version are no longer appended to a custom
  `specname` in [`installkernel()`](@ref). The default `specname` that derives
  from `name` and appends the Julia version remains unchanged ([#1154]).
- Fixed adding multiple packages in Pkg mode ([#1160]).
- Fixed an edge-case in inspection requests that would cause autocompletion to
  not work properly ([#1159]).

## [v1.27.0] - 2025-04-01

### Added
- [`installkernel()`](@ref) now supports a `displayname` argument to customize
  the kernel display name ([#1137]).

### Fixed
- The internal heartbeat thread will now shut down cleanly ([#1135],
  [#1144], [#1150]). This should prevent segfaults upon exit.
- Various fixes to the messaging code to be compliant with Jupyter ([#1138],
  [#1150]).
- Improved threadsafety of the IO-handling code so that it should be safe to
  call `flush()` concurrently ([#1149]).
